
(function(global) {
  function now() {
    return new Date();
  }

  if (typeof (window._bokeh_onload_callbacks) === "undefined") {
    window._bokeh_onload_callbacks = [];
  }

  function run_callbacks() {
    window._bokeh_onload_callbacks.forEach(function(callback) { callback() });
    delete window._bokeh_onload_callbacks
    console.info("Bokeh: all callbacks have finished");
  }

  function load_libs(js_urls, callback) {
    window._bokeh_onload_callbacks.push(callback);
    if (window._bokeh_is_loading > 0) {
      console.log("Bokeh: BokehJS is being loaded, scheduling callback at", now());
      return null;
    }
    if (js_urls == null || js_urls.length === 0) {
      run_callbacks();
      return null;
    }
    console.log("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
    window._bokeh_is_loading = js_urls.length;
    for (var i = 0; i < js_urls.length; i++) {
      var url = js_urls[i];
      var s = document.createElement('script');
      s.src = url;
      s.async = false;
      s.onreadystatechange = s.onload = function() {
        window._bokeh_is_loading--;
        if (window._bokeh_is_loading === 0) {
          console.log("Bokeh: all BokehJS libraries loaded");
          run_callbacks()
        }
      };
      s.onerror = function() {
        console.warn("failed to load library " + url);
      };
      console.log("Bokeh: injecting script tag for BokehJS library: ", url);
      document.getElementsByTagName("head")[0].appendChild(s);
    }
  };var element = document.getElementById("3ebf6bac-6e4d-4eaf-996a-097814bdb80f");
  if (element == null) {
    console.log("Bokeh: ERROR: autoload.js configured with elementid '3ebf6bac-6e4d-4eaf-996a-097814bdb80f' but no matching script tag was found. ")
    return false;
  }

  var js_urls = ['https://cdn.pydata.org/bokeh/release/bokeh-0.11.1.min.js', 'https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.11.1.min.js', 'https://cdn.pydata.org/bokeh/release/bokeh-compiler-0.11.1.min.js'];

  var inline_js = [
    function(Bokeh) {
      Bokeh.set_log_level("info");
    },
    
    function(Bokeh) {
      Bokeh.$(function() {
          var docs_json = {"ea2ef7ec-23e1-49f3-9e20-2873371b6cf4":{"roots":{"references":[{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"d0346ae3-ebae-4e01-b3cd-1d298e51aba1","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"0da99527-800a-43f1-8e4d-7dca61dd2709","type":"ColumnDataSource"},"glyph":{"id":"84ac61ca-6ac7-4e00-b0c4-585387eb94fa","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"950f1c1d-8e0e-4ae3-b797-5136ae7c41e7","type":"Line"},"selection_glyph":null},"id":"e2d45f86-c973-4e4b-98c7-48b1f6e4ad3a","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"672c6fdf-3026-4317-ab7b-6b64fd0bcc93","type":"ColumnDataSource"},"glyph":{"id":"659e997e-69d3-4dcd-a240-820ecd7191cc","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"9a514bbf-52b8-4f42-892d-a222c76a5311","type":"Text"},"selection_glyph":null},"id":"91172816-298a-4042-9bd3-9449d670cb49","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[1.0,0.6666666666666666],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#b30000"],"index":[0,1],"line_color":["#b30000","#b30000"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[1.0,0.6666666666666666]}},"id":"eba09c5f-cd1d-408d-addb-75d4fcddce7d","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4344710e-377b-48a8-bb63-9291add0c5e3","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"7d97858c-57f8-4dba-a1e1-6de8a4e169f8","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"18f8b148-0956-402a-b1f6-36af9d0995a4","type":"Text"},{"attributes":{"data_source":{"id":"b453ad00-81ca-4e76-9c7c-02ca7a186a0b","type":"ColumnDataSource"},"glyph":{"id":"12900f8c-da2d-4f41-9e4d-ed00d888c40c","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"7e8860da-b90e-4035-9402-aee3c8c49fec","type":"Text"},"selection_glyph":null},"id":"85e4a6fb-ddff-4668-9fba-cf2f8e9bbedd","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9d4e7457-36c8-4386-b380-fb59da940fa5","type":"Text"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"ticker":{"id":"75840c70-7e0e-4459-affd-c04f7522199f","type":"BasicTicker"}},"id":"8b50c811-f8fd-4d57-a976-0639e7fdfd26","type":"Grid"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"c00cdcf4-2545-481e-9fa4-9b096f01dc30","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"a071b6d4-54c6-4eb8-a9e4-710a57503de3","type":"Quad"},{"attributes":{"data_source":{"id":"1f48676c-33fe-4958-a356-6b3ef557362b","type":"ColumnDataSource"},"glyph":{"id":"070d98b6-d360-4813-9b73-946f9503cb45","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"a046de61-1131-49ea-b4f0-63b80e98d2ab","type":"Circle"},"selection_glyph":null},"id":"7ccdb1d2-a3d6-4e3e-a3cf-385e62831c3c","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"a1ac0e7a-bfa3-4d9d-854c-a98a7854cd3f","type":"ColumnDataSource"},"glyph":{"id":"42df5870-992e-49d4-b176-1c72d85ae587","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"fd7f048f-7abc-40b7-a2f9-5fb2b9cfda42","type":"Line"},"selection_glyph":null},"id":"be3b25ff-ac68-47e6-9cff-ab746ae8eb2c","type":"GlyphRenderer"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5d5e0a7b-eaae-4716-85ea-70c25994a170","type":"Wedge"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e8a23e38-2ab4-4b23-9ae4-59b4f1d7cc0a","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8617f6a0-d866-4dbe-a68c-a571b6acc825","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2b37092b-fdf5-4566-aac3-1cfb50e8f574","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"033bf1eb-1697-4032-9953-2435fe049796","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"d5f00cce-7cfa-4a5a-b665-f31787002c66","type":"ColumnDataSource"},"glyph":{"id":"6f6295b9-a6a6-4f13-b029-230c4aff6d03","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"196c0dd6-df16-4293-9958-02f7af267249","type":"Line"},"selection_glyph":null},"id":"89976ae5-49f2-4930-8535-2b7d81a4ecac","type":"GlyphRenderer"},{"attributes":{"callback":{"id":"c3c283ce-b586-4db8-a89b-2f232343d55e","type":"OpenURL"},"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"}},"id":"13499e97-94c5-4fee-b8c1-7a852f673aea","type":"TapTool"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"ab7c7e23-69ee-466c-bf21-d31ae2192729","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[370.0,8371.0,26041.0,5154.0,11723708.0,4921.0],"Confidence":["5.0","5.0","5.0","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.85,0.55,0.55],"alpha":[0.7142857142857143,0.7142857142857143,0.7142857142857143,0.5,0.5,0.5],"fill_color":["#228B22","#b30000","#b30000","#b30000","#b30000","#b30000"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#b30000","#b30000","#b30000","#b30000","#b30000"],"radius":[0.03571428571428572,0.03571428571428572,0.03571428571428572,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.7878260869565217,0.4935714285714286,0.48666666666666664]}},"id":"4db30553-083d-4818-b51d-28fedb95a488","type":"ColumnDataSource"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c3da7013-97a4-4f9f-8cdd-3ba49f29e551","type":"Wedge"},{"attributes":{"data_source":{"id":"7c0c7512-a78f-4961-86d9-a8d12d1a28c6","type":"ColumnDataSource"},"glyph":{"id":"060327c2-ca8a-47e3-9601-36dca3d5d9b6","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"9fcd7a43-b32b-4ff0-8342-10b63c275c44","type":"Circle"},"selection_glyph":null},"id":"8d65fce3-26ec-4d1e-87d8-6be548787c50","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"91b97118-aa67-403a-b44e-912371f672bc","type":"Line"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"aeea3608-2af7-4456-9a85-976b250bd41b","type":"OpenURL"},{"attributes":{"data_source":{"id":"6db8dfec-1118-483a-85c9-20d7be20c43a","type":"ColumnDataSource"},"glyph":{"id":"86e735fe-b149-4578-821c-7943bf3b7930","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"bc0045ef-79bd-4bc8-a0c8-6c4588901fad","type":"Line"},"selection_glyph":null},"id":"411e3a04-d0c0-4401-bf93-cd4534c7f42e","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"159c1750-1d11-4764-bae9-0938ce6998ae","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"7b5d385a-4721-4d43-a72c-eb52e1801f49","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2e03562e-6deb-49b2-8c92-476af3856683","type":"Text"},{"attributes":{"data_source":{"id":"d911d5a0-e471-44c4-ae35-9f482ee62498","type":"ColumnDataSource"},"glyph":{"id":"9080b7b7-0234-441c-a50c-14202a535d03","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"a8998e79-caf2-4044-9952-1c390770f2c5","type":"Line"},"selection_glyph":null},"id":"e47c3f3c-5396-4d46-835c-10bb150821f8","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"f048037a-1943-49e1-a0c3-c1ed2bd7715c","type":"ColumnDataSource"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"30c00965-39ba-47f4-aff3-488a5650ff5f","type":"Wedge"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2b61ad6c-6b2e-4a69-9c4f-4cdbbf239159","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b76165c8-b9b2-442c-8aba-94258608ae0a","type":"Circle"},{"attributes":{},"id":"c44af89f-1492-424b-a4bd-6a6779453796","type":"ToolEvents"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"e298622d-25ba-4e51-a272-5a11625672e2","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4e987cd5-af07-49aa-af3c-b7c8077387df","type":"Line"},{"attributes":{"data_source":{"id":"6f4635e3-17a8-49c9-add4-1599d0703458","type":"ColumnDataSource"},"glyph":{"id":"25596d9d-e99d-49b7-bdf4-962f541167b2","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"0e314d8b-646a-40be-b7e0-55670dae8209","type":"Text"},"selection_glyph":null},"id":"ab27df8e-54d1-4808-88a1-ea4122dfd73f","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"d5f00cce-7cfa-4a5a-b665-f31787002c66","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0b8af34c-2c81-4a48-82b2-f52e097b0ebb","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5245cddf-97f1-4abd-a68c-656e4841df15","type":"Circle"},{"attributes":{"data_source":{"id":"b0ee3a51-7d2f-490c-aabd-8a4538faf45f","type":"ColumnDataSource"},"glyph":{"id":"0923ce87-f112-47a9-9daa-a44c0dceee0c","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"3028bf36-8c7f-4910-8014-f2fe13b8e567","type":"Line"},"selection_glyph":null},"id":"8c6e4cac-e428-4c7d-a53a-2a9d43b6be95","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"3706a74f-4544-4c1d-b226-e5711f69b09c","type":"ColumnDataSource"},"glyph":{"id":"8f113789-4679-4f8a-9f0c-7e62c442833e","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"4157c3ee-1825-4033-b359-2bb13a923980","type":"Line"},"selection_glyph":null},"id":"c34ca390-2777-46db-b19a-4cd31b864e2c","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"01d9f5f6-409e-482d-a703-892996f89017","type":"ColumnDataSource"},"glyph":{"id":"9ecdb6d5-cb36-4ba0-b776-6555e252c107","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"1442d220-a6af-49d2-b463-479b839bacfa","type":"Line"},"selection_glyph":null},"id":"cdc847f6-0f98-457e-9901-3a0c14c70477","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"60cf7358-f25d-490b-b528-68930c9c9084","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"61cd579f-4d43-44c8-acd3-f4a0e46d733a","type":"Line"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"65fae3f1-c802-4bbf-9a02-7bb48894b105","type":"ColumnDataSource"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"67a46e31-e5bb-472e-a201-7867d1d2fafa","type":"OpenURL"},{"attributes":{"data_source":{"id":"8464cb63-3817-4a4d-b134-1a651f589791","type":"ColumnDataSource"},"glyph":{"id":"2f62ecf0-f99c-437c-9fb6-21a102682fd7","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"8fbde10e-21f6-4873-83a5-f56e18a9dfa6","type":"Line"},"selection_glyph":null},"id":"c3efb726-f1b1-44c6-96e1-4702f03a322b","type":"GlyphRenderer"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"c4fdbb70-e0e2-44c5-b1f3-974694ac13ac","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"7ccdb1d2-a3d6-4e3e-a3cf-385e62831c3c","type":"GlyphRenderer"}]],["Active",[{"id":"7b0603a5-c8b3-4993-937b-7f33b98193bc","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"}},"id":"1b5a40d1-3b64-4a75-99cf-1b41e6c998a5","type":"Legend"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e1e611a0-4610-4baa-a5d4-eeae8cfb99b7","type":"Text"},{"attributes":{"data_source":{"id":"5cdcff5f-e17a-458e-a5e6-1a9214f1ac30","type":"ColumnDataSource"},"glyph":{"id":"36606a36-062b-41c0-ba3b-b25569e85792","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b8426392-493e-4fc7-afe3-d5e362057e59","type":"Text"},"selection_glyph":null},"id":"cf123a53-3757-49b2-83bf-d68ae4d2df81","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"b8b7bdbd-540a-4a1e-a566-c4323d4628a2","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"c4a0db32-8fa3-4d23-82c7-ac0e3a989169","type":"Line"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6f9a3641-4aa1-4e6e-ab85-404b30805324","type":"Text"},{"attributes":{},"id":"75840c70-7e0e-4459-affd-c04f7522199f","type":"BasicTicker"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"19b7e0f7-b556-480d-ad5d-ef8509834714","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"4bcff7d1-dc7e-44dc-8b35-7d1b3618a48d","type":"GlyphRenderer"}]],["Active",[{"id":"66d97b7c-fdfb-4b2c-a544-9bad12d47573","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"}},"id":"bbdf52d6-a939-4d08-ac2b-dcf04c0d62b2","type":"Legend"},{"attributes":{"data_source":{"id":"b3541ccd-0775-4b72-a714-1b0042c582f0","type":"ColumnDataSource"},"glyph":{"id":"63af538a-d4a0-4a3f-b5ed-7bf4bc5e1cc4","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"33f4d9d4-3abe-46b9-8249-5b98a00f81a1","type":"Line"},"selection_glyph":null},"id":"acd4e592-1b08-47ac-a81b-a0108933c664","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c9d53ece-b5e8-4c0f-8d9b-f9d2f089d959","type":"Circle"},{"attributes":{"data_source":{"id":"84440a78-0ba1-4346-9af6-48fed3d102a2","type":"ColumnDataSource"},"glyph":{"id":"01ea75a1-8d37-4736-a323-0e0d3313a33c","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"3edd431f-c698-4f03-addb-dc2424844df0","type":"Text"},"selection_glyph":null},"id":"37800137-edd1-4c55-8129-721807106e84","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"46e8ab0c-bcbd-4229-8ec7-6213852ce9e8","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[3415.0,409069.0,500165.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.56,0.49,0.44],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#228B22"],"index":[6,7,8],"line_color":["#b30000","#b30000","#228B22"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.5555555555555556,0.4901960784313725,0.4375]}},"id":"999feb1a-9da2-47ad-b062-3e8c53bec416","type":"ColumnDataSource"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2d9bfcb5-c6ba-4a75-bc48-75a37a24292b","type":"Wedge"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0614363c-0e61-4a9a-aa66-81e6910ff4f3","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"77fb5270-6bb8-41d9-8c72-e78207c01ccc","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"3cb068c5-9c88-4e0b-97d1-10d0c1b7ed17","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"ea317f6f-4031-499a-8263-d69b5513eb5f","type":"BasicTickFormatter"},"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"ticker":{"id":"cc1733e2-7fce-42af-aa4c-06034b14d8ce","type":"FixedTicker"}},"id":"d348ea90-2b01-43a0-bb0b-71b58f3c98dc","type":"LinearAxis"},{"attributes":{"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"}},"id":"12f1ce8d-97f5-46ab-94aa-aaa2dbd1092f","type":"PreviewSaveTool"},{"attributes":{},"id":"f5025d67-9517-408e-a522-4ba53dccfaf9","type":"BasicTicker"},{"attributes":{},"id":"e296c866-5c11-4bd5-8980-92e632d71c02","type":"BasicTickFormatter"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"683a0cb7-ad5e-4346-ab04-61320fd4f475","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"82c2336a-38c2-4866-8b7b-4407d0ba69e4","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"ef251ae9-1ce0-4aef-85fd-e2904187a269","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[1.0,0.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#228B22"],"index":[0,1],"line_color":["#b30000","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[1.0,0.0]}},"id":"25fd62e5-79cb-4045-83ac-eb5c397d1232","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b098d7be-b23c-4fd8-baac-58f8abe801a1","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"8ae8fa4a-a552-407e-b160-d6db47172c74","type":"Range1d"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e02bbfac-2418-4c37-8000-8ddfa20b396a","type":"Text"},{"attributes":{"data_source":{"id":"e8ea865e-98cb-4218-9b2f-360e8ac3fc82","type":"ColumnDataSource"},"glyph":{"id":"60acdc8b-e434-4a96-b4a2-a5e50a128979","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"29b9881e-764e-4e55-a303-c3b2ffbaf6b0","type":"Line"},"selection_glyph":null},"id":"cf0ca54b-9794-47af-80db-71502a6436e9","type":"GlyphRenderer"},{"attributes":{"callback":null,"start":-1},"id":"cb18188c-4d99-4b56-936e-4faa30c3ee68","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"edc43e91-a45b-4c63-af6e-02896635fff7","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"eb6d46aa-c649-4964-92b9-addd9fd2bcda","type":"ColumnDataSource"},"glyph":{"id":"2ce32b03-1a0b-4ad1-99c6-b2b06e534517","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"744577cf-1a36-4445-9bf3-b0c66995f27c","type":"Circle"},"selection_glyph":null},"id":"eafced8e-ba0a-4dcf-a3d1-1c31fcc43c3f","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"b75c5da4-9e8d-4ce2-b0f4-6690730545a1","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"758f1f5f-339a-4d51-9d85-64fd88ef7465","type":"Text"},{"attributes":{"data_source":{"id":"95346bbd-cd71-4c43-9ee9-7b44306d05f2","type":"ColumnDataSource"},"glyph":{"id":"adacb845-797c-439d-9d0e-350bc457a865","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"5e0265b0-8f14-4c06-a0fb-dac8d148ddca","type":"Line"},"selection_glyph":null},"id":"cc47d604-31e5-4fe6-a7e8-d6ea0dccf157","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d09a6a5a-6f36-497d-89d7-a2f05ec91536","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"29b9881e-764e-4e55-a303-c3b2ffbaf6b0","type":"Line"},{"attributes":{"data_source":{"id":"42272ad1-d6b5-4cd1-bea6-856b50e2c2bd","type":"ColumnDataSource"},"glyph":{"id":"cdb79815-b733-4400-a34b-a439935e3201","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"9f4762f0-4ead-4dbd-b709-2c0f03356c05","type":"Text"},"selection_glyph":null},"id":"fb55c4aa-42d9-4087-ab37-7031818b8866","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"729917d1-8122-40cc-8084-b89d907e9095","type":"Text"},{"attributes":{},"id":"ac6ed80f-b600-4c15-bab0-109326623c1f","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"85f682f8-4d3f-4dd1-9a22-b1d2eec356e0","type":"ColumnDataSource"},"glyph":{"id":"4d03f9ae-4cd4-4adf-b09d-66982bf81759","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"119282da-2059-4118-a6ba-b353ff64db6f","type":"Line"},"selection_glyph":null},"id":"ef2e8033-68e0-419b-871b-404fe1ee130d","type":"GlyphRenderer"},{"attributes":{},"id":"3f15308a-7fe3-4333-81b5-8a2d2f70768d","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"33f4d9d4-3abe-46b9-8249-5b98a00f81a1","type":"Line"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ea3352d5-3159-4e7b-87af-dd38a126d4d3","type":"Circle"},{"attributes":{"data_source":{"id":"f3d926c5-95ee-4c06-871f-e126a47fc90f","type":"ColumnDataSource"},"glyph":{"id":"a836652d-3033-4c00-bf93-3cbb02fdaaf8","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"64ab0654-8ec7-4fbb-8b10-fb9b97ad77d9","type":"Text"},"selection_glyph":null},"id":"e0d0a3c4-38a4-42b8-88f6-812296d2d9f4","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"eb6d46aa-c649-4964-92b9-addd9fd2bcda","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"18c0ccee-d865-4755-bb85-78e3df7102f8","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"8dd999af-c730-4544-810b-2e2d9e9e3a5f","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"ticker":{"id":"0610ff32-5aa9-442f-865f-449864f799dd","type":"BasicTicker"}},"id":"ce3e831a-0f59-4421-ba92-f74e68c89ba9","type":"LinearAxis"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b6d39485-f00a-4ea7-8df9-7dfd71301a7f","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e1c6fc9b-32c1-4a37-92bf-79dc9cc9ce55","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"da5ad670-2ec5-4126-ad9c-62d64131e9b4","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[15910.0,3468.0,4921.0],"Confidence":[4.09,2.0,2.0],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.5842857142857143,0.2857142857142857,0.2857142857142857],"fill_color":["#b30000","#b30000","#b30000"],"index":[3,4,5],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.029214285714285717,0.014285714285714285,0.014285714285714285],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"49a14595-c137-4c94-a76f-f18ae2354a41","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"98663bf1-8112-4f6d-b471-0ddbd0d34c0d","type":"ColumnDataSource"},"glyph":{"id":"60cf7358-f25d-490b-b528-68930c9c9084","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"79844ebc-f737-47c6-b81b-004445a3cb45","type":"Text"},"selection_glyph":null},"id":"74493eec-97ac-450e-bf31-08b89d3632bc","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7174a60e-20dd-4ce0-8e1f-f87372c6b8a6","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"add3783c-0869-4181-b56d-15d31158f341","type":"Line"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fea3346c-2da4-4964-84eb-49e52d363bb8","type":"Line"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"ticker":{"id":"9ee19491-a67e-4dd7-bfb4-9a3a8e894004","type":"BasicTicker"}},"id":"c13feb07-d53c-4fd4-8851-13e5f981fed2","type":"Grid"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"3156f28e-2ef8-444d-88a3-7f0ae1bd2155","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6381fbca-90a3-4080-b782-41267257376b","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"95346bbd-cd71-4c43-9ee9-7b44306d05f2","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"88e63dac-83de-44d9-9621-e7b9410de9d2","type":"ColumnDataSource"},"glyph":{"id":"697c59ea-48b6-4e0d-83de-7c6213517339","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"8ea12d3f-76ca-4de4-ab83-29d300decc7f","type":"Line"},"selection_glyph":null},"id":"a7f30daf-273b-4630-a9e2-b540b38f8661","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"bbbae2fb-9f3a-487f-88aa-d25544809814","type":"BasicTickFormatter"},"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"ticker":{"id":"ff4ae5b9-1e6b-4f8d-9254-3a1694e81ef2","type":"FixedTicker"},"y_range_name":"category"},"id":"40616678-1662-4871-9eda-c9607dd88332","type":"LinearAxis"},{"attributes":{"data_source":{"id":"6f9a9b51-22f5-4b89-bc59-acbeb7415d0b","type":"ColumnDataSource"},"glyph":{"id":"c1620793-7b1a-42cc-b1db-cf8c87c359a7","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b4aac762-9de6-4b95-81d8-2a98ed5220a3","type":"Text"},"selection_glyph":null},"id":"e8dbbbdf-d1c8-4763-bfce-3e532912a0b4","type":"GlyphRenderer"},{"attributes":{"callback":null,"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"renderers":[{"id":"60d5f364-3f41-45bb-b36f-d6db7ada2563","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"da7c60fa-f552-49a3-8375-e3ff5bfb52fe","type":"HoverTool"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b4aac762-9de6-4b95-81d8-2a98ed5220a3","type":"Text"},{"attributes":{"data_source":{"id":"f8e396c7-9f92-4f81-bfa8-ee0034640062","type":"ColumnDataSource"},"glyph":{"id":"0289af7c-2d8f-458c-89e8-a01a42df98f0","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"eeaf2616-9d98-46f2-81ba-5c9d2d7f05f8","type":"Circle"},"selection_glyph":null},"id":"4ff8fa47-79ae-4cea-b651-cafd7e9e21f0","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"9c4a9002-2782-44a6-8fc8-8154ea4b863a","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"487245d3-5bbd-4b8d-8984-729ee20332ed","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7052e491-ff4d-4a1c-84f7-f56a4c174748","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"88730b3e-44ac-40c9-836a-ffd14b29f01d","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"aa589f65-501c-4a6e-b9f1-d98e540eed59","type":"Text"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"8ec60e07-1078-4cf4-a871-4d065b257929","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"7b3e44f9-2c48-4c5f-88bf-998633a2358c","type":"ColumnDataSource"},"glyph":{"id":"ce43bea2-0729-4f53-8618-70b0df627877","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"a29a1a53-b7a2-4481-a635-5434aa83a2ab","type":"Text"},"selection_glyph":null},"id":"666d77d9-00f7-46a2-ac24-b27f63c655f0","type":"GlyphRenderer"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"6f74f652-88d5-402a-8f87-6df7ed7a6136","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"df972afa-89c2-4d1c-a316-d2950ab2fe3d","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"00ef7017-812e-4932-b505-a55232f5647e","type":"ColumnDataSource"},"glyph":{"id":"83c9d5d2-1cfb-4080-a7ee-9327489ab12b","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"f343d8d3-e730-42f9-bd37-312ff0dd27f6","type":"Circle"},"selection_glyph":null},"id":"d1920de6-ede9-4281-a3e0-5625ab3c3834","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3669fb18-c30a-4dc3-861f-0e426b927ea8","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"1f48676c-33fe-4958-a356-6b3ef557362b","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"66bec669-1443-49e5-a129-9ea3dd1d0d7f","type":"Circle"},{"attributes":{"data_source":{"id":"37764de1-a9cf-4c4e-85a3-9332df5ad8d1","type":"ColumnDataSource"},"glyph":{"id":"00ad7dbb-0808-46e3-8de8-7baa1c5ebaa1","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"40570ab3-c54d-4c4b-90d7-5548966e2b9c","type":"Text"},"selection_glyph":null},"id":"691b49b8-323f-4142-9579-5a076c05cce5","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"78e93c2a-f482-4ff4-98ff-48ea504e2a03","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6c2541bf-d8af-480a-bcb5-16012204e079","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"6f9a9b51-22f5-4b89-bc59-acbeb7415d0b","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"29b37b3c-43c2-4683-b608-43eaf5c755a1","type":"ColumnDataSource"},"glyph":{"id":"01edfec9-6522-4dfc-8145-888262898275","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"47a1ff5f-9eca-4b7f-bdd5-5d77be192456","type":"Line"},"selection_glyph":null},"id":"8b7af0e4-7391-45bd-97aa-443b0092e706","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"adba265f-8539-4a2e-a788-3822ca5408f4","type":"Circle"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"58ed87df-2bee-44cb-97d7-b190bffea482","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d60dc498-4ad3-46f9-928a-1e88ee80cda2","type":"Text"},{"attributes":{"data_source":{"id":"daa014aa-b929-4190-8e07-3646690a8721","type":"ColumnDataSource"},"glyph":{"id":"3e780b55-caef-4543-b44b-7b23797417c3","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"c0902d01-d63f-427b-8f23-673f7fa0a669","type":"Line"},"selection_glyph":null},"id":"530fb576-c3e6-4387-ae80-4767c02906f1","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"0697b93d-492a-481b-a1d2-72ff3fe9b287","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"acf33afd-2266-4634-b820-60728684b84e","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bd1ae610-7769-436d-a58f-2a6e663d8586","type":"Text"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"08ecd9ee-cdd4-4d39-9fd4-9cca2bd5a731","type":"Circle"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0c33df92-38a0-49eb-91c5-147a01ab8a40","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"1c4ae4d4-0f94-449c-8759-2963eb28b5cb","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"0b8f0767-e742-4237-8de4-3634da7492a2","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"ef52d890-cc26-462e-ac39-6375bd5e7e26","type":"ColumnDataSource"},"glyph":{"id":"ef817c77-ddd0-4f1f-b19c-ae5e3c5dd55d","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"5245cddf-97f1-4abd-a68c-656e4841df15","type":"Circle"},"selection_glyph":null},"id":"5e7b1486-34da-472f-8c07-af07c7089421","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"652d0b5b-4cdf-477a-8e4f-3cd8d3ebd931","type":"ColumnDataSource"},"glyph":{"id":"0614363c-0e61-4a9a-aa66-81e6910ff4f3","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"6f246ba8-a8f3-46a5-a0df-48b5f966729d","type":"Circle"},"selection_glyph":null},"id":"352c9286-8247-488c-9f36-05efe6d6cb79","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"ce45b578-4121-480a-b4eb-5d53f59d7ae9","type":"ColumnDataSource"},"glyph":{"id":"65d30c96-9214-4adf-97f5-c555b2a79414","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"66bec669-1443-49e5-a129-9ea3dd1d0d7f","type":"Circle"},"selection_glyph":null},"id":"319ca9c6-c3bf-4e47-941c-9858519dd010","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ec16493c-4521-404b-bf34-ee42aedcc823","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"a1ac0e7a-bfa3-4d9d-854c-a98a7854cd3f","type":"ColumnDataSource"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"50e4d2f0-0c78-468c-ae37-23603638b645","type":"Range1d"},{"attributes":{"callback":null,"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"renderers":[{"id":"0563d767-40e8-46a2-9507-e8e9633ccc25","type":"GlyphRenderer"},{"id":"45ab0f31-337d-4991-92fa-79a07744f0b2","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"6239d423-0a03-4f88-ae6a-d042d5779a01","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"c1853d30-7cde-4da6-a804-898a7508da65","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a9e310a4-9b20-402b-ada7-4d19cc8b16d2","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"45a4b9e2-e421-4cb1-9ecb-4c25fbdfab4c","type":"Text"},{"attributes":{},"id":"bfb201a7-058c-4dcd-8cd1-16df7371a08a","type":"ToolEvents"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"27698187-cc7c-4323-a362-9c23fd6f3481","type":"Circle"},{"attributes":{"data_source":{"id":"6faad113-a25a-46f7-8c69-3a4f25fca2ca","type":"ColumnDataSource"},"glyph":{"id":"0c6da62d-010f-43f3-af54-9c1bb325a038","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"30731d34-81d9-4cc8-afa8-158926b9b434","type":"Text"},"selection_glyph":null},"id":"3148c19e-677e-4564-a6de-ecd6a4daf7bd","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"b1383655-d939-48bb-b5f3-05b468f6d13e","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"b49f43a5-f3bc-415a-b980-b1d833e1a3f2","type":"BasicTickFormatter"},"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"ticker":{"id":"4aa81ada-597d-4dc7-9475-20f8c72990fd","type":"FixedTicker"},"y_range_name":"category"},"id":"85e3d85f-bf9d-4ddd-bf56-214e5f69580c","type":"LinearAxis"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"50b0a8e2-40f9-4922-b44d-ba3aede71332","type":"Wedge"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9707d5f4-bf14-43da-be8b-8ccbd110a705","type":"Circle"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9807eabc-121a-49e3-90d3-8072c7473db0","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9f4762f0-4ead-4dbd-b709-2c0f03356c05","type":"Text"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"ticker":{"id":"a2fce2d8-0e2a-4d33-a2aa-4d59a0fb096e","type":"BasicTicker"}},"id":"69d7bb65-e1d8-4787-8f86-5bdb4e9d18d9","type":"Grid"},{"attributes":{"data_source":{"id":"125cb809-fe9e-4fbd-934e-e0196a002de2","type":"ColumnDataSource"},"glyph":{"id":"add3783c-0869-4181-b56d-15d31158f341","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"19848da1-0616-4c05-a77f-3f102d538938","type":"Line"},"selection_glyph":null},"id":"2fff4572-0c80-4f7e-bb4d-80e8813a5e3f","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"e9a1cc4b-38a7-4ca6-a52a-1385a24d13d6","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3edd431f-c698-4f03-addb-dc2424844df0","type":"Text"},{"attributes":{"data_source":{"id":"32bd0c56-d6c3-4809-88db-132f049d4153","type":"ColumnDataSource"},"glyph":{"id":"a8215f1a-ce58-400b-9f2b-9c80f3e53944","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"d97f18dc-aa33-4e0d-86aa-1469d84b5d6b","type":"Circle"},"selection_glyph":null},"id":"4bcff7d1-dc7e-44dc-8b35-7d1b3618a48d","type":"GlyphRenderer"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"6375b6c8-bad1-4824-a932-8e4268901647","type":"Quad"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"24b8e46d-36ad-4e0c-b977-dcfb71055fee","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"be8b5e48-1386-47e1-966e-cfe9feb2be56","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"42df5870-992e-49d4-b176-1c72d85ae587","type":"Line"},{"attributes":{"data_source":{"id":"855b9ac5-d39d-40cc-bb23-d891055dc87e","type":"ColumnDataSource"},"glyph":{"id":"46b31113-de04-40bc-9d77-8d37203bcfd2","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"3fdbb246-46d6-4970-997e-174d2fc137af","type":"Text"},"selection_glyph":null},"id":"087565ec-744e-437f-a81d-f8f01a6b04e2","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"3706a74f-4544-4c1d-b226-e5711f69b09c","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"7c4eedb6-4690-494e-ba8a-5f3843d598c3","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"804c3109-46a1-4ba4-b1ce-b7d29f9503d3","type":"ColumnDataSource"},"glyph":{"id":"54c290b6-5982-4739-aee0-2416065fe812","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"c24aee7b-219f-4c7b-86d0-72884addae8c","type":"Line"},"selection_glyph":null},"id":"7194894e-7efa-40fe-9780-ef4b81bbc104","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9170648a-5992-4dec-b848-e842fe4db18e","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"94e3ab18-0394-4f5e-93a5-9a49c443ca6a","type":"Text"},{"attributes":{"data_source":{"id":"8293c2f4-5455-4706-9203-f62035716d24","type":"ColumnDataSource"},"glyph":{"id":"96ed03c0-7777-41fa-a3c5-6cc9cd94d1d1","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"b3082e22-6745-4638-a36d-4d5766e1539d","type":"Circle"},"selection_glyph":null},"id":"7110b899-f026-42ca-9786-1d81b6e1b175","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"25b0cd6f-a2da-4492-a98f-e50654f24b8d","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,338.0,460.0,4921.0,5513.0,10233356.0],"Confidence":["0.27","0.27","0.27","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.58,0.55,0.54],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.5222784810126582,0.487945205479452,0.48430379746835445]}},"id":"d0a4f03e-6323-435d-8903-ae41880f4bbe","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"32711b5b-3775-4c34-ab6c-d3bb62eb0653","type":"Line"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"dd479892-5c4a-4c5e-8692-9e8bf818db49","type":"Wedge"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e150e91f-b762-48ad-a374-f9e2dece065d","type":"Line"},{"attributes":{"data_source":{"id":"82cd1763-f618-4184-98f1-f62be969e2ae","type":"ColumnDataSource"},"glyph":{"id":"58ed87df-2bee-44cb-97d7-b190bffea482","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"4861e4d4-2812-475b-b505-58fc39f682f3","type":"Text"},"selection_glyph":null},"id":"50d1ccdb-464b-406e-8d07-737a2d768bd9","type":"GlyphRenderer"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c5eee49e-dcc0-4be2-8e69-77300833925b","type":"Wedge"},{"attributes":{"formatter":{"id":"199028c7-f98c-4b5e-a5e9-aea815dec55e","type":"BasicTickFormatter"},"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"ticker":{"id":"d17c3a5d-94e7-413e-aa22-2bda411ac359","type":"FixedTicker"}},"id":"66642c04-6c37-4452-949f-592a78fc183f","type":"LinearAxis"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c8585b67-8e28-44ba-b59d-617651e582eb","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"7663421b-9b96-4973-a07f-d2f93c2b9ad1","type":"Range1d"},{"attributes":{"data_source":{"id":"487245d3-5bbd-4b8d-8984-729ee20332ed","type":"ColumnDataSource"},"glyph":{"id":"b6a7a55a-b4c7-4136-a3a1-602e9ba466a4","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"f32c8ed9-3b39-4796-8b0b-1f68d588c1de","type":"Circle"},"selection_glyph":null},"id":"dcdaee22-b44d-40bd-8e41-1de0d88d26fd","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"09922b4e-48be-4c4b-ad9d-7e49d5d08c88","type":"ColumnDataSource"},"glyph":{"id":"1a3710fc-bb09-4ea0-b103-7612a709341e","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"8617f6a0-d866-4dbe-a68c-a571b6acc825","type":"Circle"},"selection_glyph":null},"id":"89ca11c9-e348-4575-a936-a748fdc9a58d","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"79cc4cc5-9ad7-44db-9cb4-4bdc57861304","type":"Text"},{"attributes":{"callback":null,"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"renderers":[{"id":"960cdbf5-f7c7-47bb-a1f7-45e75265e45a","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"f4ccf78d-4cff-426b-aaae-b7b753aeb31d","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"9a252d68-d76f-4c9a-a528-b6333909be42","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f67f8d7e-43e3-4ef5-a810-8ab2c8b26829","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"e1f4ec85-5f2c-4ae3-8c93-76cf97e5ebca","type":"Line"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"070d98b6-d360-4813-9b73-946f9503cb45","type":"Circle"},{"attributes":{"callback":{"id":"d549b5aa-26a8-4b7b-afbe-87115b72fd2d","type":"OpenURL"},"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"}},"id":"9877848e-2182-486b-8709-e6df80243d2c","type":"TapTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"ddc78803-ed44-4edb-809b-92e4cf50f007","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"1c7f1668-4366-404b-a1c5-a9ef666850bf","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"d0df5610-a166-418b-a39c-201434fca258","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"ticker":{"id":"59623683-7844-476f-bd72-623ade51c6a9","type":"BasicTicker"}},"id":"fbc10aed-9cb1-4438-b3b0-a7ac9dd055ee","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"af9c3bc6-5b8f-4e43-80d0-143e12d2d0ee","type":"ColumnDataSource"},{"attributes":{},"id":"cf912c73-c521-48f5-9c7b-a6bf8f61d13d","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"daec6f3a-f661-4637-8d61-fe69871fd369","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5c506c51-5b4a-4213-87c2-932404db56de","type":"Circle"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b2140d65-a78d-4381-9bab-a7575a11417e","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"79844ebc-f737-47c6-b81b-004445a3cb45","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"49fc0f06-f6e3-42de-a538-b936a674ef6d","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2cafd5ae-e5a9-4847-a5c9-ed6a7f182006","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"6e388cb6-9dec-44e5-9697-6c26db82d751","type":"Range1d"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[4921.0,5513.0,10233356.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.58,0.55,0.54],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000"],"index":[6,7,8],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.5822784810126582,0.547945205479452,0.5443037974683544]}},"id":"56cff4d9-e4e6-4cb0-ae0b-013e470ce6ee","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"b453ad00-81ca-4e76-9c7c-02ca7a186a0b","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8bb807e1-23e9-4713-ba52-db0d30a145e2","type":"Line"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"b675b8cf-ab3c-4fc1-9f40-d2919da44e05","type":"FixedTicker"},{"attributes":{"formatter":{"id":"e296c866-5c11-4bd5-8980-92e632d71c02","type":"BasicTickFormatter"},"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"ticker":{"id":"57e206ae-52f8-47c5-949e-8c2c28e9b23b","type":"FixedTicker"},"y_range_name":"category"},"id":"00ef901b-1f2c-498d-9304-2fb4bcf1c27a","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"400e421d-34c5-4158-979b-a1cfa048ddfd","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"1431aafc-d812-4ba6-8505-8b399f997259","type":"ColumnDataSource"},"glyph":{"id":"8292852c-bd0c-46ad-987b-ad62511cca2b","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"a59547e5-3d04-4ff9-bba1-3a55f829b147","type":"Text"},"selection_glyph":null},"id":"e6d21a2f-7fc9-4f70-8fce-e22ded3591b8","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f1793e88-0e73-44b8-9c1a-91e5539dd831","type":"Circle"},{"attributes":{"data_source":{"id":"44c9a6a8-8ce8-4a85-b39d-527bb136ac2c","type":"ColumnDataSource"},"glyph":{"id":"58859560-e100-4345-b8bd-64bbef7b8117","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"8bb807e1-23e9-4713-ba52-db0d30a145e2","type":"Line"},"selection_glyph":null},"id":"a675c0a8-7cdc-4b3b-beb1-d76ae33de79b","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"71a74448-c788-4bd6-9e6a-2671ae97c1c6","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"36b6455d-45f5-4bbb-ad02-0cd128ea4b05","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[0.6666666666666666,0.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#228B22"],"index":[0,1],"line_color":["#b30000","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[0.6666666666666666,0.0]}},"id":"106dace7-8ab2-45b2-a83d-13728d312c18","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"44f3f01f-9a0a-4309-8d84-87e642cc21ce","type":"Circle"},{"attributes":{"callback":null,"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"renderers":[{"id":"8a92daac-a812-4307-bd9b-cf0c5caab758","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"864eb23c-194f-4b46-8637-ae4e275eeb6c","type":"HoverTool"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"521cf91b-cd61-411c-a6b2-b5fb0b7a417c","type":"Wedge"},{"attributes":{"callback":null,"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"renderers":[{"id":"7bb4c8f3-e299-4739-8e5e-450211d56549","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"bda9a454-197c-46ed-8984-59b37cc770d1","type":"HoverTool"},{"attributes":{"callback":null,"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"renderers":[{"id":"4ff8fa47-79ae-4cea-b651-cafd7e9e21f0","type":"GlyphRenderer"},{"id":"8d65fce3-26ec-4d1e-87d8-6be548787c50","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"e2707715-3cd1-43fd-9663-dc92568e1f81","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"de61e24e-8850-4c4a-b577-a1ef23492989","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d524d59d-12c9-4cc5-85e7-22d39982f145","type":"Circle"},{"attributes":{"formatter":{"id":"69810c9d-3e65-49d5-8b6f-2fc20c0ec324","type":"BasicTickFormatter"},"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"ticker":{"id":"384a7326-7cfd-4330-ac25-abf2e921e0e6","type":"FixedTicker"},"y_range_name":"category"},"id":"144580d5-5e16-4f62-9590-1b82328c6464","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9b8dc605-d97d-4e9e-a473-9370c641a1ce","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"85f682f8-4d3f-4dd1-9a22-b1d2eec356e0","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0289af7c-2d8f-458c-89e8-a01a42df98f0","type":"Circle"},{"attributes":{},"id":"e8d60fee-a216-48e3-8c29-9a90174fc3f2","type":"BasicTickFormatter"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8cce8100-dee2-4ce3-b7ef-ed7f31954152","type":"Text"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"a9afb7a9-c356-4684-9046-d55c44937a6f","type":"OpenURL"},{"attributes":{"callback":{"id":"c7daf622-0955-4f9d-8294-c075e21d8156","type":"OpenURL"},"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"}},"id":"7ade4277-d245-4287-bd6c-efee5ef911d2","type":"TapTool"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b0d54240-48a3-4dcd-bb8e-66e022c91441","type":"Text"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"98663bf1-8112-4f6d-b471-0ddbd0d34c0d","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"1923adb9-a57f-4a94-b2d7-f7c56dee86a0","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3d39ca03-9e42-4a3d-975c-127087f4dfc9","type":"Text"},{"attributes":{"data_source":{"id":"88730b3e-44ac-40c9-836a-ffd14b29f01d","type":"ColumnDataSource"},"glyph":{"id":"6b82416e-fb65-4238-af1d-7a7cf4a8b9e0","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"447a6e27-0db9-4056-96b3-b8deb9d8965b","type":"Line"},"selection_glyph":null},"id":"955632b7-4d52-4e82-a4b6-b97129307286","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6a452e79-27b5-4407-a9a9-4fec01b47519","type":"Text"},{"attributes":{"data_source":{"id":"5e4a6dc1-5951-4c84-962a-cac59ed79afc","type":"ColumnDataSource"},"glyph":{"id":"6c2541bf-d8af-480a-bcb5-16012204e079","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"94e52c99-380f-4875-b5bc-adb94bfa6cd1","type":"Circle"},"selection_glyph":null},"id":"9684efc8-659b-4fb0-a41c-715a885248fd","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"417d6adb-3ecd-4a38-b100-6e4592311fde","type":"Line"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"21cf1015-dce8-4d0f-9f63-3a6838ed145d","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"6b82416e-fb65-4238-af1d-7a7cf4a8b9e0","type":"Line"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a59547e5-3d04-4ff9-bba1-3a55f829b147","type":"Text"},{"attributes":{"data_source":{"id":"077353e9-ffa0-4509-aaa6-d5e9b15944e0","type":"ColumnDataSource"},"glyph":{"id":"be196797-cea1-49e8-8e22-f30e2b1f36c3","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"f20b0c5d-1a04-455c-8850-dea75759ff45","type":"Line"},"selection_glyph":null},"id":"9441da83-3c1a-4960-92a0-c37a3acd9bab","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"7b74f6c6-ffb9-41db-8759-27449a3f64a1","type":"ColumnDataSource"},"glyph":{"id":"e81b5a01-7fb0-495e-a3b7-7f4b5b501bf4","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"ea2bcaf0-e05f-4d7b-b25d-1980c5c9aa7c","type":"Text"},"selection_glyph":null},"id":"702e2339-fca6-494a-95e5-6b3c9b969e01","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"9c1ce333-4016-44bd-8697-4b5b8c3b7585","type":"ColumnDataSource"},"glyph":{"id":"501cb08e-807e-4d9e-b8c7-9b8829b3dcfe","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"4344710e-377b-48a8-bb63-9291add0c5e3","type":"Line"},"selection_glyph":null},"id":"dc4ef9b9-3e35-47a9-a89f-e5e27e52f958","type":"GlyphRenderer"},{"attributes":{},"id":"0b13632e-1fd6-492a-986f-27af063faef0","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"c1853d30-7cde-4da6-a804-898a7508da65","type":"ColumnDataSource"},"glyph":{"id":"e1fc1357-daa1-46ca-baad-9aa2870a37db","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"cb9724e7-2efb-43dd-a358-849179131339","type":"Text"},"selection_glyph":null},"id":"bf184cc1-2cf2-45ea-804c-d7908360e5c0","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"7b74f6c6-ffb9-41db-8759-27449a3f64a1","type":"ColumnDataSource"},{"attributes":{},"id":"dc5878de-dd40-4a99-a8d3-6877010f4b41","type":"ToolEvents"},{"attributes":{},"id":"738101cd-f0c0-4f13-88c4-882cf276d5b0","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"216fe55a-e7e5-4f5f-acc2-f2faae8ac70c","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[3562.0,9128.0,5280378.0,72.0,370.0,1491.0],"Confidence":["1.36","1.36","1.36","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.83,0.77,0.69],"alpha":[0.1942857142857143,0.1942857142857143,0.1942857142857143,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#b30000","#228B22","#228B22","#228B22"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#b30000","#228B22","#228B22","#228B22"],"radius":[0.009714285714285717,0.009714285714285717,0.009714285714285717,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.7733333333333334,0.7092307692307693,0.6323076923076922]}},"id":"c4d0e5c5-9633-4f5a-863e-32620980fc43","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"47a1ff5f-9eca-4b7f-bdd5-5d77be192456","type":"Line"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4861e4d4-2812-475b-b505-58fc39f682f3","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f556e843-ce6a-4856-a95b-508698cf8ef2","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9817ade6-e15c-4188-bba6-9ff7202e682d","type":"Text"},{"attributes":{},"id":"c9eb7435-a5c2-49f4-907e-2eb1c7e40525","type":"BasicTickFormatter"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"63a53e86-0027-44ca-a901-c5561572f397","type":"Text"},{"attributes":{},"id":"84937341-3c8c-469a-b413-f787d8435018","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"26999570-2038-4e2b-842d-7d0b35ccf97d","type":"Circle"},{"attributes":{"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"}},"id":"20da2345-0e34-426a-a7c8-f1fab625093e","type":"PreviewSaveTool"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"90c20c91-aa17-40b0-a506-92ca14f77c26","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"559ac408-f42f-4c31-a6de-0742d6b2436f","type":"Line"},{"attributes":{"formatter":{"id":"3b1b1a9d-e1e7-489a-9416-a3cb5ed1c38f","type":"BasicTickFormatter"},"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"ticker":{"id":"1bbc8a57-2bb7-413d-899b-7bad02f123a9","type":"FixedTicker"},"y_range_name":"category"},"id":"7a819b11-cbb2-4cd8-97c9-eeb9c79dd278","type":"LinearAxis"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8fbde10e-21f6-4873-83a5-f56e18a9dfa6","type":"Line"},{"attributes":{"data_source":{"id":"24b8e46d-36ad-4e0c-b977-dcfb71055fee","type":"ColumnDataSource"},"glyph":{"id":"8342bf83-0c1c-4c26-be51-74f479d9fc78","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"0e7f672d-1901-4b78-acf1-ccb1f6325cf7","type":"Circle"},"selection_glyph":null},"id":"e58e5987-c1b6-4cd0-907f-c3f4b54f2009","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"0c4ada59-c580-44f9-a360-e860f9a0c926","type":"ColumnDataSource"},"glyph":{"id":"20285499-a8f9-4bf2-8b45-6c0ab2745c19","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"8f0534ba-a64c-4f35-8458-4fde107e5e11","type":"Circle"},"selection_glyph":null},"id":"e088fb19-27e3-47b3-bf74-86f10a11ad22","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"050bc564-9aa2-4436-97ca-23212aa0cde6","type":"ColumnDataSource"},"glyph":{"id":"b78bebe6-39e4-4ab2-937b-5536cbe6e11e","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"fea3346c-2da4-4964-84eb-49e52d363bb8","type":"Line"},"selection_glyph":null},"id":"1e5eafa6-131c-4596-9052-967d7f5c61fa","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[0.0,0.3333333333333333],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#228B22","#228B22"],"index":[0,1],"line_color":["#228B22","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[0.0,0.3333333333333333]}},"id":"5ca6267c-fc9a-45f4-b4fb-4722e622e784","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0c3f5903-d2fb-4c6b-aa32-b195a398debd","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"b24d1469-ed35-4833-a65a-b995649f9b63","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"865fdb30-7865-497d-9727-e73d1c49f19e","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"071eb68d-03d0-4b52-8daf-6e4a3a7d5192","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"e45da5db-0912-4f05-990e-ff225d1fac84","type":"ColumnDataSource"},"glyph":{"id":"9170648a-5992-4dec-b848-e842fe4db18e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"6f9a3641-4aa1-4e6e-ab85-404b30805324","type":"Text"},"selection_glyph":null},"id":"d05cd594-1e00-4c4e-ab8a-93987e818091","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"857f732e-4049-4e1e-8592-1a341c42b34d","type":"Circle"},{"attributes":{"data_source":{"id":"3dee331b-7c83-4e93-b247-d0c772f77620","type":"ColumnDataSource"},"glyph":{"id":"5c7c9093-9384-4a2f-a329-3466b222bd55","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"fa656699-fd10-4c99-9f11-6bebebb4741d","type":"Line"},"selection_glyph":null},"id":"0b53257e-b99c-4505-b039-5dfc0ec32cd2","type":"GlyphRenderer"},{"attributes":{"callback":null,"start":-1},"id":"62dc1d1f-f64b-47f0-9286-754988057298","type":"Range1d"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,338.0,460.0],"Confidence":[0.27,0.27,0.27],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576],"fill_color":["#228B22","#228B22","#228B22"],"index":[3,4,5],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"d7f8d488-36d3-4df7-8671-4baeddf6736d","type":"ColumnDataSource"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"88934f4e-a72f-4b29-9d7d-91b333cdfeea","type":"Range1d"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"3dc700fa-9f72-44ce-bffd-ab2a4a0b068b","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"071eb68d-03d0-4b52-8daf-6e4a3a7d5192","type":"ColumnDataSource"},"glyph":{"id":"65bc3bd6-2dc4-4973-85e5-a96a97cd56ff","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"c1b46899-42f1-4f10-96c8-1c7545b12357","type":"Circle"},"selection_glyph":null},"id":"059ae258-11f6-4ce8-b32a-672345040be1","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"53525e32-c818-4f40-8782-a5c792e15980","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"deb79434-ee7f-40b6-9af8-d354121f9499","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"34990a91-dde2-4d29-933b-d0ce3ecc7d7b","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"2da1238a-3a74-4d25-a6b9-590c0599e807","type":"ColumnDataSource"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"2307b872-03cf-41cc-b8ff-3041a9e6053e","type":"FixedTicker"},{"attributes":{"formatter":{"id":"c9eb7435-a5c2-49f4-907e-2eb1c7e40525","type":"BasicTickFormatter"},"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"ticker":{"id":"aa0bf345-f825-4706-869c-12febc491b5e","type":"FixedTicker"}},"id":"a7582e1c-05dc-4740-9a3c-0180c242bce2","type":"LinearAxis"},{"attributes":{"data_source":{"id":"4e544471-fb09-4319-81fc-ceeb81764f6e","type":"ColumnDataSource"},"glyph":{"id":"32711b5b-3775-4c34-ab6c-d3bb62eb0653","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"a9e310a4-9b20-402b-ada7-4d19cc8b16d2","type":"Line"},"selection_glyph":null},"id":"2f4bc48b-51c1-4866-91ab-2fabdeff7b41","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"3f15308a-7fe3-4333-81b5-8a2d2f70768d","type":"BasicTickFormatter"},"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"ticker":{"id":"a362e445-0135-4f3d-b030-1d8d7fac36d1","type":"FixedTicker"},"y_range_name":"category"},"id":"77597ae4-8d14-496b-ae32-4e036b19abce","type":"LinearAxis"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"65cb878a-33f1-41b5-b157-2564fa1b1608","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"1513a437-89e7-4d6c-aa67-ab619cc3a845","type":"GlyphRenderer"}]],["Active",[{"id":"0d075a83-16ba-4f33-b4f4-a1551245e29b","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"}},"id":"2782585e-fe51-4e18-8aa4-84fd04271542","type":"Legend"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d19c5a82-4848-46dd-ab74-a5cbd8328763","type":"Text"},{"attributes":{"data_source":{"id":"b028d6fb-961e-41e1-a064-afe8f67c604f","type":"ColumnDataSource"},"glyph":{"id":"f75fd1f6-5e92-49e7-9ac2-edf4c276099e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"edfb2129-0587-40e6-8f43-99cd2d55939f","type":"Text"},"selection_glyph":null},"id":"eb892402-718a-4aea-8745-5f3817f49d1f","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"52860e3e-e15f-4b0d-bc12-36ab61fe0f9e","type":"ColumnDataSource"},"glyph":{"id":"d75f4ad7-e6a9-499c-bb41-80eb72fb6890","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"5b67abd7-cd66-4b70-9365-c664a2ee1e02","type":"Text"},"selection_glyph":null},"id":"000ecf04-f903-437c-864e-e18e2574883d","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,338.0,460.0],"Confidence":[0.27,0.27,0.27],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576],"fill_color":["#228B22","#228B22","#228B22"],"index":[3,4,5],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"d292d2b9-7b93-47fd-9a9d-e5c2c25c6bbe","type":"ColumnDataSource"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"aa0bf345-f825-4706-869c-12febc491b5e","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"3dee331b-7c83-4e93-b247-d0c772f77620","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"836e201c-fca8-4332-a6dd-0d310eec2287","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"40570ab3-c54d-4c4b-90d7-5548966e2b9c","type":"Text"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"ticker":{"id":"a334b9fb-970f-4492-91c7-6590484c6ccc","type":"BasicTicker"}},"id":"0a4c4f61-c64a-40de-9e1f-ccda1383d0d3","type":"Grid"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"36bb5007-5806-4a73-bf27-9b76d59c8093","type":"Line"},{"attributes":{},"id":"016aafd6-3097-4e35-a73a-b6604b895302","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"900d06d5-82ad-4059-ac48-078c9bc16dc9","type":"ColumnDataSource"},"glyph":{"id":"4dda91dd-6dd2-4fcf-90fe-f20016a8901e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"2e03562e-6deb-49b2-8c92-476af3856683","type":"Text"},"selection_glyph":null},"id":"c9bbca4b-95ef-475e-b42f-cac820d46178","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"a72e70d2-e0e1-461b-bca8-fbac7db623f7","type":"ColumnDataSource"},"glyph":{"id":"9ed0ab30-897c-4d5c-8820-8cf3914a235e","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"d524d59d-12c9-4cc5-85e7-22d39982f145","type":"Circle"},"selection_glyph":null},"id":"0d075a83-16ba-4f33-b4f4-a1551245e29b","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"a07e1568-ee23-4ee9-bebd-1a8ec8cec5a7","type":"ColumnDataSource"},"glyph":{"id":"51fc417a-4769-400a-b488-fe602ff46d1a","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b13343e4-a3de-45c1-8342-c3eab93943b0","type":"Text"},"selection_glyph":null},"id":"696bc72a-253b-4f0c-b732-b310216550d6","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"246c06cf-74cb-4f12-a446-646f20c35a3c","type":"BasicTickFormatter"},"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"ticker":{"id":"b675b8cf-ab3c-4fc1-9f40-d2919da44e05","type":"FixedTicker"}},"id":"23569bad-c288-4ac0-9bb6-e62eb7bf8c8b","type":"LinearAxis"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"57e206ae-52f8-47c5-949e-8c2c28e9b23b","type":"FixedTicker"},{"attributes":{},"id":"b2e8bdae-de82-4a02-8258-06a526f1d357","type":"BasicTicker"},{"attributes":{"data_source":{"id":"fc8557b4-6b19-475a-b179-f8fca4418f43","type":"ColumnDataSource"},"glyph":{"id":"b536176c-bb83-40db-909b-47e8a943ab65","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"18f8b148-0956-402a-b1f6-36af9d0995a4","type":"Text"},"selection_glyph":null},"id":"c99e11bd-5c4c-4379-bdab-5a35099050cb","type":"GlyphRenderer"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"0acaded2-3f47-4295-99c9-e2eb27488c56","type":"Range1d"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"64171ff6-748f-4635-8cdb-2140f131dc62","type":"Text"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"5e52939d-bb2b-4241-9e4f-fde8704c8fa9","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"eafced8e-ba0a-4dcf-a3d1-1c31fcc43c3f","type":"GlyphRenderer"}]],["Active",[{"id":"d50b2b4c-afd9-44bd-9189-314b54088a41","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"}},"id":"4c2bc7cf-8ab7-480b-b391-8555d4659d3d","type":"Legend"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"ticker":{"id":"f5025d67-9517-408e-a522-4ba53dccfaf9","type":"BasicTicker"}},"id":"22e6ed8a-133d-424a-b3a8-3209309e5dbe","type":"Grid"},{"attributes":{"callback":{"id":"67a46e31-e5bb-472e-a201-7867d1d2fafa","type":"OpenURL"},"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"}},"id":"b6e38909-3ae3-4b22-9658-0cd044a41d0f","type":"TapTool"},{"attributes":{"data_source":{"id":"faa15893-c1da-4960-a170-8d7f4c1b23b3","type":"ColumnDataSource"},"glyph":{"id":"d02ab3f5-5ceb-4e55-9b2c-1867a116f6f6","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"b76165c8-b9b2-442c-8aba-94258608ae0a","type":"Circle"},"selection_glyph":null},"id":"0379eb2c-2a18-4cf1-8eda-2a71996b5427","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"9d969833-afba-414a-8e4a-962f550847a6","type":"ColumnDataSource"},"glyph":{"id":"3669fb18-c30a-4dc3-861f-0e426b927ea8","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"f971154c-c46f-43c0-aa0a-1e810bcd2e70","type":"Text"},"selection_glyph":null},"id":"3a8a27fd-efc5-4c0e-9617-7b90e28f39c3","type":"GlyphRenderer"},{"attributes":{"callback":{"id":"9012ded7-5017-4d91-91dc-38a580d44d0d","type":"OpenURL"},"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"}},"id":"afc0af53-a14a-4de8-ba6a-b4a4e090790d","type":"TapTool"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8342bf83-0c1c-4c26-be51-74f479d9fc78","type":"Circle"},{"attributes":{"data_source":{"id":"51947a86-f880-4875-bf13-6693f2104dcb","type":"ColumnDataSource"},"glyph":{"id":"57a10579-b2e0-4ed4-96be-8bdfa0395bc5","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"5f2f24cc-ee5d-42b5-b5e2-f334670fedb0","type":"Text"},"selection_glyph":null},"id":"92c01e6d-dd6f-40ad-83d7-94906c4cc376","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"5c6888c9-de13-47b7-be99-37d0217ff72f","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"882fe3c2-3abc-43f2-9f88-9d90de65b8df","type":"ColumnDataSource"},"glyph":{"id":"836e201c-fca8-4332-a6dd-0d310eec2287","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b6d39485-f00a-4ea7-8df9-7dfd71301a7f","type":"Text"},"selection_glyph":null},"id":"de022fb5-4fe0-4a39-882f-2b11387fedcc","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"950f1c1d-8e0e-4ae3-b797-5136ae7c41e7","type":"Line"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"76835400-f38d-4679-a70d-cbc77831c3d1","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4d071f55-3c33-4255-a9f3-f7e94bd8f62b","type":"Circle"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"92e7e382-77f7-461e-b333-62ae372603d3","type":"Wedge"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"d61b9552-458b-418a-9a6a-5cf89111255d","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"8f113789-4679-4f8a-9f0c-7e62c442833e","type":"Line"},{"attributes":{"formatter":{"id":"a3462bbe-2c3c-4d02-aa38-8eea85a49cb3","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"ticker":{"id":"eb411e86-4f11-4257-ac79-cf51f4e15b19","type":"BasicTicker"}},"id":"206004d5-7b7b-47bb-91e1-b0a5282d3223","type":"LinearAxis"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"0275d23c-7586-4735-a5cd-a4f1cb7668c4","type":"Quad"},{"attributes":{"data_source":{"id":"53d8ba23-ab62-4168-9380-a2c6e20eca53","type":"ColumnDataSource"},"glyph":{"id":"2d5849b2-ba4a-4887-bbbe-b01555bdef15","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"c0c77d29-f29b-4358-ba5d-1645ff9dd89a","type":"Circle"},"selection_glyph":null},"id":"544a0999-1810-4205-970c-80a33ac21467","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6093b64b-f889-4d95-be92-3219f77fbd26","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"9c1ce333-4016-44bd-8697-4b5b8c3b7585","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"18893c5a-2ea4-4879-84dc-69e70efb646b","type":"ColumnDataSource"},{"attributes":{},"id":"be6a72af-c4f0-495f-8e56-694fd38b3c8e","type":"BasicTickFormatter"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"04d12ba0-83df-4bfa-be69-0ced3b33e742","type":"Circle"},{"attributes":{},"id":"3b1b1a9d-e1e7-489a-9416-a3cb5ed1c38f","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"84ac61ca-6ac7-4e00-b0c4-585387eb94fa","type":"Line"},{"attributes":{"data_source":{"id":"fd275d41-844a-4cf7-9193-bb5b815168b2","type":"ColumnDataSource"},"glyph":{"id":"3cc5f8df-4384-473d-a7d3-bbcc3c82f8a2","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"c5eee49e-dcc0-4be2-8e69-77300833925b","type":"Wedge"},"selection_glyph":null},"id":"66a0b292-11ef-47c8-b142-cbf862a14436","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"9c4a9002-2782-44a6-8fc8-8154ea4b863a","type":"ColumnDataSource"},"glyph":{"id":"27698187-cc7c-4323-a362-9c23fd6f3481","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"f25a787a-e76f-42c0-a18c-c32d51af0764","type":"Circle"},"selection_glyph":null},"id":"10107218-0eac-4c9d-8851-6dec30da7423","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"167589a8-2a29-4034-a692-70283582d0bd","type":"Circle"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"ticker":{"id":"d43bf4b7-99ed-44eb-9312-67040b516f9c","type":"BasicTicker"}},"id":"31f8bcdc-1982-4a32-977a-f3a2bf0d703b","type":"Grid"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"41d95171-ac37-4d44-bb5a-2e8889932eaa","type":"Text"},{"attributes":{"data_source":{"id":"53525e32-c818-4f40-8782-a5c792e15980","type":"ColumnDataSource"},"glyph":{"id":"5957f597-8a2a-447f-ae12-bdbe4c2a9a72","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"ce18f6f0-7bd4-4cde-a194-46b2fddf993d","type":"Quad"},"selection_glyph":null},"id":"099c85e3-d695-438f-a9c2-e6d3c06179d1","type":"GlyphRenderer"},{"attributes":{},"id":"8dd999af-c730-4544-810b-2e2d9e9e3a5f","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d6dc12a6-bc96-42ce-ac01-f57de5130a28","type":"Line"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"ticker":{"id":"87c40296-20d8-4feb-b8ca-950faa5d94a0","type":"BasicTicker"}},"id":"5d357adf-e1cf-4946-95ac-1ec5aeb91b29","type":"Grid"},{"attributes":{"data_source":{"id":"edc43e91-a45b-4c63-af6e-02896635fff7","type":"ColumnDataSource"},"glyph":{"id":"0c33df92-38a0-49eb-91c5-147a01ab8a40","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"4ce9e429-764f-42c2-8fe9-4a680ea353d7","type":"Text"},"selection_glyph":null},"id":"19fb93c0-e72e-4c93-97f0-49f307a04896","type":"GlyphRenderer"},{"attributes":{},"id":"71be4598-4cba-4f1c-877c-69c2f9fa77a7","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"00f2eb34-f169-4d49-9cb4-26fb37dbcc53","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c0902d01-d63f-427b-8f23-673f7fa0a669","type":"Line"},{"attributes":{"data_source":{"id":"665c8db3-830b-4a6a-bec8-7a216091ef53","type":"ColumnDataSource"},"glyph":{"id":"ea3352d5-3159-4e7b-87af-dd38a126d4d3","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"65483360-be0a-4c24-919d-b90ebd3fcf47","type":"Circle"},"selection_glyph":null},"id":"7197c06d-6f43-4a9e-8b01-e84ed0bafd89","type":"GlyphRenderer"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"96c6a709-ff92-49de-8e91-5745e44c9679","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"0822103c-c6eb-4552-bb93-a3008e13597d","type":"ColumnDataSource"},{"attributes":{},"id":"eb411e86-4f11-4257-ac79-cf51f4e15b19","type":"BasicTicker"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5877d2aa-fde0-4e34-9de1-89e52d99db3e","type":"Circle"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b674f930-c1a3-405d-bac5-245a13bba3d7","type":"Wedge"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[1.0,0.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#228B22"],"index":[0,1],"line_color":["#b30000","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[1.0,0.0]}},"id":"e8c8c777-aa58-4fbc-b82c-38bdd1d63f3d","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"5d22ff9d-c059-4023-a1b3-105b72c944aa","type":"ColumnDataSource"},"glyph":{"id":"a5e66d7b-ade9-46f8-9b05-d41c28349c4f","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"e2b17dac-2b27-4965-9417-9ebb3dab8fe8","type":"Circle"},"selection_glyph":null},"id":"00ad3084-ef18-42f6-9a14-161fb21f3123","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"6db8dfec-1118-483a-85c9-20d7be20c43a","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"9b17b4b1-b6fa-4b81-b348-e011f1fd99a3","type":"ColumnDataSource"},"glyph":{"id":"0e8e2c84-2c4a-47e4-b771-e45cc91532c2","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"bc75546c-1203-4c27-a1ca-2f7aa14e60de","type":"Text"},"selection_glyph":null},"id":"2341d3e7-648a-4e89-b6a4-3b6730cf69e0","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5f2f24cc-ee5d-42b5-b5e2-f334670fedb0","type":"Text"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"a362e445-0135-4f3d-b030-1d8d7fac36d1","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[7015.0,785.0,3267.0],"Confidence":[1.18,1.09,1.09],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.16857142857142857,0.15571428571428572,0.15571428571428572],"fill_color":["#228B22","#228B22","#b30000"],"index":[3,4,5],"line_color":["#228B22","#228B22","#b30000"],"radius":[0.00842857142857143,0.0077857142857142864,0.0077857142857142864],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"d81f9d01-4d1b-42c2-8c4b-5f1f9b00a3a7","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"4003abc3-4fed-4e2a-9586-bfce34f0839c","type":"Quad"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c1620793-7b1a-42cc-b1db-cf8c87c359a7","type":"Text"},{"attributes":{"data_source":{"id":"ad705037-7ef9-470c-bc9a-7a4ab82dec57","type":"ColumnDataSource"},"glyph":{"id":"4003abc3-4fed-4e2a-9586-bfce34f0839c","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"3d943e21-d9c5-4b47-8d0e-8156246cbb0a","type":"Quad"},"selection_glyph":null},"id":"0a1ebda3-a579-44ca-ac8d-71c74f3748e8","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"24b16bc1-b6f8-4021-a522-a786ec5e7e64","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"744577cf-1a36-4445-9bf3-b0c66995f27c","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"57214c52-d5c4-4745-80b6-bfb4a14f2e3c","type":"Circle"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2ce32b03-1a0b-4ad1-99c6-b2b06e534517","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"3b635ada-16cb-4d3c-b235-943a42b1e997","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"d81f9d01-4d1b-42c2-8c4b-5f1f9b00a3a7","type":"ColumnDataSource"},"glyph":{"id":"e0217762-dea7-4c0d-a20c-2e30860ae3c5","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"05d31481-6067-4b35-9452-17e0554650cc","type":"Circle"},"selection_glyph":null},"id":"dc817c69-178c-4c89-856c-55e3ea8f5709","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"29b37b3c-43c2-4683-b608-43eaf5c755a1","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"816ef2fc-6b0a-4141-8804-b23712d20b47","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6e57c3e5-b0d2-42f2-98aa-bb4f4b611501","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"b0ee3a51-7d2f-490c-aabd-8a4538faf45f","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bb496946-67c0-413c-8519-fcc8833661af","type":"Text"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"96ed03c0-7777-41fa-a3c5-6cc9cd94d1d1","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"9edbb332-7f46-4e24-b2b2-9fac4f5a6717","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"09dde2d0-db1b-456b-8d79-27882c3fab98","type":"Circle"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"31592318-f305-421c-8460-b82086147e43","type":"Range1d"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20285499-a8f9-4bf2-8b45-6c0ab2745c19","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"5c7c9093-9384-4a2f-a329-3466b222bd55","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"48e10b4a-d228-4168-8bc6-c4101a1b716a","type":"ColumnDataSource"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"56126c0e-dc40-4a5c-82e0-7eae81889f3d","type":"FixedTicker"},{"attributes":{"data_source":{"id":"e41b8606-96da-4740-9a59-f739439be73b","type":"ColumnDataSource"},"glyph":{"id":"6a452e79-27b5-4407-a9a9-4fec01b47519","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"729917d1-8122-40cc-8084-b89d907e9095","type":"Text"},"selection_glyph":null},"id":"1c59bd8f-9998-4f07-89a3-97d945fa0db8","type":"GlyphRenderer"},{"attributes":{},"id":"5ddec508-2ae2-4b8e-92f3-2dc5e5a55407","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"e8c1f466-f4d7-44d8-b522-a566996a590d","type":"ColumnDataSource"},{"attributes":{},"id":"b49f43a5-f3bc-415a-b980-b1d833e1a3f2","type":"BasicTickFormatter"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"337c3232-2e0d-4e60-85d4-674e0820755f","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"e41b8606-96da-4740-9a59-f739439be73b","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c6c412a7-b1c5-4692-97e3-07661819eeef","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"9cebfb1b-c908-41f7-9e51-2c994525c0df","type":"Range1d"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"d549b5aa-26a8-4b7b-afbe-87115b72fd2d","type":"OpenURL"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3640f87d-b1f8-485d-81b4-3c8eb05f93aa","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c0c77d29-f29b-4358-ba5d-1645ff9dd89a","type":"Circle"},{"attributes":{"below":[{"id":"e0bb4cd1-9a4a-4f68-9cf8-12f3269a2dcd","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"af178a6f-6f8e-4ee1-a523-c809322900a8","type":"Range1d"}},"left":[{"id":"78509fc0-c406-4972-b6d3-23bc47d15384","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"e0bb4cd1-9a4a-4f68-9cf8-12f3269a2dcd","type":"LinearAxis"},{"id":"c13feb07-d53c-4fd4-8851-13e5f981fed2","type":"Grid"},{"id":"78509fc0-c406-4972-b6d3-23bc47d15384","type":"LinearAxis"},{"id":"9f009327-942c-4970-a3ab-b72b116df6e5","type":"Grid"},{"id":"9557a38e-d17d-4ca2-93d9-3dc2906959ea","type":"Legend"},{"id":"e58e5987-c1b6-4cd0-907f-c3f4b54f2009","type":"GlyphRenderer"},{"id":"319ca9c6-c3bf-4e47-941c-9858519dd010","type":"GlyphRenderer"},{"id":"20c6115d-edc7-46f8-8393-7fe64cdbaf50","type":"GlyphRenderer"},{"id":"c556269f-0d7c-45bc-bee0-7db4489e1867","type":"GlyphRenderer"},{"id":"e14f27d6-5f1e-4c82-b4b3-95b0a1c71384","type":"GlyphRenderer"},{"id":"dc0ad3b7-1fdc-4f18-bc88-22c89f62a27e","type":"GlyphRenderer"},{"id":"a54ea75f-a143-4c98-9dff-4d8ca5e17954","type":"GlyphRenderer"},{"id":"ef2e8033-68e0-419b-871b-404fe1ee130d","type":"GlyphRenderer"},{"id":"35e867d6-e6b8-4c50-b1ed-be3f34230307","type":"GlyphRenderer"},{"id":"000ecf04-f903-437c-864e-e18e2574883d","type":"GlyphRenderer"},{"id":"44641c9b-8219-4eb6-976e-bea2dc4fe74d","type":"GlyphRenderer"},{"id":"d5a2acc4-a9a2-422d-82e7-b6ef0faf7374","type":"GlyphRenderer"},{"id":"cc47d604-31e5-4fe6-a7e8-d6ea0dccf157","type":"GlyphRenderer"},{"id":"96c97535-98fb-42ee-90ad-871ebbfdcefb","type":"GlyphRenderer"},{"id":"924687f8-ff24-4209-8585-f33f57731118","type":"GlyphRenderer"},{"id":"cdc847f6-0f98-457e-9901-3a0c14c70477","type":"GlyphRenderer"},{"id":"1992e56e-1ed5-45da-a2eb-61fa1133485e","type":"GlyphRenderer"},{"id":"666d77d9-00f7-46a2-ac24-b27f63c655f0","type":"GlyphRenderer"},{"id":"481a83e6-0e6c-48da-a65e-ae46c8db9134","type":"GlyphRenderer"},{"id":"e5f50dd2-0674-425d-b102-8e08cbab0330","type":"GlyphRenderer"},{"id":"12562961-57dc-4877-8c4b-402a8d76ef1d","type":"GlyphRenderer"},{"id":"352c9286-8247-488c-9f36-05efe6d6cb79","type":"GlyphRenderer"},{"id":"6024d667-a242-43d5-aae8-372d727e39d9","type":"GlyphRenderer"},{"id":"8a92daac-a812-4307-bd9b-cf0c5caab758","type":"GlyphRenderer"},{"id":"e22ef7ce-ba46-47c1-a95e-5dd318cbcd29","type":"LinearAxis"}],"right":[{"id":"e22ef7ce-ba46-47c1-a95e-5dd318cbcd29","type":"LinearAxis"}],"title":"PubChem CID 2703","tool_events":{"id":"dc5878de-dd40-4a99-a8d3-6877010f4b41","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"12f1ce8d-97f5-46ab-94aa-aaa2dbd1092f","type":"PreviewSaveTool"},{"id":"5dbbb6d8-40f9-40f9-8d3b-7bffed8e2ff8","type":"TapTool"},{"id":"c3179690-7b57-4128-b6a0-7582645082b5","type":"HoverTool"},{"id":"864eb23c-194f-4b46-8637-ae4e275eeb6c","type":"HoverTool"}],"x_range":{"id":"7a732073-4edb-4a67-999c-aa3f90f3ff27","type":"Range1d"},"y_range":{"id":"027496ca-8cde-4128-9946-50242e076b74","type":"Range1d"}},"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e7c6ac85-1da4-4b56-9332-7b3f9dc21a48","type":"Circle"},{"attributes":{"data_source":{"id":"62969570-90bd-4065-ba1b-ba97ce924640","type":"ColumnDataSource"},"glyph":{"id":"3cbc7cc3-729c-4e7c-85ea-efab44c62c9b","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"19b4a2a0-1fa4-44fb-abb8-ab7974f783bb","type":"Circle"},"selection_glyph":null},"id":"20c6115d-edc7-46f8-8393-7fe64cdbaf50","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"0da99527-800a-43f1-8e4d-7dca61dd2709","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"5c6888c9-de13-47b7-be99-37d0217ff72f","type":"ColumnDataSource"},"glyph":{"id":"ab7c7e23-69ee-466c-bf21-d31ae2192729","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"f556e843-ce6a-4856-a95b-508698cf8ef2","type":"Line"},"selection_glyph":null},"id":"54f8b746-8ef3-4407-8453-ebbe0e91a299","type":"GlyphRenderer"},{"attributes":{"callback":null,"start":-1},"id":"a6862581-807f-47a8-b7b4-6896716f461d","type":"Range1d"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6fe776a4-6555-402a-a9ba-44d92709439e","type":"Circle"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"39924fa8-1f5d-4e6d-b447-671e5125d8c6","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2542fe61-4091-4e59-b6da-3ec7a11b3b0e","type":"Text"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"ce18f6f0-7bd4-4cde-a194-46b2fddf993d","type":"Quad"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"c69ebceb-66e6-4b86-9639-62532a50a4a9","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"270541aa-4bed-4dbe-a424-684f7f927f34","type":"Line"},{"attributes":{"data_source":{"id":"9edbb332-7f46-4e24-b2b2-9fac4f5a6717","type":"ColumnDataSource"},"glyph":{"id":"39924fa8-1f5d-4e6d-b447-671e5125d8c6","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"e15dc3c2-2cc3-41be-adf7-518b5e8027a9","type":"Text"},"selection_glyph":null},"id":"f7a163ef-39fa-40ec-a90d-5e398dd2f55c","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"a27409c5-f194-4876-999d-2322d1350553","type":"ColumnDataSource"},"glyph":{"id":"c4a0db32-8fa3-4d23-82c7-ac0e3a989169","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"0ffb55b2-339e-4331-a991-a8250250416d","type":"Line"},"selection_glyph":null},"id":"aff79c17-6de3-4f31-a8a6-cee61fb01c8e","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"b028d6fb-961e-41e1-a064-afe8f67c604f","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"01edfec9-6522-4dfc-8145-888262898275","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"37764de1-a9cf-4c4e-85a3-9332df5ad8d1","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"7b142527-23cd-4bd5-b634-8ec825ce333e","type":"ColumnDataSource"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"ticker":{"id":"71be4598-4cba-4f1c-877c-69c2f9fa77a7","type":"BasicTicker"}},"id":"fc60fad5-49fb-4636-a1d1-ea8c8f1a3218","type":"Grid"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b8426392-493e-4fc7-afe3-d5e362057e59","type":"Text"},{"attributes":{"data_source":{"id":"f91080fa-ce9e-48c9-882c-89fc92e4aae0","type":"ColumnDataSource"},"glyph":{"id":"cdb3d191-af45-4029-8b96-7d57a0596081","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"fbe35c41-9df0-437f-918e-1c2c6693fde6","type":"Circle"},"selection_glyph":null},"id":"12562961-57dc-4877-8c4b-402a8d76ef1d","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8b7ba20b-cb00-466b-8d6a-09cf4a2f4449","type":"Text"},{"attributes":{"data_source":{"id":"36792f09-b23b-4255-9682-60243ea0ea2d","type":"ColumnDataSource"},"glyph":{"id":"47302cf6-8b87-4d01-95b1-841fc361e558","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"e150e91f-b762-48ad-a374-f9e2dece065d","type":"Line"},"selection_glyph":null},"id":"7ec7be4d-6d2c-48dc-9940-1e8974250501","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"697c59ea-48b6-4e0d-83de-7c6213517339","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"659e997e-69d3-4dcd-a240-820ecd7191cc","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"e8ea865e-98cb-4218-9b2f-360e8ac3fc82","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"94e52c99-380f-4875-b5bc-adb94bfa6cd1","type":"Circle"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9ed0ab30-897c-4d5c-8820-8cf3914a235e","type":"Circle"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"84a44748-8b50-47dc-aabf-36f80c87ec99","type":"Circle"},{"attributes":{"data_source":{"id":"7c4eedb6-4690-494e-ba8a-5f3843d598c3","type":"ColumnDataSource"},"glyph":{"id":"61cd579f-4d43-44c8-acd3-f4a0e46d733a","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"559ac408-f42f-4c31-a6de-0742d6b2436f","type":"Line"},"selection_glyph":null},"id":"1992e56e-1ed5-45da-a2eb-61fa1133485e","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"05d31481-6067-4b35-9452-17e0554650cc","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4d6d853b-1b78-41fe-8e73-735a5c846d68","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fd07b0a5-e6a6-497a-b746-74d3575de365","type":"Circle"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a836652d-3033-4c00-bf93-3cbb02fdaaf8","type":"Text"},{"attributes":{"data_source":{"id":"ddc78803-ed44-4edb-809b-92e4cf50f007","type":"ColumnDataSource"},"glyph":{"id":"865fdb30-7865-497d-9727-e73d1c49f19e","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"7f3bbb0d-5a76-4352-baec-82d49a96658a","type":"Line"},"selection_glyph":null},"id":"3ae08c92-1ba6-4392-9826-0a2c3da5e814","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"681e8530-66e1-4f1e-9bd4-731c5c0a634f","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1282bcaf-d8fd-4ad0-8008-6bf55b5087da","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"4d03f9ae-4cd4-4adf-b09d-66982bf81759","type":"Line"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2ada3b43-0f21-4bc0-9fc4-4845a726b3a4","type":"Wedge"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d7cfaf9e-3db4-4ed8-acd5-27248b2da62b","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0e8e2c84-2c4a-47e4-b771-e45cc91532c2","type":"Text"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"f3102822-5e90-4667-bc7e-90cc663878ba","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c24c2685-3be4-4107-80d1-5b089c16af4c","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c0e223fc-8d59-4b1f-a376-a61e932c5d98","type":"Circle"},{"attributes":{"data_source":{"id":"bb911975-57e6-4956-aba1-d7266f404145","type":"ColumnDataSource"},"glyph":{"id":"4be58326-fdc8-4ab9-9673-ff8215d408f6","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"d18635e4-f6b1-4329-94d1-88abe39fe91a","type":"Circle"},"selection_glyph":null},"id":"ced942e4-7be5-4b02-99dc-da9067d1b2e9","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7e8860da-b90e-4035-9402-aee3c8c49fec","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1c4e002f-b2d2-4539-b854-630180d8ef08","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"453a90f3-5052-4bec-b31a-8b76b10473d5","type":"Circle"},{"attributes":{"data_source":{"id":"b8b7bdbd-540a-4a1e-a566-c4323d4628a2","type":"ColumnDataSource"},"glyph":{"id":"66f08f5b-3496-4b67-a250-6ea4cefcd8c0","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"c5cb83cd-36fa-49c1-a6d6-29b19f9fcee5","type":"Text"},"selection_glyph":null},"id":"e14f27d6-5f1e-4c82-b4b3-95b0a1c71384","type":"GlyphRenderer"},{"attributes":{"callback":null,"start":-1},"id":"05d14e5b-bf82-44be-981a-c407e02b5157","type":"Range1d"},{"attributes":{"data_source":{"id":"3520197b-4ae5-461d-bcf7-d8457175da6e","type":"ColumnDataSource"},"glyph":{"id":"aa3db0b8-51ff-4fa7-b555-4dca68e50320","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"72a156cd-ecd0-4094-a17b-a661dbbdb7c3","type":"Text"},"selection_glyph":null},"id":"0e11da23-c116-4033-a06f-56f0123b619f","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d02ab3f5-5ceb-4e55-9b2c-1867a116f6f6","type":"Circle"},{"attributes":{"data_source":{"id":"4080c3f2-04dd-444a-b986-b6c7399c17bd","type":"ColumnDataSource"},"glyph":{"id":"1db7a92c-abaf-4424-aeb9-40afe30d397e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"a1dba711-5bea-4381-919c-07919b901bb7","type":"Text"},"selection_glyph":null},"id":"78cf289e-d801-4b46-aab0-f9d3e2d3aa0d","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"65483360-be0a-4c24-919d-b90ebd3fcf47","type":"Circle"},{"attributes":{"data_source":{"id":"219dbc84-cfb1-4a16-a760-fc3fb5dd9480","type":"ColumnDataSource"},"glyph":{"id":"5cb8495b-8ee4-43a4-b3d8-fc5b1158ea99","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"4d071f55-3c33-4255-a9f3-f7e94bd8f62b","type":"Circle"},"selection_glyph":null},"id":"81364e52-2871-479f-bd8d-6841720891d9","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9d75df10-4138-4b97-8cb5-c98c07c7f083","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a8998e79-caf2-4044-9952-1c390770f2c5","type":"Line"},{"attributes":{"data_source":{"id":"1a7c2fd1-afe9-488d-955e-be3bf49ebd22","type":"ColumnDataSource"},"glyph":{"id":"3d39ca03-9e42-4a3d-975c-127087f4dfc9","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"15ee8333-4a57-4fa9-8bac-f8a2f4a879f2","type":"Text"},"selection_glyph":null},"id":"687115f2-c1e9-4cae-a42a-b7869b702eca","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"2fe87224-2618-4382-903c-5320288beb7c","type":"ColumnDataSource"},"glyph":{"id":"d37485fa-138c-4ee5-912a-5c826130f7c8","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"4e987cd5-af07-49aa-af3c-b7c8077387df","type":"Line"},"selection_glyph":null},"id":"2fe1c9c0-a059-46e7-9936-0a3cb974bc1d","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0e7f672d-1901-4b78-acf1-ccb1f6325cf7","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3b47ce9b-a440-402a-9e19-0fb6baa6e8c6","type":"Line"},{"attributes":{"data_source":{"id":"aee4bc84-4a91-42e4-8ba6-dc8f0c6e162d","type":"ColumnDataSource"},"glyph":{"id":"9707d5f4-bf14-43da-be8b-8ccbd110a705","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"57214c52-d5c4-4745-80b6-bfb4a14f2e3c","type":"Circle"},"selection_glyph":null},"id":"5e52939d-bb2b-4241-9e4f-fde8704c8fa9","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"c87d0239-8caa-4244-9fa3-036fd0ba47ba","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a1dba711-5bea-4381-919c-07919b901bb7","type":"Text"},{"attributes":{"callback":{"id":"933677c7-166f-446a-81c0-849f2c19a172","type":"OpenURL"},"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"}},"id":"e8f46727-6153-4406-99b3-a0aecaeaf6cd","type":"TapTool"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"061ce8e8-7961-4b81-9542-434ca17c7e78","type":"Text"},{"attributes":{"data_source":{"id":"7ffbdc0c-dba8-4842-beaf-e09a97dd3141","type":"ColumnDataSource"},"glyph":{"id":"f4ab1ecd-cf5e-4164-9b27-97922d26ef82","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"7052e491-ff4d-4a1c-84f7-f56a4c174748","type":"Line"},"selection_glyph":null},"id":"d5be11d3-efc7-40f7-b7de-12b8ee8f5a5d","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9fcd7a43-b32b-4ff0-8342-10b63c275c44","type":"Circle"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"09f60e8c-c77f-4d83-88dc-9cc5e37bada0","type":"Range1d"},{"attributes":{"data_source":{"id":"21cf1015-dce8-4d0f-9f63-3a6838ed145d","type":"ColumnDataSource"},"glyph":{"id":"be8b5e48-1386-47e1-966e-cfe9feb2be56","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"d60dc498-4ad3-46f9-928a-1e88ee80cda2","type":"Text"},"selection_glyph":null},"id":"c556269f-0d7c-45bc-bee0-7db4489e1867","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"3246b95c-a0c5-43c1-814d-608d4e87bf1a","type":"Line"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"276094da-9343-4ff6-8cdd-ea05639f22c8","type":"Text"},{"attributes":{"data_source":{"id":"b1383655-d939-48bb-b5f3-05b468f6d13e","type":"ColumnDataSource"},"glyph":{"id":"45a4b9e2-e421-4cb1-9ecb-4c25fbdfab4c","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"704fcaf3-e187-4a0e-a5ba-ead9d5241b6f","type":"Text"},"selection_glyph":null},"id":"b41963f3-6da2-4e3e-ae0d-79971406fab3","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"45488f92-ba4f-4a7b-b51d-4e40b3539603","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"22dec926-18e5-43fe-84bb-79cd932d0fb4","type":"Text"},{"attributes":{"data_source":{"id":"be070e15-886c-46f4-aedb-9b2949e52f99","type":"ColumnDataSource"},"glyph":{"id":"7983de7c-27ff-4e63-8a37-8acd25459a10","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"6381fbca-90a3-4080-b782-41267257376b","type":"Text"},"selection_glyph":null},"id":"f03ab4dc-dd88-43ca-a5d6-9dd482c2e876","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f75fd1f6-5e92-49e7-9ac2-edf4c276099e","type":"Text"},{"attributes":{"below":[{"id":"fbc10aed-9cb1-4438-b3b0-a7ac9dd055ee","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"9cebfb1b-c908-41f7-9e51-2c994525c0df","type":"Range1d"}},"left":[{"id":"269c493b-6227-408a-badb-f2734409ec32","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"fbc10aed-9cb1-4438-b3b0-a7ac9dd055ee","type":"LinearAxis"},{"id":"adc47d88-16e1-441a-b92b-af64296d2dec","type":"Grid"},{"id":"269c493b-6227-408a-badb-f2734409ec32","type":"LinearAxis"},{"id":"22e6ed8a-133d-424a-b3a8-3209309e5dbe","type":"Grid"},{"id":"66e5ecaa-4395-4c3e-9627-fae6c7e90dd0","type":"Legend"},{"id":"5e7b1486-34da-472f-8c07-af07c7089421","type":"GlyphRenderer"},{"id":"e088fb19-27e3-47b3-bf74-86f10a11ad22","type":"GlyphRenderer"},{"id":"52d5d45e-1fca-4390-91b5-bd9a519b562c","type":"GlyphRenderer"},{"id":"e0d0a3c4-38a4-42b8-88f6-812296d2d9f4","type":"GlyphRenderer"},{"id":"ea9c025d-c257-4068-89a0-72e700ecb077","type":"GlyphRenderer"},{"id":"de022fb5-4fe0-4a39-882f-2b11387fedcc","type":"GlyphRenderer"},{"id":"0a1ebda3-a579-44ca-ac8d-71c74f3748e8","type":"GlyphRenderer"},{"id":"3f9a22e5-b18e-4352-b7eb-69c11216b0aa","type":"GlyphRenderer"},{"id":"dc4ef9b9-3e35-47a9-a89f-e5e27e52f958","type":"GlyphRenderer"},{"id":"b41963f3-6da2-4e3e-ae0d-79971406fab3","type":"GlyphRenderer"},{"id":"c8af19e3-c376-43ae-a3e8-e4f4d4496d63","type":"GlyphRenderer"},{"id":"cf0ca54b-9794-47af-80db-71502a6436e9","type":"GlyphRenderer"},{"id":"54f8b746-8ef3-4407-8453-ebbe0e91a299","type":"GlyphRenderer"},{"id":"7b0fbaea-b14e-484e-8382-b6711ced8018","type":"GlyphRenderer"},{"id":"691b49b8-323f-4142-9579-5a076c05cce5","type":"GlyphRenderer"},{"id":"1e5eafa6-131c-4596-9052-967d7f5c61fa","type":"GlyphRenderer"},{"id":"6c5a288b-a2d0-49c9-9703-1373c4317764","type":"GlyphRenderer"},{"id":"0d193e5f-4b55-41d8-92e2-776601bc5b25","type":"GlyphRenderer"},{"id":"b6691a69-4548-4fc3-b47c-db117176ed39","type":"GlyphRenderer"},{"id":"4f8e3439-425d-47ee-b86e-966e68dd9b1e","type":"GlyphRenderer"},{"id":"0563d767-40e8-46a2-9507-e8e9633ccc25","type":"GlyphRenderer"},{"id":"45ab0f31-337d-4991-92fa-79a07744f0b2","type":"GlyphRenderer"},{"id":"d05cd594-1e00-4c4e-ab8a-93987e818091","type":"GlyphRenderer"},{"id":"960cdbf5-f7c7-47bb-a1f7-45e75265e45a","type":"GlyphRenderer"},{"id":"7a819b11-cbb2-4cd8-97c9-eeb9c79dd278","type":"LinearAxis"}],"right":[{"id":"7a819b11-cbb2-4cd8-97c9-eeb9c79dd278","type":"LinearAxis"}],"title":"PubChem CID 3136","tool_events":{"id":"4873df9b-5b5f-428e-923e-dde6b1ca14f5","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"b02bad4c-6415-4721-8ee5-4ceecf3bd1c2","type":"PreviewSaveTool"},{"id":"040320ee-5e16-4a1b-8af0-21dbd0bba412","type":"TapTool"},{"id":"6239d423-0a03-4f88-ae6a-d042d5779a01","type":"HoverTool"},{"id":"f4ccf78d-4cff-426b-aaae-b7b753aeb31d","type":"HoverTool"}],"x_range":{"id":"e87daea9-4f85-4651-a4bb-00b406495fbb","type":"Range1d"},"y_range":{"id":"31592318-f305-421c-8460-b82086147e43","type":"Range1d"}},"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"924d995a-e133-4d6a-a7e6-6ad11f26feb8","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"497ea889-fff5-4b0a-9f32-2259639c353a","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[15910.0,3468.0,4921.0,56638112.0,8570.0,15109.0],"Confidence":["4.09","2.0","2.0","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.69,0.67,0.66],"alpha":[0.5842857142857143,0.2857142857142857,0.2857142857142857,0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000","#b30000","#b30000","#228B22"],"index":[3,4,5,6,7,8],"line_color":["#b30000","#b30000","#b30000","#b30000","#b30000","#228B22"],"radius":[0.029214285714285717,0.014285714285714285,0.014285714285714285,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.6296551724137931,0.6066666666666667,0.5951724137931034]}},"id":"fe943490-6ddc-4873-80c8-fd5ffe5cbd4d","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"03e4a4f6-6512-4a2e-a527-2c94c9b6111d","type":"Text"},{"attributes":{"below":[{"id":"6b868da8-0196-4769-ae56-266ce9b19bb5","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"e41a2d24-5a27-4003-93f9-408ff536d15d","type":"Range1d"}},"left":[{"id":"a7582e1c-05dc-4740-9a3c-0180c242bce2","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"6b868da8-0196-4769-ae56-266ce9b19bb5","type":"LinearAxis"},{"id":"e5c07b5b-2918-4704-934d-8d0bb0284b76","type":"Grid"},{"id":"a7582e1c-05dc-4740-9a3c-0180c242bce2","type":"LinearAxis"},{"id":"e0484dd5-5682-42d7-8738-2b2b8c84bf94","type":"Grid"},{"id":"49b9e056-4ffa-43f5-a0c9-637b1ac1cbd8","type":"Legend"},{"id":"76912a12-5241-4899-9584-a8580e9ae339","type":"GlyphRenderer"},{"id":"c79c3885-b884-48d0-8447-72fb1e03f2f7","type":"GlyphRenderer"},{"id":"60839618-03f0-4cd8-92ae-976a6ecb0069","type":"GlyphRenderer"},{"id":"794fa2c3-c247-484a-859a-b224440a6932","type":"GlyphRenderer"},{"id":"696bc72a-253b-4f0c-b732-b310216550d6","type":"GlyphRenderer"},{"id":"52e4871a-9df7-4ee9-8c8b-3ff70397a77e","type":"GlyphRenderer"},{"id":"4d45b8a0-6d91-4fdb-868b-0c17ed8e12bb","type":"GlyphRenderer"},{"id":"3ae08c92-1ba6-4392-9826-0a2c3da5e814","type":"GlyphRenderer"},{"id":"6120b74b-fc7b-44a9-a7b5-25b064ab37d8","type":"GlyphRenderer"},{"id":"4e00706a-228e-4971-9a04-30745f4c48b5","type":"GlyphRenderer"},{"id":"080f840e-eb95-40b4-a514-2233d51ccb5b","type":"GlyphRenderer"},{"id":"aff79c17-6de3-4f31-a8a6-cee61fb01c8e","type":"GlyphRenderer"},{"id":"411e3a04-d0c0-4401-bf93-cd4534c7f42e","type":"GlyphRenderer"},{"id":"adf6adbd-226e-4861-a4ef-41a0b3c840af","type":"GlyphRenderer"},{"id":"2136b167-775a-40b4-8a1e-27b92b8b83ca","type":"GlyphRenderer"},{"id":"029a745d-2dd4-4064-903e-d4042827252e","type":"GlyphRenderer"},{"id":"c34ca390-2777-46db-b19a-4cd31b864e2c","type":"GlyphRenderer"},{"id":"aa8a1fb5-b004-474b-988e-10aeb0997b21","type":"GlyphRenderer"},{"id":"37800137-edd1-4c55-8129-721807106e84","type":"GlyphRenderer"},{"id":"00ad3084-ef18-42f6-9a14-161fb21f3123","type":"GlyphRenderer"},{"id":"4ff8fa47-79ae-4cea-b651-cafd7e9e21f0","type":"GlyphRenderer"},{"id":"8d65fce3-26ec-4d1e-87d8-6be548787c50","type":"GlyphRenderer"},{"id":"6ceb2163-ffb3-4d6d-bd53-d4a7b37a0dee","type":"GlyphRenderer"},{"id":"66a0b292-11ef-47c8-b142-cbf862a14436","type":"GlyphRenderer"},{"id":"77597ae4-8d14-496b-ae32-4e036b19abce","type":"LinearAxis"}],"right":[{"id":"77597ae4-8d14-496b-ae32-4e036b19abce","type":"LinearAxis"}],"title":"PubChem CID 3136","tool_events":{"id":"bfb201a7-058c-4dcd-8cd1-16df7371a08a","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"9a111abf-d9bb-46c7-8666-08ad84e67709","type":"PreviewSaveTool"},{"id":"afc0af53-a14a-4de8-ba6a-b4a4e090790d","type":"TapTool"},{"id":"e2707715-3cd1-43fd-9663-dc92568e1f81","type":"HoverTool"},{"id":"c91d26e1-641f-4b5f-9362-47f83dcf86e5","type":"HoverTool"}],"x_range":{"id":"cb18188c-4d99-4b56-936e-4faa30c3ee68","type":"Range1d"},"y_range":{"id":"b1cae29d-8cb8-4496-8eb3-7a05064363ca","type":"Range1d"}},"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"766f0168-e205-4a30-9dc4-761aee229ac9","type":"Line"},{"attributes":{},"id":"d0df5610-a166-418b-a39c-201434fca258","type":"BasicTickFormatter"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fdd4af7e-4f72-4993-b6a5-0e7da05c2b36","type":"Text"},{"attributes":{"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"}},"id":"a536caa5-cb65-40e1-8fef-c5da4f1522b0","type":"PreviewSaveTool"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e12f0767-9f01-4275-925a-3bf162219c09","type":"Circle"},{"attributes":{"data_source":{"id":"1c4ae4d4-0f94-449c-8759-2963eb28b5cb","type":"ColumnDataSource"},"glyph":{"id":"f6def0a7-bd37-4f2c-9cdc-4fdff365637d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"07bb7f39-a54b-4c12-b537-94890f12bf37","type":"Text"},"selection_glyph":null},"id":"e0411573-7744-4c1a-833c-a6aea3c8a79f","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ba8ad0fe-bb82-4d25-8f7b-de54f264f712","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fd7f048f-7abc-40b7-a2f9-5fb2b9cfda42","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9d95799b-c796-4ed5-9f33-aaaa25292a8f","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,338.0,460.0,72.0,13622.0,12127.0],"Confidence":["0.27","0.27","0.27","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.87,0.83,0.83],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22","#228B22","#b30000","#228B22"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#228B22","#228B22","#b30000","#228B22"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.8095652173913044,0.7733333333333334,0.7660869565217392]}},"id":"4080c3f2-04dd-444a-b986-b6c7399c17bd","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"2da1238a-3a74-4d25-a6b9-590c0599e807","type":"ColumnDataSource"},"glyph":{"id":"9b35586d-0824-4ea3-a55a-afa282bb5c5f","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"3dff6048-f84e-4fa5-8c04-32a446ec509d","type":"Text"},"selection_glyph":null},"id":"4e00706a-228e-4971-9a04-30745f4c48b5","type":"GlyphRenderer"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"9012ded7-5017-4d91-91dc-38a580d44d0d","type":"OpenURL"},{"attributes":{"data_source":{"id":"8e83dcd9-0b41-4b34-89d9-e1c54702e499","type":"ColumnDataSource"},"glyph":{"id":"e515a6cc-6ae1-4e79-94c0-f1a4923cbc62","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"2542fe61-4091-4e59-b6da-3ec7a11b3b0e","type":"Text"},"selection_glyph":null},"id":"ae8cc5c9-716d-446e-bbf4-34514bdbaf0d","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"8e83dcd9-0b41-4b34-89d9-e1c54702e499","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"08d076d1-ef6c-4c93-a58c-40fa0ac1cf74","type":"ColumnDataSource"},"glyph":{"id":"d0d1a22c-fa09-4c0d-a17e-8c3b4ee41031","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"9269f95d-e3e6-4c7b-9e7f-36836a9d8775","type":"Text"},"selection_glyph":null},"id":"52e4871a-9df7-4ee9-8c8b-3ff70397a77e","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"84937341-3c8c-469a-b413-f787d8435018","type":"BasicTickFormatter"},"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"ticker":{"id":"a61734b0-f743-4422-a10d-c14267ae99bc","type":"FixedTicker"}},"id":"e9dc2665-b412-488f-870b-e96e1fda9014","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"8644e60f-e9b6-4923-9a56-669a6eb62061","type":"ColumnDataSource"},{"attributes":{"below":[{"id":"835ced68-b808-4204-bbcf-e5afaf5e29e3","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"4a0a47a9-4287-4482-975f-2f7cdd0b360c","type":"Range1d"}},"left":[{"id":"2a51f87c-5cc0-48b1-be94-8261e69e4ea5","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"835ced68-b808-4204-bbcf-e5afaf5e29e3","type":"LinearAxis"},{"id":"0a4c4f61-c64a-40de-9e1f-ccda1383d0d3","type":"Grid"},{"id":"2a51f87c-5cc0-48b1-be94-8261e69e4ea5","type":"LinearAxis"},{"id":"48f8608a-294e-492b-b03a-330e20a909f6","type":"Grid"},{"id":"4c2bc7cf-8ab7-480b-b391-8555d4659d3d","type":"Legend"},{"id":"5e52939d-bb2b-4241-9e4f-fde8704c8fa9","type":"GlyphRenderer"},{"id":"eafced8e-ba0a-4dcf-a3d1-1c31fcc43c3f","type":"GlyphRenderer"},{"id":"d50b2b4c-afd9-44bd-9189-314b54088a41","type":"GlyphRenderer"},{"id":"672b506a-92b2-44ab-a1a9-de91e188b4ae","type":"GlyphRenderer"},{"id":"05d9524c-903e-40f4-a811-a6020cf10b7d","type":"GlyphRenderer"},{"id":"087565ec-744e-437f-a81d-f8f01a6b04e2","type":"GlyphRenderer"},{"id":"85881a87-7732-42ca-8423-0602d3665b1a","type":"GlyphRenderer"},{"id":"e7c34c4d-eefa-40ce-aaed-dca7e0c1fdd4","type":"GlyphRenderer"},{"id":"2fe1c9c0-a059-46e7-9936-0a3cb974bc1d","type":"GlyphRenderer"},{"id":"c99e11bd-5c4c-4379-bdab-5a35099050cb","type":"GlyphRenderer"},{"id":"f456e206-c618-4801-aedf-d58b3de71dd4","type":"GlyphRenderer"},{"id":"e47c3f3c-5396-4d46-835c-10bb150821f8","type":"GlyphRenderer"},{"id":"384be773-57f2-4bf4-a7cc-1d0762be7373","type":"GlyphRenderer"},{"id":"b9cb2128-5865-4f11-8452-c586a964de04","type":"GlyphRenderer"},{"id":"9920c709-ddc5-4354-aaef-13fdd47d2a5b","type":"GlyphRenderer"},{"id":"26edec7e-2be2-4a0f-9226-b105badd7e0e","type":"GlyphRenderer"},{"id":"57de1767-cf11-4648-88a3-52d715245533","type":"GlyphRenderer"},{"id":"b1c9201e-261e-4d2d-a87f-f351791bb043","type":"GlyphRenderer"},{"id":"a7787ce8-5a7e-4b5e-9e5b-5acf2524d7e9","type":"GlyphRenderer"},{"id":"252e3f99-327e-428c-9d62-39b54e09261d","type":"GlyphRenderer"},{"id":"293c0239-6489-4b71-b539-85b08893248b","type":"GlyphRenderer"},{"id":"7197c06d-6f43-4a9e-8b01-e84ed0bafd89","type":"GlyphRenderer"},{"id":"3148c19e-677e-4564-a6de-ecd6a4daf7bd","type":"GlyphRenderer"},{"id":"60d5f364-3f41-45bb-b36f-d6db7ada2563","type":"GlyphRenderer"},{"id":"40616678-1662-4871-9eda-c9607dd88332","type":"LinearAxis"}],"right":[{"id":"40616678-1662-4871-9eda-c9607dd88332","type":"LinearAxis"}],"title":"PubChem CID 3614","tool_events":{"id":"a13d3c97-1e7a-429d-90aa-a0edde20233e","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"c5e0b3bb-34e8-4ff6-a2d7-894e5a903d40","type":"PreviewSaveTool"},{"id":"e8f46727-6153-4406-99b3-a0aecaeaf6cd","type":"TapTool"},{"id":"1b1f787f-8076-4008-8f4a-e56d9c9f0fe2","type":"HoverTool"},{"id":"da7c60fa-f552-49a3-8375-e3ff5bfb52fe","type":"HoverTool"}],"x_range":{"id":"62dc1d1f-f64b-47f0-9286-754988057298","type":"Range1d"},"y_range":{"id":"4fbedb7b-b867-4a43-9bf1-3d522231e31f","type":"Range1d"}},"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"90bcc13a-ab62-4394-9b72-aa4ab1991735","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"6f6295b9-a6a6-4f13-b029-230c4aff6d03","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"ab5689bd-9a1a-4c4f-bbed-37dd3e066b68","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"84440a78-0ba1-4346-9af6-48fed3d102a2","type":"ColumnDataSource"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"ticker":{"id":"e7cffe65-1ad0-4ccd-b7b3-4149dbac4aaf","type":"BasicTicker"}},"id":"9f009327-942c-4970-a3ab-b72b116df6e5","type":"Grid"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"172d4829-5beb-4331-a322-6aa70253d36e","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"8644e60f-e9b6-4923-9a56-669a6eb62061","type":"ColumnDataSource"},"glyph":{"id":"266cddc4-8dfe-4b83-b73b-edfded212719","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"dbc36d21-3a92-4db6-affc-c17a0564f4c4","type":"Line"},"selection_glyph":null},"id":"e7c34c4d-eefa-40ce-aaed-dca7e0c1fdd4","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"38918166-bd7c-4a6a-b9f9-ae1ef5cf9653","type":"Text"},{"attributes":{"data_source":{"id":"4b769f47-8c40-443d-bca9-6ae0d7223bd8","type":"ColumnDataSource"},"glyph":{"id":"3fc6ba07-30ad-455d-af53-09fe1724c7a8","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"18bf1816-07f1-43b9-a99e-84e0b45efee8","type":"Circle"},"selection_glyph":null},"id":"4f8e3439-425d-47ee-b86e-966e68dd9b1e","type":"GlyphRenderer"},{"attributes":{},"id":"a13d3c97-1e7a-429d-90aa-a0edde20233e","type":"ToolEvents"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b6a7a55a-b4c7-4136-a3a1-602e9ba466a4","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[5154.0,11723708.0,4921.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.85,0.55,0.55],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000"],"index":[6,7,8],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.8478260869565217,0.5535714285714286,0.5466666666666666]}},"id":"652d0b5b-4cdf-477a-8e4f-3cd8d3ebd931","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"8b5ad13d-35a9-4fc5-bd99-afa990dff24f","type":"ColumnDataSource"},"glyph":{"id":"1e2af17c-7965-455e-a796-f7d6c508e346","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"1f613211-6c9f-4b82-87ba-9b866e8e1256","type":"Line"},"selection_glyph":null},"id":"35e867d6-e6b8-4c50-b1ed-be3f34230307","type":"GlyphRenderer"},{"attributes":{},"id":"bbbae2fb-9f3a-487f-88aa-d25544809814","type":"BasicTickFormatter"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"ticker":{"id":"59623683-7844-476f-bd72-623ade51c6a9","type":"BasicTicker"}},"id":"adc47d88-16e1-441a-b92b-af64296d2dec","type":"Grid"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8afe975b-ea52-42c5-8ee2-a928017d01ca","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"a27409c5-f194-4876-999d-2322d1350553","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"c72e1233-1e24-4de1-8d89-64f1dbe2bde9","type":"BasicTickFormatter"},"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"ticker":{"id":"82fb5df3-f32c-4153-ab91-e60e790a3909","type":"FixedTicker"}},"id":"2a51f87c-5cc0-48b1-be94-8261e69e4ea5","type":"LinearAxis"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"12900f8c-da2d-4f41-9e4d-ed00d888c40c","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"09922b4e-48be-4c4b-ad9d-7e49d5d08c88","type":"ColumnDataSource"},{"attributes":{},"id":"d43bf4b7-99ed-44eb-9312-67040b516f9c","type":"BasicTicker"},{"attributes":{"data_source":{"id":"5ca6267c-fc9a-45f4-b4fb-4722e622e784","type":"ColumnDataSource"},"glyph":{"id":"2ada3b43-0f21-4bc0-9fc4-4845a726b3a4","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"50b0a8e2-40f9-4922-b44d-ba3aede71332","type":"Wedge"},"selection_glyph":null},"id":"711821d8-33a4-4e63-9f38-6590b040cb4d","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"63af538a-d4a0-4a3f-b5ed-7bf4bc5e1cc4","type":"Line"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"9080b7b7-0234-441c-a50c-14202a535d03","type":"Line"},{"attributes":{"data_source":{"id":"98cf0b6a-95ad-4d36-8b41-88af12050a15","type":"ColumnDataSource"},"glyph":{"id":"84a44748-8b50-47dc-aabf-36f80c87ec99","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"9e694000-b648-443d-a208-2b3580e4f7ad","type":"Circle"},"selection_glyph":null},"id":"45ab0f31-337d-4991-92fa-79a07744f0b2","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"e64c468c-d3a9-4078-aa10-b9eba0c462b9","type":"ColumnDataSource"},{"attributes":{},"id":"5b08d41c-27a4-43b6-9e2d-6ffecbd333d7","type":"ToolEvents"},{"attributes":{"data_source":{"id":"0dc47928-d0e0-42b2-86d7-57bb0d8267e1","type":"ColumnDataSource"},"glyph":{"id":"36449d9f-9de8-432b-ba6e-3172a29228fb","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"276094da-9343-4ff6-8cdd-ea05639f22c8","type":"Text"},"selection_glyph":null},"id":"f32ce353-6c23-450b-a6c5-dac8a7aaa0ec","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"d7f8d488-36d3-4df7-8671-4baeddf6736d","type":"ColumnDataSource"},"glyph":{"id":"6093b64b-f889-4d95-be92-3219f77fbd26","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"453a90f3-5052-4bec-b31a-8b76b10473d5","type":"Circle"},"selection_glyph":null},"id":"8594a800-a3a8-4478-8fc2-53cde8cb98fa","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f25a787a-e76f-42c0-a18c-c32d51af0764","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1442d220-a6af-49d2-b463-479b839bacfa","type":"Line"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f13a002f-74dc-4b59-9ec2-5d921311c385","type":"Circle"},{"attributes":{"formatter":{"id":"995e1964-eb9a-42d5-a309-07085f008c74","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"ticker":{"id":"4f3d1d70-e6bf-4964-af79-7b5541b32339","type":"BasicTicker"}},"id":"8cd447ae-b736-4de7-8e90-4a91e4d47a42","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"e41a45f1-bece-4806-8a1d-4116846dc627","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"e2a2c637-14af-47bf-83de-32cd48307401","type":"ColumnDataSource"},"glyph":{"id":"fa50f2e2-2aad-4558-b3c9-d2a1c7361359","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"d7cfaf9e-3db4-4ed8-acd5-27248b2da62b","type":"Text"},"selection_glyph":null},"id":"047202d2-6122-4dcb-b1d2-94290b083af6","type":"GlyphRenderer"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"5e7b1486-34da-472f-8c07-af07c7089421","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"e088fb19-27e3-47b3-bf74-86f10a11ad22","type":"GlyphRenderer"}]],["Active",[{"id":"52d5d45e-1fca-4390-91b5-bd9a519b562c","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"}},"id":"66e5ecaa-4395-4c3e-9627-fae6c7e90dd0","type":"Legend"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"daead269-be8b-4ed2-90b4-623de226836b","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"18bf1816-07f1-43b9-a99e-84e0b45efee8","type":"Circle"},{"attributes":{"callback":{"id":"7fcf4174-5de1-40e0-bf2a-ab5ef60357d8","type":"OpenURL"},"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"}},"id":"4b3c3212-38b1-4025-947a-83bc53117059","type":"TapTool"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4157c3ee-1825-4033-b359-2bb13a923980","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2f5d45fb-e4a0-4c64-a893-72bde563af4e","type":"Text"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"734e50b1-272a-4007-821f-4c7adefdec21","type":"Wedge"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"3bf981a8-d88f-4dcb-b3d0-08bcb32c8136","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"0328efa1-c285-4f88-9ee7-58cca70688c3","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a395d39e-6a09-4a75-b02b-417d22e165c3","type":"Text"},{"attributes":{"data_source":{"id":"05398eca-ab7e-43b7-8dd8-f2925abca9b5","type":"ColumnDataSource"},"glyph":{"id":"66c5d0ca-f111-4f4b-be34-a7b4ac0d8310","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"6fe776a4-6555-402a-a9ba-44d92709439e","type":"Circle"},"selection_glyph":null},"id":"3988cb34-9e28-42bd-ae9f-32421a950e04","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e7ad59d6-7487-4cfe-919a-0804e617a08e","type":"Text"},{"attributes":{"formatter":{"id":"be6a72af-c4f0-495f-8e56-694fd38b3c8e","type":"BasicTickFormatter"},"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"ticker":{"id":"56126c0e-dc40-4a5c-82e0-7eae81889f3d","type":"FixedTicker"},"y_range_name":"category"},"id":"e22ef7ce-ba46-47c1-a95e-5dd318cbcd29","type":"LinearAxis"},{"attributes":{"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"}},"id":"f635ad13-daed-4542-92b1-dd55c21d5064","type":"PreviewSaveTool"},{"attributes":{"data_source":{"id":"c7147948-777d-459a-a03c-e1bf0da86402","type":"ColumnDataSource"},"glyph":{"id":"6375b6c8-bad1-4824-a932-8e4268901647","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"0275d23c-7586-4735-a5cd-a4f1cb7668c4","type":"Quad"},"selection_glyph":null},"id":"7bbc1f94-9fff-4fe7-9e82-a468c43f264e","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"ec41a19b-2117-4a4d-99bb-c59117943d8e","type":"ColumnDataSource"},"glyph":{"id":"6b66ab61-47db-40e1-a645-135856493365","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"e7c6ac85-1da4-4b56-9332-7b3f9dc21a48","type":"Circle"},"selection_glyph":null},"id":"7b0603a5-c8b3-4993-937b-7f33b98193bc","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"c4d0e5c5-9633-4f5a-863e-32620980fc43","type":"ColumnDataSource"},"glyph":{"id":"d3ec6ba6-78cf-4f20-8c2c-1d54082a0aaf","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"03e4a4f6-6512-4a2e-a527-2c94c9b6111d","type":"Text"},"selection_glyph":null},"id":"db523982-0da2-4a7b-89ae-ef3d5e146755","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"e2128614-1414-47f8-a512-c734262776b6","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c1b46899-42f1-4f10-96c8-1c7545b12357","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"ec41a19b-2117-4a4d-99bb-c59117943d8e","type":"ColumnDataSource"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"5a56b690-9fad-46d9-b672-755cb49a1912","type":"FixedTicker"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e15dc3c2-2cc3-41be-adf7-518b5e8027a9","type":"Text"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"cdb3d191-af45-4029-8b96-7d57a0596081","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3731e240-974d-4dea-aaf0-77993086164a","type":"Text"},{"attributes":{"data_source":{"id":"3cb068c5-9c88-4e0b-97d1-10d0c1b7ed17","type":"ColumnDataSource"},"glyph":{"id":"9576c3d9-e65d-4415-859e-420776b4f711","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"dfcfb902-d7a3-4c55-af61-0b8837a63122","type":"Line"},"selection_glyph":null},"id":"832ddfdf-0938-42a4-911e-9c2fb7747bcd","type":"GlyphRenderer"},{"attributes":{},"id":"9ee19491-a67e-4dd7-bfb4-9a3a8e894004","type":"BasicTicker"},{"attributes":{"below":[{"id":"206004d5-7b7b-47bb-91e1-b0a5282d3223","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"6f74f652-88d5-402a-8f87-6df7ed7a6136","type":"Range1d"}},"left":[{"id":"0cd188be-9241-4249-8206-83d50d7b5f33","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"206004d5-7b7b-47bb-91e1-b0a5282d3223","type":"LinearAxis"},{"id":"71202d7d-a1ac-499a-97ec-29eb98d62513","type":"Grid"},{"id":"0cd188be-9241-4249-8206-83d50d7b5f33","type":"LinearAxis"},{"id":"69d7bb65-e1d8-4787-8f86-5bdb4e9d18d9","type":"Grid"},{"id":"2782585e-fe51-4e18-8aa4-84fd04271542","type":"Legend"},{"id":"65cb878a-33f1-41b5-b157-2564fa1b1608","type":"GlyphRenderer"},{"id":"1513a437-89e7-4d6c-aa67-ab619cc3a845","type":"GlyphRenderer"},{"id":"0d075a83-16ba-4f33-b4f4-a1551245e29b","type":"GlyphRenderer"},{"id":"e6d21a2f-7fc9-4f70-8fce-e22ded3591b8","type":"GlyphRenderer"},{"id":"e73426ee-6971-41bd-9217-10e79a17c71b","type":"GlyphRenderer"},{"id":"50d1ccdb-464b-406e-8d07-737a2d768bd9","type":"GlyphRenderer"},{"id":"7bbc1f94-9fff-4fe7-9e82-a468c43f264e","type":"GlyphRenderer"},{"id":"1bd17ebb-72fe-4414-8966-02e4eb7181c6","type":"GlyphRenderer"},{"id":"2f4bc48b-51c1-4866-91ab-2fabdeff7b41","type":"GlyphRenderer"},{"id":"fe7282e7-b0e5-4d1e-8d62-848b613548d0","type":"GlyphRenderer"},{"id":"687115f2-c1e9-4cae-a42a-b7869b702eca","type":"GlyphRenderer"},{"id":"68e981c0-5084-48d5-816c-6e4dd2502f6f","type":"GlyphRenderer"},{"id":"7194894e-7efa-40fe-9780-ef4b81bbc104","type":"GlyphRenderer"},{"id":"0e7ef584-73dc-4f2e-8f49-202537f6bb10","type":"GlyphRenderer"},{"id":"b9146972-2fb6-4775-a72e-370ca9d62e24","type":"GlyphRenderer"},{"id":"8c6e4cac-e428-4c7d-a53a-2a9d43b6be95","type":"GlyphRenderer"},{"id":"89976ae5-49f2-4930-8535-2b7d81a4ecac","type":"GlyphRenderer"},{"id":"eb892402-718a-4aea-8745-5f3817f49d1f","type":"GlyphRenderer"},{"id":"4c8142dd-bace-4a5f-826a-49b28075f5d4","type":"GlyphRenderer"},{"id":"186b3027-7897-41b4-9ab3-039659088f39","type":"GlyphRenderer"},{"id":"c83727b3-7488-42b1-907c-922cf5967753","type":"GlyphRenderer"},{"id":"81364e52-2871-479f-bd8d-6841720891d9","type":"GlyphRenderer"},{"id":"db523982-0da2-4a7b-89ae-ef3d5e146755","type":"GlyphRenderer"},{"id":"711821d8-33a4-4e63-9f38-6590b040cb4d","type":"GlyphRenderer"},{"id":"85e3d85f-bf9d-4ddd-bf56-214e5f69580c","type":"LinearAxis"}],"right":[{"id":"85e3d85f-bf9d-4ddd-bf56-214e5f69580c","type":"LinearAxis"}],"title":"PubChem CID 547","tool_events":{"id":"aa44257c-fd2c-4bee-9267-660e89347364","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"a536caa5-cb65-40e1-8fef-c5da4f1522b0","type":"PreviewSaveTool"},{"id":"7ade4277-d245-4287-bd6c-efee5ef911d2","type":"TapTool"},{"id":"a17e2313-cc2f-499f-a8a6-0f9453983435","type":"HoverTool"},{"id":"58ff8082-1d50-4f2c-9cee-54ad0ae86c5b","type":"HoverTool"}],"x_range":{"id":"7e6bf2f7-d105-4d2c-87d0-19dd9299578c","type":"Range1d"},"y_range":{"id":"676d2c09-fa8d-4529-9ad7-d878c5a03ad7","type":"Range1d"}},"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"be196797-cea1-49e8-8e22-f30e2b1f36c3","type":"Line"},{"attributes":{"data_source":{"id":"48e10b4a-d228-4168-8bc6-c4101a1b716a","type":"ColumnDataSource"},"glyph":{"id":"83feb436-22d0-4072-aa98-a833b427f6d9","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"29daf99e-1a5b-4745-a6b4-e4ff1b99d0d6","type":"Line"},"selection_glyph":null},"id":"1bd17ebb-72fe-4414-8966-02e4eb7181c6","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"6820ecb7-7168-421f-aeee-61eb344d7b3b","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[15910.0,3468.0,4921.0,56638112.0,8570.0,15109.0],"Confidence":["4.09","2.0","2.0","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.69,0.67,0.66],"alpha":[0.5842857142857143,0.2857142857142857,0.2857142857142857,0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000","#b30000","#b30000","#228B22"],"index":[3,4,5,6,7,8],"line_color":["#b30000","#b30000","#b30000","#b30000","#b30000","#228B22"],"radius":[0.029214285714285717,0.014285714285714285,0.014285714285714285,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.6296551724137931,0.6066666666666667,0.5951724137931034]}},"id":"e45da5db-0912-4f05-990e-ff225d1fac84","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"bc91f89c-a4a6-44cc-a74f-0978b61a6f51","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"0b13632e-1fd6-492a-986f-27af063faef0","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"ticker":{"id":"75840c70-7e0e-4459-affd-c04f7522199f","type":"BasicTicker"}},"id":"313753e9-bfda-4ee0-94f6-919ab57dede6","type":"LinearAxis"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"df667f7f-4a18-44ca-97f1-6592cd386bab","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f971154c-c46f-43c0-aa0a-1e810bcd2e70","type":"Text"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"31154bd4-1093-4eb1-a143-16c73ad317bc","type":"Text"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"ticker":{"id":"cf912c73-c521-48f5-9c7b-a6bf8f61d13d","type":"BasicTicker"}},"id":"e5c07b5b-2918-4704-934d-8d0bb0284b76","type":"Grid"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"adacb845-797c-439d-9d0e-350bc457a865","type":"Line"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"05da1c0e-eb6d-4c52-a606-a5c7f375ba01","type":"Circle"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ef817c77-ddd0-4f1f-b19c-ae5e3c5dd55d","type":"Circle"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e1fc1357-daa1-46ca-baad-9aa2870a37db","type":"Text"},{"attributes":{"data_source":{"id":"61282e9e-c17a-4644-962c-75679c4448e5","type":"ColumnDataSource"},"glyph":{"id":"64171ff6-748f-4635-8cdb-2140f131dc62","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b0d54240-48a3-4dcd-bb8e-66e022c91441","type":"Text"},"selection_glyph":null},"id":"e73426ee-6971-41bd-9217-10e79a17c71b","type":"GlyphRenderer"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"0bca1867-a8b4-4f88-8ec5-a247ea2fc6a7","type":"Quad"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"113dce63-81af-4410-93f0-fef2d535f36d","type":"Wedge"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"b19eadaf-e0dc-40ed-94cd-c7dabdf02322","type":"Line"},{"attributes":{"data_source":{"id":"e298622d-25ba-4e51-a272-5a11625672e2","type":"ColumnDataSource"},"glyph":{"id":"dfe80c05-c2a4-4364-bc58-ddccde640fa5","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"22fe2955-bef8-4790-8ef9-b0c819294a48","type":"Quad"},"selection_glyph":null},"id":"350a53f2-2e44-4c63-8762-48c9fd2df751","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"51947a86-f880-4875-bf13-6693f2104dcb","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"f4ab1ecd-cf5e-4164-9b27-97922d26ef82","type":"Line"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"266cddc4-8dfe-4b83-b73b-edfded212719","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"c96d52fd-b777-4035-9b72-3521bc7d6ee8","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7c93e9cd-d018-4f48-845f-9361152fe8dc","type":"Circle"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"5cdcff5f-e17a-458e-a5e6-1a9214f1ac30","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2d5849b2-ba4a-4887-bbbe-b01555bdef15","type":"Circle"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"c3c283ce-b586-4db8-a89b-2f232343d55e","type":"OpenURL"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"346ff4f8-2b14-4f54-a597-f79440bb0cd6","type":"Quad"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"ff4ae5b9-1e6b-4f8d-9254-3a1694e81ef2","type":"FixedTicker"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a12e995f-e744-4b86-9120-5f09b888496a","type":"Text"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"4aa81ada-597d-4dc7-9475-20f8c72990fd","type":"FixedTicker"},{"attributes":{"below":[{"id":"8cd447ae-b736-4de7-8e90-4a91e4d47a42","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"5f8d72d7-c8c0-4aee-85a8-cb79c9574c8d","type":"Range1d"}},"left":[{"id":"23569bad-c288-4ac0-9bb6-e62eb7bf8c8b","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"8cd447ae-b736-4de7-8e90-4a91e4d47a42","type":"LinearAxis"},{"id":"5e171d41-597a-4018-a489-71c5656f963e","type":"Grid"},{"id":"23569bad-c288-4ac0-9bb6-e62eb7bf8c8b","type":"LinearAxis"},{"id":"5d357adf-e1cf-4946-95ac-1ec5aeb91b29","type":"Grid"},{"id":"bbdf52d6-a939-4d08-ac2b-dcf04c0d62b2","type":"Legend"},{"id":"19b7e0f7-b556-480d-ad5d-ef8509834714","type":"GlyphRenderer"},{"id":"4bcff7d1-dc7e-44dc-8b35-7d1b3618a48d","type":"GlyphRenderer"},{"id":"66d97b7c-fdfb-4b2c-a544-9bad12d47573","type":"GlyphRenderer"},{"id":"da0cdabb-46d2-4ac4-8c53-b5ef82d08672","type":"GlyphRenderer"},{"id":"1719488f-edbd-498e-9e3e-04854ff22345","type":"GlyphRenderer"},{"id":"92c01e6d-dd6f-40ad-83d7-94906c4cc376","type":"GlyphRenderer"},{"id":"350a53f2-2e44-4c63-8762-48c9fd2df751","type":"GlyphRenderer"},{"id":"916cb35b-677b-4f1d-9d8d-b2f0cc09dad5","type":"GlyphRenderer"},{"id":"e83d5a21-49c1-4151-8e9c-29c90201cbe8","type":"GlyphRenderer"},{"id":"982cea8b-e742-4e1b-b6ce-216261f010aa","type":"GlyphRenderer"},{"id":"ebe5ce1f-3991-4e53-bb8c-fa9550067cb9","type":"GlyphRenderer"},{"id":"7ec7be4d-6d2c-48dc-9940-1e8974250501","type":"GlyphRenderer"},{"id":"a7f30daf-273b-4630-a9e2-b540b38f8661","type":"GlyphRenderer"},{"id":"e0411573-7744-4c1a-833c-a6aea3c8a79f","type":"GlyphRenderer"},{"id":"0d672c2a-b148-4ee8-9f47-361f67fff1dc","type":"GlyphRenderer"},{"id":"a675c0a8-7cdc-4b3b-beb1-d76ae33de79b","type":"GlyphRenderer"},{"id":"ebf533bc-4207-41c5-b8a7-91b2923f898c","type":"GlyphRenderer"},{"id":"d08a23e9-8c5f-467a-abd1-2f91a124980e","type":"GlyphRenderer"},{"id":"702e2339-fca6-494a-95e5-6b3c9b969e01","type":"GlyphRenderer"},{"id":"10107218-0eac-4c9d-8851-6dec30da7423","type":"GlyphRenderer"},{"id":"0379eb2c-2a18-4cf1-8eda-2a71996b5427","type":"GlyphRenderer"},{"id":"7110b899-f026-42ca-9786-1d81b6e1b175","type":"GlyphRenderer"},{"id":"c9bbca4b-95ef-475e-b42f-cac820d46178","type":"GlyphRenderer"},{"id":"7bb4c8f3-e299-4739-8e5e-450211d56549","type":"GlyphRenderer"},{"id":"144580d5-5e16-4f62-9590-1b82328c6464","type":"LinearAxis"}],"right":[{"id":"144580d5-5e16-4f62-9590-1b82328c6464","type":"LinearAxis"}],"title":"PubChem CID 128018","tool_events":{"id":"711447a6-71e6-4fa6-8bc4-cdbb7f0508ad","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"73e4db49-edf0-47f7-9507-73c55baf7d5d","type":"PreviewSaveTool"},{"id":"13499e97-94c5-4fee-b8c1-7a852f673aea","type":"TapTool"},{"id":"0450cf2f-a8ea-4e7b-9d50-2a10a652da52","type":"HoverTool"},{"id":"bda9a454-197c-46ed-8984-59b37cc770d1","type":"HoverTool"}],"x_range":{"id":"3f3ba71b-400c-4185-9c78-fe18a6039f6f","type":"Range1d"},"y_range":{"id":"09f60e8c-c77f-4d83-88dc-9cc5e37bada0","type":"Range1d"}},"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"78dacfbe-86c6-4099-85b2-5a63c988da5b","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"bdb820d7-5f5c-4200-bf8a-16c0730898d0","type":"Quad"},{"attributes":{"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"}},"id":"60d10184-9f60-4859-ab46-f9e086c3efe7","type":"PreviewSaveTool"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"de385f2e-a40b-479a-a207-a31879f5800f","type":"Text"},{"attributes":{"data_source":{"id":"cd72b24b-c293-4c66-b408-eba879a0a501","type":"ColumnDataSource"},"glyph":{"id":"09dde2d0-db1b-456b-8d79-27882c3fab98","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"c1bf55ae-2879-4d62-b210-f8b5a8c6780b","type":"Circle"},"selection_glyph":null},"id":"1499adb8-0569-4b5c-9ec1-47a456b74d6e","type":"GlyphRenderer"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"ea6eee16-91f2-4a28-94be-83c9ce2691d4","type":"FixedTicker"},{"attributes":{"data_source":{"id":"c96d52fd-b777-4035-9b72-3521bc7d6ee8","type":"ColumnDataSource"},"glyph":{"id":"e9651682-7ff6-4b07-852c-b3067f33644c","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"8befe0b2-10e9-4318-aa39-17614757e125","type":"Text"},"selection_glyph":null},"id":"28e9a0ec-17e5-4708-b093-0ff8e28b7c4d","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"e8c1f466-f4d7-44d8-b522-a566996a590d","type":"ColumnDataSource"},"glyph":{"id":"49fc0f06-f6e3-42de-a538-b936a674ef6d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"8b7ba20b-cb00-466b-8d6a-09cf4a2f4449","type":"Text"},"selection_glyph":null},"id":"b9cb2128-5865-4f11-8452-c586a964de04","type":"GlyphRenderer"},{"attributes":{"callback":null,"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"renderers":[{"id":"711821d8-33a4-4e63-9f38-6590b040cb4d","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"58ff8082-1d50-4f2c-9cee-54ad0ae86c5b","type":"HoverTool"},{"attributes":{"data_source":{"id":"c4e7a4ad-8cb5-4273-85a3-19b94c220e7b","type":"ColumnDataSource"},"glyph":{"id":"6820ecb7-7168-421f-aeee-61eb344d7b3b","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"51042dcc-f2fa-43fa-a042-08b89343dcc6","type":"Line"},"selection_glyph":null},"id":"d5a2acc4-a9a2-422d-82e7-b6ef0faf7374","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9e694000-b648-443d-a208-2b3580e4f7ad","type":"Circle"},{"attributes":{"data_source":{"id":"d0346ae3-ebae-4e01-b3cd-1d298e51aba1","type":"ColumnDataSource"},"glyph":{"id":"a6c0fc9e-92f3-4172-ad65-fec1ea1c4158","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"2f826e81-c45c-484e-97fc-c9dd727d08cd","type":"Line"},"selection_glyph":null},"id":"2265de28-0b62-4b28-b761-41e32517dd76","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"eeaf2616-9d98-46f2-81ba-5c9d2d7f05f8","type":"Circle"},{"attributes":{"callback":null,"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"renderers":[{"id":"c83727b3-7488-42b1-907c-922cf5967753","type":"GlyphRenderer"},{"id":"81364e52-2871-479f-bd8d-6841720891d9","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"a17e2313-cc2f-499f-a8a6-0f9453983435","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"1431aafc-d812-4ba6-8505-8b399f997259","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"2f62ecf0-f99c-437c-9fb6-21a102682fd7","type":"Line"},{"attributes":{},"id":"a3462bbe-2c3c-4d02-aa38-8eea85a49cb3","type":"BasicTickFormatter"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"a61734b0-f743-4422-a10d-c14267ae99bc","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"daf0c743-03af-4e20-a06c-f18477bcdeed","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"e2128614-1414-47f8-a512-c734262776b6","type":"ColumnDataSource"},"glyph":{"id":"683a0cb7-ad5e-4346-ab04-61320fd4f475","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"035a82f6-d82a-45bd-9519-780f249ca4d1","type":"Text"},"selection_glyph":null},"id":"080f840e-eb95-40b4-a514-2233d51ccb5b","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"62969570-90bd-4065-ba1b-ba97ce924640","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"677d6360-4641-40f5-bde8-4db4d052c539","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"ee37717a-9925-4bef-8f93-d4c1fe0c1ee5","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0f252a7e-d21d-424f-935a-32aa9e68e6bc","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"f54f6c62-6f31-496b-8967-b08d3eb9008c","type":"Line"},{"attributes":{"data_source":{"id":"626b9c43-6dd9-418b-a956-4ea3b87bd723","type":"ColumnDataSource"},"glyph":{"id":"ac0c13c4-fff5-4f32-a93d-64af7fbe839a","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"76835400-f38d-4679-a70d-cbc77831c3d1","type":"Line"},"selection_glyph":null},"id":"511ec524-cb39-4e4a-82bb-55914a0deb68","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"3156f28e-2ef8-444d-88a3-7f0ae1bd2155","type":"ColumnDataSource"},"glyph":{"id":"b19eadaf-e0dc-40ed-94cd-c7dabdf02322","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"91b97118-aa67-403a-b44e-912371f672bc","type":"Line"},"selection_glyph":null},"id":"26edec7e-2be2-4a0f-9226-b105badd7e0e","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"6f662a9e-f132-4efb-85ba-ba21fbdc24da","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"b75c5da4-9e8d-4ce2-b0f4-6690730545a1","type":"ColumnDataSource"},"glyph":{"id":"d414134a-11c2-4969-b64c-e0ff591a013d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"135eb392-0644-4ead-84c0-f94febe935ac","type":"Text"},"selection_glyph":null},"id":"794fa2c3-c247-484a-859a-b224440a6932","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7983de7c-27ff-4e63-8a37-8acd25459a10","type":"Text"},{"attributes":{},"id":"04e89aea-1b88-4058-a8bf-62a8e3cdefc9","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"c48575ae-7228-4d86-ac1d-269110818d8f","type":"ColumnDataSource"},"glyph":{"id":"0c3f5903-d2fb-4c6b-aa32-b195a398debd","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"816ef2fc-6b0a-4141-8804-b23712d20b47","type":"Text"},"selection_glyph":null},"id":"b9146972-2fb6-4775-a72e-370ca9d62e24","type":"GlyphRenderer"},{"attributes":{"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"}},"id":"9a111abf-d9bb-46c7-8666-08ad84e67709","type":"PreviewSaveTool"},{"attributes":{"data_source":{"id":"e41a45f1-bece-4806-8a1d-4116846dc627","type":"ColumnDataSource"},"glyph":{"id":"3731e240-974d-4dea-aaf0-77993086164a","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"94e3ab18-0394-4f5e-93a5-9a49c443ca6a","type":"Text"},"selection_glyph":null},"id":"96c97535-98fb-42ee-90ad-871ebbfdcefb","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6f246ba8-a8f3-46a5-a0df-48b5f966729d","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"9cf401b8-f6c6-4d09-a291-3cbe7c0e1edb","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"17ab7374-e8ad-48d3-a552-d819d7b34da9","type":"Line"},{"attributes":{"data_source":{"id":"033bf1eb-1697-4032-9953-2435fe049796","type":"ColumnDataSource"},"glyph":{"id":"f67f8d7e-43e3-4ef5-a810-8ab2c8b26829","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"f861d908-6b8b-439f-aaf0-24bd0a5272e5","type":"Text"},"selection_glyph":null},"id":"9920c709-ddc5-4354-aaef-13fdd47d2a5b","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8f0534ba-a64c-4f35-8458-4fde107e5e11","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[0.3333333333333333,0.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#228B22","#228B22"],"index":[0,1],"line_color":["#228B22","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[0.3333333333333333,0.0]}},"id":"95e9df1b-b331-4abe-97fc-5ad18bca918b","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8befe0b2-10e9-4318-aa39-17614757e125","type":"Text"},{"attributes":{"data_source":{"id":"5be0b274-ddef-440f-b48a-facefd349adf","type":"ColumnDataSource"},"glyph":{"id":"1923adb9-a57f-4a94-b2d7-f7c56dee86a0","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"c2211048-7a40-4264-a836-3b1531e77651","type":"Line"},"selection_glyph":null},"id":"ea96fb60-cd6c-4ae1-acc2-14ed602d3143","type":"GlyphRenderer"},{"attributes":{},"id":"711447a6-71e6-4fa6-8bc4-cdbb7f0508ad","type":"ToolEvents"},{"attributes":{"data_source":{"id":"fe943490-6ddc-4873-80c8-fd5ffe5cbd4d","type":"ColumnDataSource"},"glyph":{"id":"3b42612d-f068-40d7-9f29-c3705e35fcd2","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"79cc4cc5-9ad7-44db-9cb4-4bdc57861304","type":"Text"},"selection_glyph":null},"id":"6ceb2163-ffb3-4d6d-bd53-d4a7b37a0dee","type":"GlyphRenderer"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"5f8d72d7-c8c0-4aee-85a8-cb79c9574c8d","type":"Range1d"},{"attributes":{"data_source":{"id":"d292d2b9-7b93-47fd-9a9d-e5c2c25c6bbe","type":"ColumnDataSource"},"glyph":{"id":"674f9e49-4aca-4a10-8dcd-c9eb65c17f3d","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"44f3f01f-9a0a-4309-8d84-87e642cc21ce","type":"Circle"},"selection_glyph":null},"id":"94b052a8-beb4-417f-884c-8980044c1e82","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"b11ee89f-ed8a-46cf-b226-7545c76b96e2","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"ab5689bd-9a1a-4c4f-bbed-37dd3e066b68","type":"ColumnDataSource"},"glyph":{"id":"bb496946-67c0-413c-8519-fcc8833661af","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"7c7a6b27-76c6-49ea-b303-905cdbddd985","type":"Text"},"selection_glyph":null},"id":"481a83e6-0e6c-48da-a65e-ae46c8db9134","type":"GlyphRenderer"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"ticker":{"id":"4f3d1d70-e6bf-4964-af79-7b5541b32339","type":"BasicTicker"}},"id":"5e171d41-597a-4018-a489-71c5656f963e","type":"Grid"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,13622.0,12127.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.87,0.83,0.83],"alpha":[0.5,0.5,0.5],"fill_color":["#228B22","#b30000","#228B22"],"index":[6,7,8],"line_color":["#228B22","#b30000","#228B22"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.8695652173913043,0.8333333333333334,0.8260869565217391]}},"id":"00ef7017-812e-4932-b505-a55232f5647e","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"9ecdb6d5-cb36-4ba0-b776-6555e252c107","type":"Line"},{"attributes":{},"id":"ce479310-5f10-406b-8715-c30296fdc5d6","type":"BasicTickFormatter"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5072c526-1778-4850-9035-9636cbb9dea9","type":"Text"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"82fb5df3-f32c-4153-ab91-e60e790a3909","type":"FixedTicker"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8d879815-5f26-40ee-af6e-2990552ca115","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"e41a2d24-5a27-4003-93f9-408ff536d15d","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"44c9a6a8-8ce8-4a85-b39d-527bb136ac2c","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e2b17dac-2b27-4965-9417-9ebb3dab8fe8","type":"Circle"},{"attributes":{"data_source":{"id":"c25e190b-71be-4342-8ce6-39ff8fbbe09d","type":"ColumnDataSource"},"glyph":{"id":"bdb820d7-5f5c-4200-bf8a-16c0730898d0","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"a071b6d4-54c6-4eb8-a9e4-710a57503de3","type":"Quad"},"selection_glyph":null},"id":"85881a87-7732-42ca-8423-0602d3665b1a","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"4070f420-8af8-4007-8a6b-0af5831635a3","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e5dd90cc-27de-464d-91ce-2a86bd966070","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"47302cf6-8b87-4d01-95b1-841fc361e558","type":"Line"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b6a67e5c-d619-4210-af29-e056883debca","type":"Circle"},{"attributes":{"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"}},"id":"b02bad4c-6415-4721-8ee5-4ceecf3bd1c2","type":"PreviewSaveTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"5be0b274-ddef-440f-b48a-facefd349adf","type":"ColumnDataSource"},{"attributes":{},"id":"a30a3586-61fa-4be0-83c6-32d79ada6002","type":"BasicTickFormatter"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"51042dcc-f2fa-43fa-a042-08b89343dcc6","type":"Line"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"c7daf622-0955-4f9d-8294-c075e21d8156","type":"OpenURL"},{"attributes":{"data_source":{"id":"f6f228ec-39b8-45be-b227-4e1b9b31c2c4","type":"ColumnDataSource"},"glyph":{"id":"46dcf49b-6962-42d6-a38a-7e8ec5f09055","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"e1c6fc9b-32c1-4a37-92bf-79dc9cc9ce55","type":"Circle"},"selection_glyph":null},"id":"293c0239-6489-4b71-b539-85b08893248b","type":"GlyphRenderer"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"7fcf4174-5de1-40e0-bf2a-ab5ef60357d8","type":"OpenURL"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a8215f1a-ce58-400b-9f2b-9c80f3e53944","type":"Circle"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"cf5f41b7-97e2-476e-bb57-ff3a9919d296","type":"ColumnDataSource"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"87a77245-ce30-49e9-aa47-9d90a046579e","type":"OpenURL"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"dbc36d21-3a92-4db6-affc-c17a0564f4c4","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[9909677.0,4921.0,213031.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.61,0.58,0.56],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000"],"index":[6,7,8],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.6119402985074627,0.5844155844155844,0.559322033898305]}},"id":"8293c2f4-5455-4706-9203-f62035716d24","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"eba09c5f-cd1d-408d-addb-75d4fcddce7d","type":"ColumnDataSource"},"glyph":{"id":"5374300f-124f-40df-bf6a-1c730ad38fed","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"dd479892-5c4a-4c5e-8692-9e8bf818db49","type":"Wedge"},"selection_glyph":null},"id":"8a92daac-a812-4307-bd9b-cf0c5caab758","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bc0045ef-79bd-4bc8-a0c8-6c4588901fad","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6ad48073-2659-4ac6-ab0b-d3ae7fecdff2","type":"Text"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"65bc3bd6-2dc4-4973-85e5-a96a97cd56ff","type":"Circle"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"3738c010-aa8b-43a5-ba3e-73101095f70b","type":"Quad"},{"attributes":{"data_source":{"id":"293fe221-ab64-4178-af68-1155dde2ed98","type":"ColumnDataSource"},"glyph":{"id":"fb0a1e0e-16d1-4048-9c10-679840a5d036","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"8d879815-5f26-40ee-af6e-2990552ca115","type":"Text"},"selection_glyph":null},"id":"da0cdabb-46d2-4ac4-8c53-b5ef82d08672","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4b08c3cd-842e-46be-aaae-de8c1a3a541a","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"791f58e6-1b74-4c09-b50f-ec9970ba74e7","type":"ColumnDataSource"},{"attributes":{},"id":"ac312c1f-8c31-4281-ae6c-84469c90b26e","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d18635e4-f6b1-4329-94d1-88abe39fe91a","type":"Circle"},{"attributes":{"data_source":{"id":"400e421d-34c5-4158-979b-a1cfa048ddfd","type":"ColumnDataSource"},"glyph":{"id":"0b8af34c-2c81-4a48-82b2-f52e097b0ebb","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"524f6cca-d873-4175-8ffc-45a6c9ada0b8","type":"Text"},"selection_glyph":null},"id":"ea9c025d-c257-4068-89a0-72e700ecb077","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"c648f370-c668-4d00-9047-c729ccf308ad","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9ec56921-aab2-45a3-86aa-2da8a08dbb36","type":"Circle"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"72a156cd-ecd0-4094-a17b-a661dbbdb7c3","type":"Text"},{"attributes":{"data_source":{"id":"0f29d8c4-ee90-43ce-b5d9-bbdb9db7b719","type":"ColumnDataSource"},"glyph":{"id":"a8efa064-f426-41f1-980b-14c9b64d7b63","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"ae716f12-cb2f-404d-9139-d07b730717f7","type":"Circle"},"selection_glyph":null},"id":"76912a12-5241-4899-9584-a8580e9ae339","type":"GlyphRenderer"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"384a7326-7cfd-4330-ac25-abf2e921e0e6","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[1,1]}},"id":"5b44e5a4-23a0-48f4-8e1c-d43f7059eb84","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"3e780b55-caef-4543-b44b-7b23797417c3","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"edfb2129-0587-40e6-8f43-99cd2d55939f","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fd3ed4c0-f4e4-4785-804f-9973fecec201","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"7ffbdc0c-dba8-4842-beaf-e09a97dd3141","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ff9b00c9-2e5a-4377-bb84-2f6d315069f6","type":"Text"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"059ae258-11f6-4ce8-b32a-672345040be1","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"3301b70d-4432-4658-8d00-38aa163752a8","type":"GlyphRenderer"}]],["Active",[{"id":"58cc1cf0-7d5f-4043-ab4c-535d4edbe46f","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"}},"id":"3ce01f61-082c-4fb2-9c45-40181beeb5ba","type":"Legend"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"5f8a28fe-fff8-401a-bd26-9621e9a8413f","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"b3c19a96-003e-4116-82a2-62790fae37a1","type":"ColumnDataSource"},"glyph":{"id":"adba265f-8539-4a2e-a788-3822ca5408f4","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"e12f0767-9f01-4275-925a-3bf162219c09","type":"Circle"},"selection_glyph":null},"id":"0c472726-c370-4a4e-94f4-73e22b07ef3b","type":"GlyphRenderer"},{"attributes":{},"id":"a334b9fb-970f-4492-91c7-6590484c6ccc","type":"BasicTicker"},{"attributes":{"data_source":{"id":"8c71415e-5383-4dc6-bb49-6e3efbc0ebd1","type":"ColumnDataSource"},"glyph":{"id":"11b649c1-2533-4549-917e-b9ca28bbe439","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"fdd4af7e-4f72-4993-b6a5-0e7da05c2b36","type":"Text"},"selection_glyph":null},"id":"e53b1f05-4d1d-44f1-a55c-7b3da44404fd","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"0c4ada59-c580-44f9-a360-e860f9a0c926","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ae716f12-cb2f-404d-9139-d07b730717f7","type":"Circle"},{"attributes":{"data_source":{"id":"77fb5270-6bb8-41d9-8c72-e78207c01ccc","type":"ColumnDataSource"},"glyph":{"id":"08ecd9ee-cdd4-4d39-9fd4-9cca2bd5a731","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"f1793e88-0e73-44b8-9c1a-91e5539dd831","type":"Circle"},"selection_glyph":null},"id":"1513a437-89e7-4d6c-aa67-ab619cc3a845","type":"GlyphRenderer"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"46c98f5b-eb4c-42db-a037-d5e3cbe8ec05","type":"Wedge"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"ticker":{"id":"0610ff32-5aa9-442f-865f-449864f799dd","type":"BasicTicker"}},"id":"8a6d09d6-f892-4cc2-92ec-730c5b00ddf8","type":"Grid"},{"attributes":{},"id":"69810c9d-3e65-49d5-8b6f-2fc20c0ec324","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a046de61-1131-49ea-b4f0-63b80e98d2ab","type":"Circle"},{"attributes":{"data_source":{"id":"4c3b698f-bdf2-451f-97ae-9f73253b78aa","type":"ColumnDataSource"},"glyph":{"id":"2e503e58-98ea-4e44-8a9e-b93c83e42d42","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"c32fb5ed-7bf7-43f4-b992-d56f3a70934e","type":"Wedge"},"selection_glyph":null},"id":"960cdbf5-f7c7-47bb-a1f7-45e75265e45a","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"0b8f0767-e742-4237-8de4-3634da7492a2","type":"ColumnDataSource"},"glyph":{"id":"90bcc13a-ab62-4394-9b72-aa4ab1991735","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"7211ec32-30cf-4ac0-b969-86401c96476d","type":"Text"},"selection_glyph":null},"id":"4c8142dd-bace-4a5f-826a-49b28075f5d4","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"bfb12256-9739-4815-a17d-526e0578f041","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"e2a2c637-14af-47bf-83de-32cd48307401","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"148eb8b2-119d-49fb-b472-47691d87a287","type":"Quad"},{"attributes":{"data_source":{"id":"d61b9552-458b-418a-9a6a-5cf89111255d","type":"ColumnDataSource"},"glyph":{"id":"f13a002f-74dc-4b59-9ec2-5d921311c385","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"dfad4f63-ecdf-41f4-bbda-36d8c1f51f9d","type":"Circle"},"selection_glyph":null},"id":"186b3027-7897-41b4-9ab3-039659088f39","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fbe35c41-9df0-437f-918e-1c2c6693fde6","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a29a1a53-b7a2-4481-a635-5434aa83a2ab","type":"Text"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"83c9d5d2-1cfb-4080-a7ee-9327489ab12b","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"58859560-e100-4345-b8bd-64bbef7b8117","type":"Line"},{"attributes":{"callback":null,"start":-1},"id":"7a732073-4edb-4a67-999c-aa3f90f3ff27","type":"Range1d"},{"attributes":{"data_source":{"id":"4dc1e9cc-5c80-4b7b-b11b-17e5c2047a25","type":"ColumnDataSource"},"glyph":{"id":"34990a91-dde2-4d29-933b-d0ce3ecc7d7b","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"277bd24e-9f92-4692-8017-3a934bc1023e","type":"Text"},"selection_glyph":null},"id":"24f521a9-af4e-4ae5-be48-8b2f4850c743","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5737f64a-dae0-48e4-a943-ed974294d311","type":"Circle"},{"attributes":{"data_source":{"id":"c648f370-c668-4d00-9047-c729ccf308ad","type":"ColumnDataSource"},"glyph":{"id":"df667f7f-4a18-44ca-97f1-6592cd386bab","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"fa06be48-95af-403a-b315-638414f44be3","type":"Circle"},"selection_glyph":null},"id":"60839618-03f0-4cd8-92ae-976a6ecb0069","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"a30a3586-61fa-4be0-83c6-32d79ada6002","type":"BasicTickFormatter"},"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"ticker":{"id":"83e79488-7c91-49a1-accc-7ca67679be94","type":"FixedTicker"}},"id":"7dfb0740-0f24-4461-83a3-f0142812d39c","type":"LinearAxis"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3fc6ba07-30ad-455d-af53-09fe1724c7a8","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"196c0dd6-df16-4293-9958-02f7af267249","type":"Line"},{"attributes":{"data_source":{"id":"43878629-34c7-48a3-a1f5-ec9022cd3b63","type":"ColumnDataSource"},"glyph":{"id":"167589a8-2a29-4034-a692-70283582d0bd","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"e0677b09-2dc0-485c-ac2a-b4ea7bb94b9f","type":"Circle"},"selection_glyph":null},"id":"c79c3885-b884-48d0-8447-72fb1e03f2f7","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"bc91f89c-a4a6-44cc-a74f-0978b61a6f51","type":"ColumnDataSource"},"glyph":{"id":"1c4e002f-b2d2-4539-b854-630180d8ef08","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"0790422a-58e5-4e70-90fb-08ae8daea845","type":"Text"},"selection_glyph":null},"id":"c19e3e25-ea23-4a1d-b3a9-f1c265c98afc","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"9cf401b8-f6c6-4d09-a291-3cbe7c0e1edb","type":"ColumnDataSource"},"glyph":{"id":"278f0ada-0e50-4185-b25d-de3db1ad6648","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"3b47ce9b-a440-402a-9e19-0fb6baa6e8c6","type":"Line"},"selection_glyph":null},"id":"e83d5a21-49c1-4151-8e9c-29c90201cbe8","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"bf8946a5-5976-48ed-8339-10ed0a7b5af8","type":"ColumnDataSource"},"glyph":{"id":"92e7e382-77f7-461e-b333-62ae372603d3","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"5d5e0a7b-eaae-4716-85ea-70c25994a170","type":"Wedge"},"selection_glyph":null},"id":"60d5f364-3f41-45bb-b36f-d6db7ada2563","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"826d6c3f-d61e-4e06-bdc0-ecf9d4b960d9","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"32bd0c56-d6c3-4809-88db-132f049d4153","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"c69ebceb-66e6-4b86-9639-62532a50a4a9","type":"ColumnDataSource"},"glyph":{"id":"225f1a56-8c9f-42a6-90a1-1a09aecf490e","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"9ec56921-aab2-45a3-86aa-2da8a08dbb36","type":"Circle"},"selection_glyph":null},"id":"c4fdbb70-e0e2-44c5-b1f3-974694ac13ac","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"d3c59497-cd38-4d37-9b14-1cef14bc8d36","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"183622ca-7cd9-41c1-9ccc-c2e4f480aea1","type":"Circle"},{"attributes":{"data_source":{"id":"c6546bf2-619a-4c88-a24a-b3d6e905326c","type":"ColumnDataSource"},"glyph":{"id":"b6a67e5c-d619-4210-af29-e056883debca","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"5737f64a-dae0-48e4-a943-ed974294d311","type":"Circle"},"selection_glyph":null},"id":"3301b70d-4432-4658-8d00-38aa163752a8","type":"GlyphRenderer"},{"attributes":{"callback":null,"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"renderers":[{"id":"94b052a8-beb4-417f-884c-8980044c1e82","type":"GlyphRenderer"},{"id":"d1920de6-ede9-4281-a3e0-5625ab3c3834","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"098c3dc1-49e0-4b78-a972-4cfe2d3226b4","type":"HoverTool"},{"attributes":{"below":[{"id":"313753e9-bfda-4ee0-94f6-919ab57dede6","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"7663421b-9b96-4973-a07f-d2f93c2b9ad1","type":"Range1d"}},"left":[{"id":"7dfb0740-0f24-4461-83a3-f0142812d39c","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"313753e9-bfda-4ee0-94f6-919ab57dede6","type":"LinearAxis"},{"id":"8b50c811-f8fd-4d57-a976-0639e7fdfd26","type":"Grid"},{"id":"7dfb0740-0f24-4461-83a3-f0142812d39c","type":"LinearAxis"},{"id":"84eb4d49-6b09-48e6-9f83-cb4029efe958","type":"Grid"},{"id":"c3e2211d-8e5e-4f29-a1f8-0b9b5fde43cc","type":"Legend"},{"id":"89ca11c9-e348-4575-a936-a748fdc9a58d","type":"GlyphRenderer"},{"id":"96568603-0248-421c-bd09-42c8a6933e20","type":"GlyphRenderer"},{"id":"dcdaee22-b44d-40bd-8e41-1de0d88d26fd","type":"GlyphRenderer"},{"id":"801791d6-232b-4e3a-8bee-d3438d199376","type":"GlyphRenderer"},{"id":"c19e3e25-ea23-4a1d-b3a9-f1c265c98afc","type":"GlyphRenderer"},{"id":"e8dbbbdf-d1c8-4763-bfce-3e532912a0b4","type":"GlyphRenderer"},{"id":"099c85e3-d695-438f-a9c2-e6d3c06179d1","type":"GlyphRenderer"},{"id":"88c21c95-a5d6-4638-9989-e1171ac8d21d","type":"GlyphRenderer"},{"id":"ea96fb60-cd6c-4ae1-acc2-14ed602d3143","type":"GlyphRenderer"},{"id":"93fdf307-0c60-4776-a345-13fce320fe5a","type":"GlyphRenderer"},{"id":"047202d2-6122-4dcb-b1d2-94290b083af6","type":"GlyphRenderer"},{"id":"d5be11d3-efc7-40f7-b7de-12b8ee8f5a5d","type":"GlyphRenderer"},{"id":"8b7af0e4-7391-45bd-97aa-443b0092e706","type":"GlyphRenderer"},{"id":"bb2f8aca-3e25-4315-a154-bb2555f4bc59","type":"GlyphRenderer"},{"id":"28e9a0ec-17e5-4708-b093-0ff8e28b7c4d","type":"GlyphRenderer"},{"id":"e2d45f86-c973-4e4b-98c7-48b1f6e4ad3a","type":"GlyphRenderer"},{"id":"832ddfdf-0938-42a4-911e-9c2fb7747bcd","type":"GlyphRenderer"},{"id":"c1bfe955-3d69-4a25-8036-3f0c83c56ac7","type":"GlyphRenderer"},{"id":"922c5d6d-ad92-4a3b-b33d-6706eeef0d67","type":"GlyphRenderer"},{"id":"9684efc8-659b-4fb0-a41c-715a885248fd","type":"GlyphRenderer"},{"id":"dc817c69-178c-4c89-856c-55e3ea8f5709","type":"GlyphRenderer"},{"id":"1499adb8-0569-4b5c-9ec1-47a456b74d6e","type":"GlyphRenderer"},{"id":"24f521a9-af4e-4ae5-be48-8b2f4850c743","type":"GlyphRenderer"},{"id":"bce12821-aa20-4cfd-a824-0ac277673e5a","type":"GlyphRenderer"},{"id":"00ef901b-1f2c-498d-9304-2fb4bcf1c27a","type":"LinearAxis"}],"right":[{"id":"00ef901b-1f2c-498d-9304-2fb4bcf1c27a","type":"LinearAxis"}],"title":"PubChem CID 6603792","tool_events":{"id":"b3f6dcff-0056-46ed-9edb-e0f6d8c6c6f1","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"1d04cacb-89ee-4e9c-876b-513b998b30df","type":"PreviewSaveTool"},{"id":"b6e38909-3ae3-4b22-9658-0cd044a41d0f","type":"TapTool"},{"id":"248da0e3-f062-4024-beab-68606adafb5a","type":"HoverTool"},{"id":"8bda0cfc-1b0d-4f56-b58b-6e1843ebb060","type":"HoverTool"}],"x_range":{"id":"05d14e5b-bf82-44be-981a-c407e02b5157","type":"Range1d"},"y_range":{"id":"6674531c-a998-44e8-96e0-71a56eef3dd5","type":"Range1d"}},"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"66c5d0ca-f111-4f4b-be34-a7b4ac0d8310","type":"Circle"},{"attributes":{"data_source":{"id":"e8c8c777-aa58-4fbc-b82c-38bdd1d63f3d","type":"ColumnDataSource"},"glyph":{"id":"734e50b1-272a-4007-821f-4c7adefdec21","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"2d9bfcb5-c6ba-4a75-bc48-75a37a24292b","type":"Wedge"},"selection_glyph":null},"id":"7bb4c8f3-e299-4739-8e5e-450211d56549","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"01ea75a1-8d37-4736-a323-0e0d3313a33c","type":"Text"},{"attributes":{"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"}},"id":"73e4db49-edf0-47f7-9507-73c55baf7d5d","type":"PreviewSaveTool"},{"attributes":{},"id":"199028c7-f98c-4b5e-a5e9-aea815dec55e","type":"BasicTickFormatter"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c16d1c0c-4784-4685-911f-3ece1d4169e4","type":"Text"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"65d30c96-9214-4adf-97f5-c555b2a79414","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"1e2af17c-7965-455e-a796-f7d6c508e346","type":"Line"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0c6da62d-010f-43f3-af54-9c1bb325a038","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"7d73e36b-ce14-4ae1-a2c3-bd91da75ae04","type":"Line"},{"attributes":{"data_source":{"id":"941537c6-1b6f-4640-9c37-155113cc2b31","type":"ColumnDataSource"},"glyph":{"id":"8afe975b-ea52-42c5-8ee2-a928017d01ca","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"71a74448-c788-4bd6-9e6a-2671ae97c1c6","type":"Text"},"selection_glyph":null},"id":"90bfdb49-0ab4-4809-9f3d-f4017311f145","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c590c3d1-bd69-4c7e-b193-769f55cb3110","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"01d9f5f6-409e-482d-a703-892996f89017","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[7015.0,785.0,3267.0,2040.0,3033538.0,156414.0],"Confidence":["1.18","1.09","1.09","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.62,0.58,0.54],"alpha":[0.16857142857142857,0.15571428571428572,0.15571428571428572,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#b30000","#b30000","#b30000","#b30000"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#b30000","#b30000","#b30000","#b30000"],"radius":[0.00842857142857143,0.0077857142857142864,0.0077857142857142864,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.5626415094339623,0.5218181818181817,0.47623188405797107]}},"id":"4dc1e9cc-5c80-4b7b-b11b-17e5c2047a25","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"ce479310-5f10-406b-8715-c30296fdc5d6","type":"BasicTickFormatter"},"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"ticker":{"id":"165b8a5d-e2ca-4e13-bb30-b5d3379829dd","type":"FixedTicker"}},"id":"0cd188be-9241-4249-8206-83d50d7b5f33","type":"LinearAxis"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"ticker":{"id":"f307618b-010b-4afa-953f-d0fc1deb099f","type":"BasicTicker"}},"id":"48f8608a-294e-492b-b03a-330e20a909f6","type":"Grid"},{"attributes":{"data_source":{"id":"95e9df1b-b331-4abe-97fc-5ad18bca918b","type":"ColumnDataSource"},"glyph":{"id":"0dd9c740-96ad-4a35-9d3e-78337c9c0545","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"b674f930-c1a3-405d-bac5-245a13bba3d7","type":"Wedge"},"selection_glyph":null},"id":"426e3582-f522-4c54-9db1-0dd43b83e6c8","type":"GlyphRenderer"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3cc5f8df-4384-473d-a7d3-bbcc3c82f8a2","type":"Wedge"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"76912a12-5241-4899-9584-a8580e9ae339","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"c79c3885-b884-48d0-8447-72fb1e03f2f7","type":"GlyphRenderer"}]],["Active",[{"id":"60839618-03f0-4cd8-92ae-976a6ecb0069","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"}},"id":"49b9e056-4ffa-43f5-a0c9-637b1ac1cbd8","type":"Legend"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[3562.0,9128.0,5280378.0],"Confidence":[1.36,1.36,1.36],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.1942857142857143,0.1942857142857143,0.1942857142857143],"fill_color":["#228B22","#228B22","#b30000"],"index":[3,4,5],"line_color":["#228B22","#228B22","#b30000"],"radius":[0.009714285714285717,0.009714285714285717,0.009714285714285717],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"cd538a5a-1c96-4a16-8f9c-0318efa64fff","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"1808d6ab-a0df-40bc-9b23-5540776f19fc","type":"Quad"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5b67abd7-cd66-4b70-9365-c664a2ee1e02","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ec2d8e47-1359-42d7-bdb7-ba316fc6cc43","type":"Line"},{"attributes":{"callback":null,"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"renderers":[{"id":"22fcdf47-9b84-42a1-b79d-775fc368b805","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"99000ee0-7e8d-4484-b79d-38380d8a3f54","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"7b3e44f9-2c48-4c5f-88bf-998633a2358c","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0790422a-58e5-4e70-90fb-08ae8daea845","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"672c6fdf-3026-4317-ab7b-6b64fd0bcc93","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6b66ab61-47db-40e1-a645-135856493365","type":"Circle"},{"attributes":{"data_source":{"id":"337c3232-2e0d-4e60-85d4-674e0820755f","type":"ColumnDataSource"},"glyph":{"id":"f6240f89-c6be-4dae-a4ea-99682544bf81","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"82c2336a-38c2-4866-8b7b-4407d0ba69e4","type":"Circle"},"selection_glyph":null},"id":"e5f50dd2-0674-425d-b102-8e08cbab0330","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c2211048-7a40-4264-a836-3b1531e77651","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"10e357fe-7f91-4e99-8c0d-0ca725c422df","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"af178a6f-6f8e-4ee1-a523-c809322900a8","type":"Range1d"},{"attributes":{},"id":"f307618b-010b-4afa-953f-d0fc1deb099f","type":"BasicTicker"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"0d2d6c68-3e3c-441a-a979-28a5b74bd384","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"9fdf582a-ca1f-4672-8e6c-ab3501e891f8","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"7bb6e3ee-3cee-4655-85ad-3dc59495c8bd","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"172d4829-5beb-4331-a322-6aa70253d36e","type":"ColumnDataSource"},"glyph":{"id":"9d75df10-4138-4b97-8cb5-c98c07c7f083","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"2b37092b-fdf5-4566-aac3-1cfb50e8f574","type":"Text"},"selection_glyph":null},"id":"aa8a1fb5-b004-474b-988e-10aeb0997b21","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"681e8530-66e1-4f1e-9bd4-731c5c0a634f","type":"ColumnDataSource"},"glyph":{"id":"da5ad670-2ec5-4126-ad9c-62d64131e9b4","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"766f0168-e205-4a30-9dc4-761aee229ac9","type":"Line"},"selection_glyph":null},"id":"57de1767-cf11-4648-88a3-52d715245533","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"e25f92d0-282b-4de5-9237-052a70cf555b","type":"ColumnDataSource"},"glyph":{"id":"ea952f86-52aa-4e2b-93b1-909ce0dfb93b","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"e02bbfac-2418-4c37-8000-8ddfa20b396a","type":"Text"},"selection_glyph":null},"id":"93fdf307-0c60-4776-a345-13fce320fe5a","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3b42612d-f068-40d7-9f29-c3705e35fcd2","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fa656699-fd10-4c99-9f11-6bebebb4741d","type":"Line"},{"attributes":{},"id":"246c06cf-74cb-4f12-a446-646f20c35a3c","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"46dcf49b-6962-42d6-a38a-7e8ec5f09055","type":"Circle"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a5e66d7b-ade9-46f8-9b05-d41c28349c4f","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"ce45b578-4121-480a-b4eb-5d53f59d7ae9","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e0677b09-2dc0-485c-ac2a-b4ea7bb94b9f","type":"Circle"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4dda91dd-6dd2-4fcf-90fe-f20016a8901e","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3dff6048-f84e-4fa5-8c04-32a446ec509d","type":"Text"},{"attributes":{"data_source":{"id":"924d995a-e133-4d6a-a7e6-6ad11f26feb8","type":"ColumnDataSource"},"glyph":{"id":"9807eabc-121a-49e3-90d3-8072c7473db0","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"758f1f5f-339a-4d51-9d85-64fd88ef7465","type":"Text"},"selection_glyph":null},"id":"1719488f-edbd-498e-9e3e-04854ff22345","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"a1b23c7c-565a-4232-abd8-bdad1d6292e0","type":"BasicTickFormatter"},"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"ticker":{"id":"0d2d6c68-3e3c-441a-a979-28a5b74bd384","type":"FixedTicker"},"y_range_name":"category"},"id":"f79953ee-33b5-4357-bb5d-e09260fbb02e","type":"LinearAxis"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7f478e2d-cb62-4754-8f53-e3e5b46cc20a","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"501cb08e-807e-4d9e-b8c7-9b8829b3dcfe","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"d248e39f-ced3-4190-982d-3c27b8c1024a","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"22fe2955-bef8-4790-8ef9-b0c819294a48","type":"Quad"},{"attributes":{"data_source":{"id":"b24d1469-ed35-4833-a65a-b995649f9b63","type":"ColumnDataSource"},"glyph":{"id":"ab21de95-f3c2-4a1c-ad9f-dd153a1ebee4","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"4324f6fd-cdea-4894-8a5b-7a635fcb87a4","type":"Text"},"selection_glyph":null},"id":"adf6adbd-226e-4861-a4ef-41a0b3c840af","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"dfb4e009-b667-4402-b404-a4d7831717d8","type":"Circle"},{"attributes":{"formatter":{"id":"016aafd6-3097-4e35-a73a-b6604b895302","type":"BasicTickFormatter"},"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"ticker":{"id":"96c6a709-ff92-49de-8e91-5745e44c9679","type":"FixedTicker"},"y_range_name":"category"},"id":"a51d2b1e-bd37-4a64-8e5e-f91a6999c5f8","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"1a7c2fd1-afe9-488d-955e-be3bf49ebd22","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6b5a3bca-e13a-4e6e-b8d9-fbd901e5fc83","type":"ColumnDataSource"},"glyph":{"id":"b6202455-cfed-4ec7-93b0-29294110a112","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"3738c010-aa8b-43a5-ba3e-73101095f70b","type":"Quad"},"selection_glyph":null},"id":"4d45b8a0-6d91-4fdb-868b-0c17ed8e12bb","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"c4445ec6-3d3c-4985-93a0-c1dd11b0388b","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"3520197b-4ae5-461d-bcf7-d8457175da6e","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"6f662a9e-f132-4efb-85ba-ba21fbdc24da","type":"ColumnDataSource"},"glyph":{"id":"183622ca-7cd9-41c1-9ccc-c2e4f480aea1","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"fd07b0a5-e6a6-497a-b746-74d3575de365","type":"Circle"},"selection_glyph":null},"id":"4235ec72-974d-4bd5-9bfb-d5b787d0fefa","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6e2322e1-65a4-4a69-86bf-457192fdb0f8","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"027496ca-8cde-4128-9946-50242e076b74","type":"Range1d"},{"attributes":{"data_source":{"id":"c82cd597-735c-4fff-9141-64ca3c6a674e","type":"ColumnDataSource"},"glyph":{"id":"41d95171-ac37-4d44-bb5a-2e8889932eaa","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"22dec926-18e5-43fe-84bb-79cd932d0fb4","type":"Text"},"selection_glyph":null},"id":"2136b167-775a-40b4-8a1e-27b92b8b83ca","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"bfb12256-9739-4815-a17d-526e0578f041","type":"ColumnDataSource"},"glyph":{"id":"708efe5b-19e6-4b34-9114-607c8a1f7dfe","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b098d7be-b23c-4fd8-baac-58f8abe801a1","type":"Text"},"selection_glyph":null},"id":"d08a23e9-8c5f-467a-abd1-2f91a124980e","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e515a6cc-6ae1-4e79-94c0-f1a4923cbc62","type":"Text"},{"attributes":{"below":[{"id":"ce3e831a-0f59-4421-ba92-f74e68c89ba9","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"50e4d2f0-0c78-468c-ae37-23603638b645","type":"Range1d"}},"left":[{"id":"e9dc2665-b412-488f-870b-e96e1fda9014","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"ce3e831a-0f59-4421-ba92-f74e68c89ba9","type":"LinearAxis"},{"id":"8a6d09d6-f892-4cc2-92ec-730c5b00ddf8","type":"Grid"},{"id":"e9dc2665-b412-488f-870b-e96e1fda9014","type":"LinearAxis"},{"id":"b29a9d19-b6cc-468d-8049-8e81ea52acd7","type":"Grid"},{"id":"1b5a40d1-3b64-4a75-99cf-1b41e6c998a5","type":"Legend"},{"id":"c4fdbb70-e0e2-44c5-b1f3-974694ac13ac","type":"GlyphRenderer"},{"id":"7ccdb1d2-a3d6-4e3e-a3cf-385e62831c3c","type":"GlyphRenderer"},{"id":"7b0603a5-c8b3-4993-937b-7f33b98193bc","type":"GlyphRenderer"},{"id":"baf98ef5-4fbd-48fb-8bb3-adc3a7245aa4","type":"GlyphRenderer"},{"id":"f32ce353-6c23-450b-a6c5-dac8a7aaa0ec","type":"GlyphRenderer"},{"id":"9849d424-9016-4662-9a6c-b3feea5ff7c2","type":"GlyphRenderer"},{"id":"92053d85-a75b-4104-b1f4-996d09ffbcd6","type":"GlyphRenderer"},{"id":"2fff4572-0c80-4f7e-bb4d-80e8813a5e3f","type":"GlyphRenderer"},{"id":"e3d5b38b-566c-475f-af2e-8a6aafceb385","type":"GlyphRenderer"},{"id":"d209e31d-9e92-47f6-9283-1d18a4e8af14","type":"GlyphRenderer"},{"id":"fb55c4aa-42d9-4087-ab37-7031818b8866","type":"GlyphRenderer"},{"id":"511ec524-cb39-4e4a-82bb-55914a0deb68","type":"GlyphRenderer"},{"id":"2acc4e09-187f-4c7a-959f-2503d4489378","type":"GlyphRenderer"},{"id":"91172816-298a-4042-9bd3-9449d670cb49","type":"GlyphRenderer"},{"id":"cf123a53-3757-49b2-83bf-d68ae4d2df81","type":"GlyphRenderer"},{"id":"2265de28-0b62-4b28-b761-41e32517dd76","type":"GlyphRenderer"},{"id":"f22fcf0b-17bb-4e7d-87cd-735038f16177","type":"GlyphRenderer"},{"id":"ac24ba21-09f8-4243-8550-4f7e4dfbc17f","type":"GlyphRenderer"},{"id":"bab6f652-f672-47aa-8af6-9d30a9d44f65","type":"GlyphRenderer"},{"id":"4235ec72-974d-4bd5-9bfb-d5b787d0fefa","type":"GlyphRenderer"},{"id":"94b052a8-beb4-417f-884c-8980044c1e82","type":"GlyphRenderer"},{"id":"d1920de6-ede9-4281-a3e0-5625ab3c3834","type":"GlyphRenderer"},{"id":"78cf289e-d801-4b46-aab0-f9d3e2d3aa0d","type":"GlyphRenderer"},{"id":"426e3582-f522-4c54-9db1-0dd43b83e6c8","type":"GlyphRenderer"},{"id":"a51d2b1e-bd37-4a64-8e5e-f91a6999c5f8","type":"LinearAxis"}],"right":[{"id":"a51d2b1e-bd37-4a64-8e5e-f91a6999c5f8","type":"LinearAxis"}],"title":"PubChem CID 1245","tool_events":{"id":"5b08d41c-27a4-43b6-9e2d-6ffecbd333d7","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"60d10184-9f60-4859-ab46-f9e086c3efe7","type":"PreviewSaveTool"},{"id":"9877848e-2182-486b-8709-e6df80243d2c","type":"TapTool"},{"id":"098c3dc1-49e0-4b78-a972-4cfe2d3226b4","type":"HoverTool"},{"id":"393e8f54-f093-4e51-a5c8-4ae8d1d3efaf","type":"HoverTool"}],"x_range":{"id":"6c6b8449-de46-4c98-99a5-96b28bdc9312","type":"Range1d"},"y_range":{"id":"6005ef5b-7eb9-466a-bdfa-da55af3853d0","type":"Range1d"}},"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[1.0,0.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#228B22"],"index":[0,1],"line_color":["#b30000","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[1.0,0.0]}},"id":"bf8946a5-5976-48ed-8339-10ed0a7b5af8","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[0.06],"y":[1]}},"id":"941537c6-1b6f-4640-9c37-155113cc2b31","type":"ColumnDataSource"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"ticker":{"id":"3190fb7d-eb5d-427b-b86b-16f3798ebf5d","type":"BasicTicker"}},"id":"84eb4d49-6b09-48e6-9f83-cb4029efe958","type":"Grid"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fcd1f9aa-83b7-4801-ac34-147ac66512f5","type":"Text"},{"attributes":{"callback":null,"start":-1},"id":"3f3ba71b-400c-4185-9c78-fe18a6039f6f","type":"Range1d"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"ticker":{"id":"cb493db0-8912-4067-883f-71410bb92e27","type":"BasicTicker"}},"id":"b29a9d19-b6cc-468d-8049-8e81ea52acd7","type":"Grid"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"b3c19a96-003e-4116-82a2-62790fae37a1","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ea2bcaf0-e05f-4d7b-b25d-1980c5c9aa7c","type":"Text"},{"attributes":{"data_source":{"id":"999feb1a-9da2-47ad-b062-3e8c53bec416","type":"ColumnDataSource"},"glyph":{"id":"26999570-2038-4e2b-842d-7d0b35ccf97d","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"b6560264-75b6-4602-a324-79bb05660f20","type":"Circle"},"selection_glyph":null},"id":"cff1fe24-e5fd-4fe0-99f2-e0c6f34cb2f5","type":"GlyphRenderer"},{"attributes":{"callback":null,"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"renderers":[{"id":"8594a800-a3a8-4478-8fc2-53cde8cb98fa","type":"GlyphRenderer"},{"id":"dc4e92c6-5741-491e-858c-cfab060e5f08","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"86e4a926-3814-404e-a727-2d2c0c2edc9a","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"43878629-34c7-48a3-a1f5-ec9022cd3b63","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0d0e8298-f2da-41f7-a60c-9dec6d9c6961","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0,3415.0,409069.0,500165.0],"Confidence":["0.45","0.45","0.45","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.56,0.49,0.44],"alpha":[0.0642857142857143,0.0642857142857143,0.0642857142857143,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#228B22"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#228B22"],"radius":[0.0032142857142857147,0.0032142857142857147,0.0032142857142857147,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.4955555555555556,0.4301960784313725,0.3775]}},"id":"be070e15-886c-46f4-aedb-9b2949e52f99","type":"ColumnDataSource"},{"attributes":{"callback":null,"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"renderers":[{"id":"dc817c69-178c-4c89-856c-55e3ea8f5709","type":"GlyphRenderer"},{"id":"1499adb8-0569-4b5c-9ec1-47a456b74d6e","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"248da0e3-f062-4024-beab-68606adafb5a","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"05398eca-ab7e-43b7-8dd8-f2925abca9b5","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19848da1-0616-4c05-a77f-3f102d538938","type":"Line"},{"attributes":{"fill_color":{"value":"#9a9a9a"},"line_color":{"value":"#9a9a9a"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b327041a-3613-4f79-90b0-ec212821e260","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"36792f09-b23b-4255-9682-60243ea0ea2d","type":"ColumnDataSource"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2e503e58-98ea-4e44-8a9e-b93c83e42d42","type":"Wedge"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"ac0c13c4-fff5-4f32-a93d-64af7fbe839a","type":"Line"},{"attributes":{"data_source":{"id":"d248e39f-ced3-4190-982d-3c27b8c1024a","type":"ColumnDataSource"},"glyph":{"id":"0697b93d-492a-481b-a1d2-72ff3fe9b287","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"ec2d8e47-1359-42d7-bdb7-ba316fc6cc43","type":"Line"},"selection_glyph":null},"id":"5c99540a-9cae-4ae7-93d2-898c74454fc8","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"674f9e49-4aca-4a10-8dcd-c9eb65c17f3d","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[3033538.0,10127622.0,2040.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.53,0.41,0.4],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000"],"index":[6,7,8],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.5294117647058824,0.4084507042253521,0.4]}},"id":"665c8db3-830b-4a6a-bec8-7a216091ef53","type":"ColumnDataSource"},{"attributes":{},"id":"ea317f6f-4031-499a-8263-d69b5513eb5f","type":"BasicTickFormatter"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"80169d3a-10c3-4022-a185-525f933c188c","type":"Circle"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3fdbb246-46d6-4970-997e-174d2fc137af","type":"Text"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"225f1a56-8c9f-42a6-90a1-1a09aecf490e","type":"Circle"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f343d8d3-e730-42f9-bd37-312ff0dd27f6","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[15910.0,3468.0,4921.0],"Confidence":[4.09,2.0,2.0],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.5842857142857143,0.2857142857142857,0.2857142857142857],"fill_color":["#b30000","#b30000","#b30000"],"index":[3,4,5],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.029214285714285717,0.014285714285714285,0.014285714285714285],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"f8e396c7-9f92-4f81-bfa8-ee0034640062","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"ef52d890-cc26-462e-ac39-6375bd5e7e26","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f32c8ed9-3b39-4796-8b0b-1f68d588c1de","type":"Circle"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3fe34616-1e3f-492e-92e6-cb032254a597","type":"Circle"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"f6b35e06-5b03-416d-bbd0-7383eda28985","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"78dacfbe-86c6-4099-85b2-5a63c988da5b","type":"ColumnDataSource"},"glyph":{"id":"46e8ab0c-bcbd-4229-8ec7-6213852ce9e8","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"8deb7732-400b-40a2-940a-3ec5d04ef293","type":"Line"},"selection_glyph":null},"id":"688d1749-2ef0-4f81-8618-c1645d939fcb","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8292852c-bd0c-46ad-987b-ad62511cca2b","type":"Text"},{"attributes":{},"id":"4873df9b-5b5f-428e-923e-dde6b1ca14f5","type":"ToolEvents"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"29daf99e-1a5b-4745-a6b4-e4ff1b99d0d6","type":"Line"},{"attributes":{},"id":"a6957cff-7843-45af-a234-8437748de3ea","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"9d969833-afba-414a-8e4a-962f550847a6","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b8be4c0f-9eb2-4535-8e58-7551bfb2df02","type":"Text"},{"attributes":{"data_source":{"id":"d3c59497-cd38-4d37-9b14-1cef14bc8d36","type":"ColumnDataSource"},"glyph":{"id":"c24c2685-3be4-4107-80d1-5b089c16af4c","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"de385f2e-a40b-479a-a207-a31879f5800f","type":"Text"},"selection_glyph":null},"id":"bab6f652-f672-47aa-8af6-9d30a9d44f65","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"c7147948-777d-459a-a03c-e1bf0da86402","type":"ColumnDataSource"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"6674531c-a998-44e8-96e0-71a56eef3dd5","type":"Range1d"},{"attributes":{"formatter":{"id":"04e89aea-1b88-4058-a8bf-62a8e3cdefc9","type":"BasicTickFormatter"},"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"ticker":{"id":"ea6eee16-91f2-4a28-94be-83c9ce2691d4","type":"FixedTicker"}},"id":"78509fc0-c406-4972-b6d3-23bc47d15384","type":"LinearAxis"},{"attributes":{},"id":"87c40296-20d8-4feb-b8ca-950faa5d94a0","type":"BasicTicker"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c5cb83cd-36fa-49c1-a6d6-29b19f9fcee5","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"15ee8333-4a57-4fa9-8bac-f8a2f4a879f2","type":"Text"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"877a44cd-fe77-4154-9425-e47f26bee2c7","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"5e4a6dc1-5951-4c84-962a-cac59ed79afc","type":"ColumnDataSource"},{"attributes":{"callback":null,"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"renderers":[{"id":"66a0b292-11ef-47c8-b142-cbf862a14436","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"c91d26e1-641f-4b5f-9362-47f83dcf86e5","type":"HoverTool"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5e0265b0-8f14-4c06-a0fb-dac8d148ddca","type":"Line"},{"attributes":{},"id":"a1b23c7c-565a-4232-abd8-bdad1d6292e0","type":"BasicTickFormatter"},{"attributes":{"data_source":{"id":"e9a1cc4b-38a7-4ca6-a52a-1385a24d13d6","type":"ColumnDataSource"},"glyph":{"id":"c4445ec6-3d3c-4985-93a0-c1dd11b0388b","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"20e9d9fe-7280-414a-b389-46ebaab1c39d","type":"Line"},"selection_glyph":null},"id":"384be773-57f2-4bf4-a7cc-1d0762be7373","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4324f6fd-cdea-4894-8a5b-7a635fcb87a4","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"36449d9f-9de8-432b-ba6e-3172a29228fb","type":"Text"},{"attributes":{"data_source":{"id":"be1b0284-8117-409f-8aae-6699500a6324","type":"ColumnDataSource"},"glyph":{"id":"6e2322e1-65a4-4a69-86bf-457192fdb0f8","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"24b16bc1-b6f8-4021-a522-a786ec5e7e64","type":"Text"},"selection_glyph":null},"id":"bb2f8aca-3e25-4315-a154-bb2555f4bc59","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"de61e24e-8850-4c4a-b577-a1ef23492989","type":"ColumnDataSource"},"glyph":{"id":"44f42cf7-b0d6-4f3c-9648-b889bd5d9eab","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"ec16493c-4521-404b-bf34-ee42aedcc823","type":"Line"},"selection_glyph":null},"id":"6c5a288b-a2d0-49c9-9703-1373c4317764","type":"GlyphRenderer"},{"attributes":{"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"}},"id":"1d04cacb-89ee-4e9c-876b-513b998b30df","type":"PreviewSaveTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"06fbe35e-e691-4228-bd65-238ae24c2a37","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"ea0fb058-b6c8-4419-b525-f8a5525c0404","type":"Quad"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c1bf55ae-2879-4d62-b210-f8b5a8c6780b","type":"Circle"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"165b8a5d-e2ca-4e13-bb30-b5d3379829dd","type":"FixedTicker"},{"attributes":{"callback":null,"plot":{"id":"69f683bf-8b7c-4adb-b6b8-8f141703c344","subtype":"Figure","type":"Plot"},"renderers":[{"id":"426e3582-f522-4c54-9db1-0dd43b83e6c8","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"393e8f54-f093-4e51-a5c8-4ae8d1d3efaf","type":"HoverTool"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"60acdc8b-e434-4a96-b4a2-a5e50a128979","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"b3541ccd-0775-4b72-a714-1b0042c582f0","type":"ColumnDataSource"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d3ec6ba6-78cf-4f20-8c2c-1d54082a0aaf","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ab21de95-f3c2-4a1c-ad9f-dd153a1ebee4","type":"Text"},{"attributes":{"data_source":{"id":"f048037a-1943-49e1-a0c3-c1ed2bd7715c","type":"ColumnDataSource"},"glyph":{"id":"799aae23-3355-4892-a4e0-220d39b18737","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"c590c3d1-bd69-4c7e-b193-769f55cb3110","type":"Circle"},"selection_glyph":null},"id":"66d97b7c-fdfb-4b2c-a544-9bad12d47573","type":"GlyphRenderer"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"83e79488-7c91-49a1-accc-7ca67679be94","type":"FixedTicker"},{"attributes":{"data_source":{"id":"18c0ccee-d865-4755-bb85-78e3df7102f8","type":"ColumnDataSource"},"glyph":{"id":"0f252a7e-d21d-424f-935a-32aa9e68e6bc","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"2cafd5ae-e5a9-4847-a5c9-ed6a7f182006","type":"Text"},"selection_glyph":null},"id":"922c5d6d-ad92-4a3b-b33d-6706eeef0d67","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"0dc47928-d0e0-42b2-86d7-57bb0d8267e1","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"5957f597-8a2a-447f-ae12-bdbe4c2a9a72","type":"Quad"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"293fe221-ab64-4178-af68-1155dde2ed98","type":"ColumnDataSource"},{"attributes":{},"id":"995e1964-eb9a-42d5-a309-07085f008c74","type":"BasicTickFormatter"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7c7a6b27-76c6-49ea-b303-905cdbddd985","type":"Text"},{"attributes":{"data_source":{"id":"04bc41ea-792d-4df9-9354-21dfcf4d42f3","type":"ColumnDataSource"},"glyph":{"id":"7ae9bb71-f5b0-4d0f-a5cb-acb1df553114","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"e8a23e38-2ab4-4b23-9ae4-59b4f1d7cc0a","type":"Line"},"selection_glyph":null},"id":"029a745d-2dd4-4064-903e-d4042827252e","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"ac312c1f-8c31-4281-ae6c-84469c90b26e","type":"BasicTickFormatter"},"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"ticker":{"id":"2307b872-03cf-41cc-b8ff-3041a9e6053e","type":"FixedTicker"},"y_range_name":"category"},"id":"390b7c26-224b-49c5-8e58-821f35d08f08","type":"LinearAxis"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"b6202455-cfed-4ec7-93b0-29294110a112","type":"Quad"},{"attributes":{"callback":null,"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"renderers":[{"id":"12562961-57dc-4877-8c4b-402a8d76ef1d","type":"GlyphRenderer"},{"id":"352c9286-8247-488c-9f36-05efe6d6cb79","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"c3179690-7b57-4128-b6a0-7582645082b5","type":"HoverTool"},{"attributes":{"dimension":1,"grid_line_color":{"value":null},"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"ticker":{"id":"a6957cff-7843-45af-a234-8437748de3ea","type":"BasicTicker"}},"id":"e0484dd5-5682-42d7-8738-2b2b8c84bf94","type":"Grid"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"00ad7dbb-0808-46e3-8de8-7baa1c5ebaa1","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"b1cae29d-8cb8-4496-8eb3-7a05064363ca","type":"Range1d"},{"attributes":{},"id":"cb493db0-8912-4067-883f-71410bb92e27","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0],"Confidence":[0.45,0.45,0.45],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.0642857142857143,0.0642857142857143,0.0642857142857143],"fill_color":["#228B22","#228B22","#228B22"],"index":[3,4,5],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.0032142857142857147,0.0032142857142857147,0.0032142857142857147],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"bb911975-57e6-4956-aba1-d7266f404145","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"035a82f6-d82a-45bd-9519-780f249ca4d1","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"0f29d8c4-ee90-43ce-b5d9-bbdb9db7b719","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"6f4635e3-17a8-49c9-add4-1599d0703458","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"66f08f5b-3496-4b67-a250-6ea4cefcd8c0","type":"Text"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"ticker":{"id":"b2e8bdae-de82-4a02-8258-06a526f1d357","type":"BasicTicker"}},"id":"184cfca4-0fd6-44e8-a91c-6f3a0f0acc2c","type":"Grid"},{"attributes":{"callback":null,"plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"},"renderers":[{"id":"bce12821-aa20-4cfd-a824-0ac277673e5a","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"8bda0cfc-1b0d-4f56-b58b-6e1843ebb060","type":"HoverTool"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7f05898c-08df-42d1-83b9-00b3127d9cf4","type":"Circle"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"66e27df2-d7b7-4cab-a720-4b6630d8f204","type":"Line"},{"attributes":{"formatter":{"id":"6ed3dc5a-3617-4701-ae9b-676d26d7f1be","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"450aa568-a859-4858-99d1-3e38c634f3a3","subtype":"Figure","type":"Plot"},"ticker":{"id":"cf912c73-c521-48f5-9c7b-a6bf8f61d13d","type":"BasicTicker"}},"id":"6b868da8-0196-4769-ae56-266ce9b19bb5","type":"LinearAxis"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"11b649c1-2533-4549-917e-b9ca28bbe439","type":"Text"},{"attributes":{"below":[{"id":"ccd29176-c24a-4038-ad03-46b01ffb8c09","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"8ae8fa4a-a552-407e-b160-d6db47172c74","type":"Range1d"}},"left":[{"id":"66642c04-6c37-4452-949f-592a78fc183f","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"ccd29176-c24a-4038-ad03-46b01ffb8c09","type":"LinearAxis"},{"id":"b0f2b8a3-228a-48b3-af0f-6ecd688fd2a8","type":"Grid"},{"id":"66642c04-6c37-4452-949f-592a78fc183f","type":"LinearAxis"},{"id":"31f8bcdc-1982-4a32-977a-f3a2bf0d703b","type":"Grid"},{"id":"e9acedbc-6672-4de5-80f0-39fcb0e5297f","type":"Legend"},{"id":"3988cb34-9e28-42bd-ae9f-32421a950e04","type":"GlyphRenderer"},{"id":"0c472726-c370-4a4e-94f4-73e22b07ef3b","type":"GlyphRenderer"},{"id":"3b6cc46b-3623-4c6e-a244-78a18f65e619","type":"GlyphRenderer"},{"id":"1c59bd8f-9998-4f07-89a3-97d945fa0db8","type":"GlyphRenderer"},{"id":"ab27df8e-54d1-4808-88a1-ea4122dfd73f","type":"GlyphRenderer"},{"id":"19fb93c0-e72e-4c93-97f0-49f307a04896","type":"GlyphRenderer"},{"id":"eda78574-5b43-4173-866f-ba28094d16a0","type":"GlyphRenderer"},{"id":"530fb576-c3e6-4387-ae80-4767c02906f1","type":"GlyphRenderer"},{"id":"c3efb726-f1b1-44c6-96e1-4702f03a322b","type":"GlyphRenderer"},{"id":"3f9328fe-31a5-4f45-b62b-eb81d08dc9fc","type":"GlyphRenderer"},{"id":"fcdf32e6-b4ec-4dce-a144-b98edd30b793","type":"GlyphRenderer"},{"id":"3cde3213-3d1a-4706-9df0-53bd3d7c42f6","type":"GlyphRenderer"},{"id":"9441da83-3c1a-4960-92a0-c37a3acd9bab","type":"GlyphRenderer"},{"id":"3a8a27fd-efc5-4c0e-9617-7b90e28f39c3","type":"GlyphRenderer"},{"id":"0e11da23-c116-4033-a06f-56f0123b619f","type":"GlyphRenderer"},{"id":"5c99540a-9cae-4ae7-93d2-898c74454fc8","type":"GlyphRenderer"},{"id":"688d1749-2ef0-4f81-8618-c1645d939fcb","type":"GlyphRenderer"},{"id":"93ea5ea0-3e6e-4fc1-9be3-526f468ba636","type":"GlyphRenderer"},{"id":"90bfdb49-0ab4-4809-9f3d-f4017311f145","type":"GlyphRenderer"},{"id":"544a0999-1810-4205-970c-80a33ac21467","type":"GlyphRenderer"},{"id":"8594a800-a3a8-4478-8fc2-53cde8cb98fa","type":"GlyphRenderer"},{"id":"dc4e92c6-5741-491e-858c-cfab060e5f08","type":"GlyphRenderer"},{"id":"82164310-ce9c-4b4b-8643-d14aa41ce1aa","type":"GlyphRenderer"},{"id":"662760c6-1f2c-4d92-9b16-bec25a6ffd70","type":"GlyphRenderer"},{"id":"f79953ee-33b5-4357-bb5d-e09260fbb02e","type":"LinearAxis"}],"right":[{"id":"f79953ee-33b5-4357-bb5d-e09260fbb02e","type":"LinearAxis"}],"title":"PubChem CID 3585","tool_events":{"id":"58522dbe-4e4b-4a47-b95c-5ea5c6e6e102","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"20da2345-0e34-426a-a7c8-f1fab625093e","type":"PreviewSaveTool"},{"id":"4b3c3212-38b1-4025-947a-83bc53117059","type":"TapTool"},{"id":"86e4a926-3814-404e-a727-2d2c0c2edc9a","type":"HoverTool"},{"id":"d539c2a0-cd42-4ccd-b099-7a909c6944ad","type":"HoverTool"}],"x_range":{"id":"46b14668-f60e-4666-afa3-65ba8f69277f","type":"Range1d"},"y_range":{"id":"88934f4e-a72f-4b29-9d7d-91b333cdfeea","type":"Range1d"}},"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"c00cdcf4-2545-481e-9fa4-9b096f01dc30","type":"ColumnDataSource"},"glyph":{"id":"a1e1667c-6c40-4faf-b90f-76067453bce0","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"810b0a79-8788-458b-a3e5-c80cfdad0358","type":"Text"},"selection_glyph":null},"id":"924687f8-ff24-4209-8585-f33f57731118","type":"GlyphRenderer"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"68ca074d-a2cb-433f-b313-a96198f77f0d","type":"Quad"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0e314d8b-646a-40be-b7e0-55670dae8209","type":"Text"},{"attributes":{"data_source":{"id":"579c431c-c816-4e70-877b-336e18fc6414","type":"ColumnDataSource"},"glyph":{"id":"6e57c3e5-b0d2-42f2-98aa-bb4f4b611501","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"aa589f65-501c-4a6e-b9f1-d98e540eed59","type":"Text"},"selection_glyph":null},"id":"7b0fbaea-b14e-484e-8382-b6711ced8018","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"05d78898-e003-4523-bfc1-1fee74e45848","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"8ec60e07-1078-4cf4-a871-4d065b257929","type":"ColumnDataSource"},"glyph":{"id":"1808d6ab-a0df-40bc-9b23-5540776f19fc","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"ea0fb058-b6c8-4419-b525-f8a5525c0404","type":"Quad"},"selection_glyph":null},"id":"92053d85-a75b-4104-b1f4-996d09ffbcd6","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5cb8495b-8ee4-43a4-b3d8-fc5b1158ea99","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f6def0a7-bd37-4f2c-9cdc-4fdff365637d","type":"Text"},{"attributes":{"data_source":{"id":"7bb6e3ee-3cee-4655-85ad-3dc59495c8bd","type":"ColumnDataSource"},"glyph":{"id":"e7132043-2074-454b-8e0e-1db1933c927b","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"346ff4f8-2b14-4f54-a597-f79440bb0cd6","type":"Quad"},"selection_glyph":null},"id":"eda78574-5b43-4173-866f-ba28094d16a0","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"07bb7f39-a54b-4c12-b537-94890f12bf37","type":"Text"},{"attributes":{"callback":null,"plot":{"id":"ae73f079-93a7-47e5-9014-e189818f588f","subtype":"Figure","type":"Plot"},"renderers":[{"id":"0379eb2c-2a18-4cf1-8eda-2a71996b5427","type":"GlyphRenderer"},{"id":"7110b899-f026-42ca-9786-1d81b6e1b175","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"0450cf2f-a8ea-4e7b-9d50-2a10a652da52","type":"HoverTool"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4be58326-fdc8-4ab9-9673-ff8215d408f6","type":"Circle"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"64ab0654-8ec7-4fbb-8b10-fb9b97ad77d9","type":"Text"},{"attributes":{"data_source":{"id":"5b44e5a4-23a0-48f4-8e1c-d43f7059eb84","type":"ColumnDataSource"},"glyph":{"id":"7d73e36b-ce14-4ae1-a2c3-bd91da75ae04","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"2af11ffa-6ca6-4021-9e14-c073d558ff86","type":"Line"},"selection_glyph":null},"id":"61fcf533-d3f2-4a45-a786-6cba09b55b50","type":"GlyphRenderer"},{"attributes":{"callback":null,"start":-1},"id":"46b14668-f60e-4666-afa3-65ba8f69277f","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"125cb809-fe9e-4fbd-934e-e0196a002de2","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"810b0a79-8788-458b-a3e5-c80cfdad0358","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ee01ba9c-e82a-4de6-a0f0-c7ee6479da14","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b3082e22-6745-4638-a36d-4d5766e1539d","type":"Circle"},{"attributes":{"data_source":{"id":"deb79434-ee7f-40b6-9af8-d354121f9499","type":"ColumnDataSource"},"glyph":{"id":"9d95799b-c796-4ed5-9f33-aaaa25292a8f","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"84a0240e-2415-4414-b92d-ac18b17d8862","type":"Text"},"selection_glyph":null},"id":"fe7282e7-b0e5-4d1e-8d62-848b613548d0","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"c48575ae-7228-4d86-ac1d-269110818d8f","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"25596d9d-e99d-49b7-bdf4-962f541167b2","type":"Text"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"4fbedb7b-b867-4a43-9bf1-3d522231e31f","type":"Range1d"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0dd9c740-96ad-4a35-9d3e-78337c9c0545","type":"Wedge"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"c25e190b-71be-4342-8ce6-39ff8fbbe09d","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"738101cd-f0c0-4f13-88c4-882cf276d5b0","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"},"ticker":{"id":"9ee19491-a67e-4dd7-bfb4-9a3a8e894004","type":"BasicTicker"}},"id":"e0bb4cd1-9a4a-4f68-9cf8-12f3269a2dcd","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"6237731e-6c93-4c84-bc3c-7a3b5f7665e4","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f861d908-6b8b-439f-aaf0-24bd0a5272e5","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[1.0,0.3333333333333333],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#228B22"],"index":[0,1],"line_color":["#b30000","#228B22"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[1.0,0.3333333333333333]}},"id":"07e898b1-8c79-45c0-adb5-bc1aad53e140","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[370.0,8371.0,26041.0],"Confidence":[5.0,5.0,5.0],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.7142857142857143,0.7142857142857143,0.7142857142857143],"fill_color":["#228B22","#b30000","#b30000"],"index":[3,4,5],"line_color":["#228B22","#b30000","#b30000"],"radius":[0.03571428571428572,0.03571428571428572,0.03571428571428572],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"f91080fa-ce9e-48c9-882c-89fc92e4aae0","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"da59b435-65a3-47cf-a8d9-5b3618862c27","type":"Text"},{"attributes":{"data_source":{"id":"07e898b1-8c79-45c0-adb5-bc1aad53e140","type":"ColumnDataSource"},"glyph":{"id":"fdeb3acb-64cb-4190-af15-6c05a842b5ea","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"46c98f5b-eb4c-42db-a037-d5e3cbe8ec05","type":"Wedge"},"selection_glyph":null},"id":"bce12821-aa20-4cfd-a824-0ac277673e5a","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"9fdf582a-ca1f-4672-8e6c-ab3501e891f8","type":"ColumnDataSource"},"glyph":{"id":"05da1c0e-eb6d-4c52-a606-a5c7f375ba01","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"7c93e9cd-d018-4f48-845f-9361152fe8dc","type":"Circle"},"selection_glyph":null},"id":"65cb878a-33f1-41b5-b157-2564fa1b1608","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"524f6cca-d873-4175-8ffc-45a6c9ada0b8","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"5d22ff9d-c059-4023-a1b3-105b72c944aa","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"dd6d8286-3e46-4eff-a83e-e30bfe9b5507","type":"ColumnDataSource"},"glyph":{"id":"2f5d45fb-e4a0-4c64-a893-72bde563af4e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b2140d65-a78d-4381-9bab-a7575a11417e","type":"Text"},"selection_glyph":null},"id":"c8af19e3-c376-43ae-a3e8-e4f4d4496d63","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"277bd24e-9f92-4692-8017-3a934bc1023e","type":"Text"},{"attributes":{"data_source":{"id":"45179818-4c59-4351-8e8c-829fd21783d4","type":"ColumnDataSource"},"glyph":{"id":"c8585b67-8e28-44ba-b59d-617651e582eb","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"8b5fadad-713c-4d80-bbfa-3a4c8fbe7149","type":"Text"},"selection_glyph":null},"id":"0d193e5f-4b55-41d8-92e2-776601bc5b25","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"b11ee89f-ed8a-46cf-b226-7545c76b96e2","type":"ColumnDataSource"},"glyph":{"id":"f58883cf-779d-4773-9048-ffb6fad0d645","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"061ce8e8-7961-4b81-9542-434ca17c7e78","type":"Text"},"selection_glyph":null},"id":"fcdf32e6-b4ec-4dce-a144-b98edd30b793","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"c87d0239-8caa-4244-9fa3-036fd0ba47ba","type":"ColumnDataSource"},"glyph":{"id":"216fe55a-e7e5-4f5f-acc2-f2faae8ac70c","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"36b6455d-45f5-4bbb-ad02-0cd128ea4b05","type":"Line"},"selection_glyph":null},"id":"3f9a22e5-b18e-4352-b7eb-69c11216b0aa","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3b92181b-2c60-4f74-a8e6-0be4ff6fea17","type":"Line"},{"attributes":{"data_source":{"id":"3dc700fa-9f72-44ce-bffd-ab2a4a0b068b","type":"ColumnDataSource"},"glyph":{"id":"4d297a5a-6cbd-4d1b-92ca-80da696b3fbf","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"45488f92-ba4f-4a7b-b51d-4e40b3539603","type":"Text"},"selection_glyph":null},"id":"d209e31d-9e92-47f6-9283-1d18a4e8af14","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"7d97858c-57f8-4dba-a1e1-6de8a4e169f8","type":"ColumnDataSource"},"glyph":{"id":"3e83067a-f701-40bb-a2a6-01a0f0be20c1","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"fd3ed4c0-f4e4-4785-804f-9973fecec201","type":"Circle"},"selection_glyph":null},"id":"91f6a144-6576-473c-a879-be305bd8bae3","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"57a10579-b2e0-4ed4-96be-8bdfa0395bc5","type":"Text"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"849effab-b9be-4ea5-aaf3-4bea93a80d4f","type":"Circle"},{"attributes":{"data_source":{"id":"9a252d68-d76f-4c9a-a528-b6333909be42","type":"ColumnDataSource"},"glyph":{"id":"c16d1c0c-4784-4685-911f-3ece1d4169e4","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"e7ad59d6-7487-4cfe-919a-0804e617a08e","type":"Text"},"selection_glyph":null},"id":"801791d6-232b-4e3a-8bee-d3438d199376","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"579c431c-c816-4e70-877b-336e18fc6414","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"882fe3c2-3abc-43f2-9f88-9d90de65b8df","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"34d76a7f-a99d-4305-bab2-3c86a7d5ddf8","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[2040.0,3033538.0,156414.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.62,0.58,0.54],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#b30000"],"index":[6,7,8],"line_color":["#b30000","#b30000","#b30000"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.6226415094339622,0.5818181818181818,0.5362318840579711]}},"id":"cd72b24b-c293-4c66-b408-eba879a0a501","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f20b0c5d-1a04-455c-8850-dea75759ff45","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"c82cd597-735c-4fff-9141-64ca3c6a674e","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"32a37477-e513-4e73-9af8-04bf247d4c6f","type":"ColumnDataSource"},"glyph":{"id":"74a6a5a0-dc24-4acb-b43f-0af41006daa7","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"ff9b00c9-2e5a-4377-bb84-2f6d315069f6","type":"Text"},"selection_glyph":null},"id":"672b506a-92b2-44ab-a1a9-de91e188b4ae","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"ef251ae9-1ce0-4aef-85fd-e2904187a269","type":"ColumnDataSource"},"glyph":{"id":"e9226244-2ad6-4873-9414-831146f05b2e","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"d6dc12a6-bc96-42ce-ac01-f57de5130a28","type":"Line"},"selection_glyph":null},"id":"3cde3213-3d1a-4706-9df0-53bd3d7c42f6","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"4db30553-083d-4818-b51d-28fedb95a488","type":"ColumnDataSource"},"glyph":{"id":"31154bd4-1093-4eb1-a143-16c73ad317bc","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"6932416a-694c-4382-a91e-dedb9bfb857e","type":"Text"},"selection_glyph":null},"id":"6024d667-a242-43d5-aae8-372d727e39d9","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"34d76a7f-a99d-4305-bab2-3c86a7d5ddf8","type":"ColumnDataSource"},"glyph":{"id":"617d3095-58ed-4fae-8754-a70afedc0e7e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"d39f79ce-84c4-43f3-8c81-bf734d436934","type":"Text"},"selection_glyph":null},"id":"3f9328fe-31a5-4f45-b62b-eb81d08dc9fc","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"8b5ad13d-35a9-4fc5-bd99-afa990dff24f","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"83feb436-22d0-4072-aa98-a833b427f6d9","type":"Line"},{"attributes":{"data_source":{"id":"56cff4d9-e4e6-4cb0-ae0b-013e470ce6ee","type":"ColumnDataSource"},"glyph":{"id":"d09a6a5a-6f36-497d-89d7-a2f05ec91536","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"849effab-b9be-4ea5-aaf3-4bea93a80d4f","type":"Circle"},"selection_glyph":null},"id":"dc4e92c6-5741-491e-858c-cfab060e5f08","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"6932416a-694c-4382-a91e-dedb9bfb857e","type":"Text"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"a07e1568-ee23-4ee9-bebd-1a8ec8cec5a7","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"3bf981a8-d88f-4dcb-b3d0-08bcb32c8136","type":"ColumnDataSource"},"glyph":{"id":"677d6360-4641-40f5-bde8-4db4d052c539","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"6ad48073-2659-4ac6-ab0b-d3ae7fecdff2","type":"Text"},"selection_glyph":null},"id":"25730231-81dd-476c-a895-4950288872a6","type":"GlyphRenderer"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"ticker":{"id":"5ddec508-2ae2-4b8e-92f3-2dc5e5a55407","type":"BasicTicker"}},"id":"b0f2b8a3-228a-48b3-af0f-6ecd688fd2a8","type":"Grid"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"02749bad-2ace-41fa-8793-9febce98b7f7","type":"Line"},{"attributes":{"data_source":{"id":"cd538a5a-1c96-4a16-8f9c-0318efa64fff","type":"ColumnDataSource"},"glyph":{"id":"c9d53ece-b5e8-4c0f-8d9b-f9d2f089d959","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"dfb4e009-b667-4402-b404-a4d7831717d8","type":"Circle"},"selection_glyph":null},"id":"c83727b3-7488-42b1-907c-922cf5967753","type":"GlyphRenderer"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"676d2c09-fa8d-4529-9ad7-d878c5a03ad7","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"e1a70edc-e91b-416f-9587-45a72cbb939f","type":"ColumnDataSource"},{"attributes":{},"id":"e7cffe65-1ad0-4ccd-b7b3-4149dbac4aaf","type":"BasicTicker"},{"attributes":{"below":[{"id":"6eb98035-363c-493b-895e-6ce433127e8c","type":"LinearAxis"}],"extra_y_ranges":{"category":{"id":"6e388cb6-9dec-44e5-9697-6c26db82d751","type":"Range1d"}},"left":[{"id":"d348ea90-2b01-43a0-bb0b-71b58f3c98dc","type":"LinearAxis"}],"logo":null,"plot_height":800,"plot_width":800,"renderers":[{"id":"6eb98035-363c-493b-895e-6ce433127e8c","type":"LinearAxis"},{"id":"184cfca4-0fd6-44e8-a91c-6f3a0f0acc2c","type":"Grid"},{"id":"d348ea90-2b01-43a0-bb0b-71b58f3c98dc","type":"LinearAxis"},{"id":"fc60fad5-49fb-4636-a1d1-ea8c8f1a3218","type":"Grid"},{"id":"3ce01f61-082c-4fb2-9c45-40181beeb5ba","type":"Legend"},{"id":"059ae258-11f6-4ce8-b32a-672345040be1","type":"GlyphRenderer"},{"id":"3301b70d-4432-4658-8d00-38aa163752a8","type":"GlyphRenderer"},{"id":"58cc1cf0-7d5f-4043-ab4c-535d4edbe46f","type":"GlyphRenderer"},{"id":"f7a163ef-39fa-40ec-a90d-5e398dd2f55c","type":"GlyphRenderer"},{"id":"441d246a-2314-4b8e-94c8-bd5ce4851981","type":"GlyphRenderer"},{"id":"74493eec-97ac-450e-bf31-08b89d3632bc","type":"GlyphRenderer"},{"id":"a6accade-88f3-43e8-bb1c-4d063609e921","type":"GlyphRenderer"},{"id":"acd4e592-1b08-47ac-a81b-a0108933c664","type":"GlyphRenderer"},{"id":"955632b7-4d52-4e82-a4b6-b97129307286","type":"GlyphRenderer"},{"id":"25730231-81dd-476c-a895-4950288872a6","type":"GlyphRenderer"},{"id":"bf184cc1-2cf2-45ea-804c-d7908360e5c0","type":"GlyphRenderer"},{"id":"be3b25ff-ac68-47e6-9cff-ab746ae8eb2c","type":"GlyphRenderer"},{"id":"214d2228-8fb3-450a-8de0-842f6e2f97a7","type":"GlyphRenderer"},{"id":"2341d3e7-648a-4e89-b6a4-3b6730cf69e0","type":"GlyphRenderer"},{"id":"85e4a6fb-ddff-4668-9fba-cf2f8e9bbedd","type":"GlyphRenderer"},{"id":"0b53257e-b99c-4505-b039-5dfc0ec32cd2","type":"GlyphRenderer"},{"id":"61fcf533-d3f2-4a45-a786-6cba09b55b50","type":"GlyphRenderer"},{"id":"e53b1f05-4d1d-44f1-a55c-7b3da44404fd","type":"GlyphRenderer"},{"id":"ae8cc5c9-716d-446e-bbf4-34514bdbaf0d","type":"GlyphRenderer"},{"id":"91f6a144-6576-473c-a879-be305bd8bae3","type":"GlyphRenderer"},{"id":"ced942e4-7be5-4b02-99dc-da9067d1b2e9","type":"GlyphRenderer"},{"id":"cff1fe24-e5fd-4fe0-99f2-e0c6f34cb2f5","type":"GlyphRenderer"},{"id":"f03ab4dc-dd88-43ca-a5d6-9dd482c2e876","type":"GlyphRenderer"},{"id":"22fcdf47-9b84-42a1-b79d-775fc368b805","type":"GlyphRenderer"},{"id":"390b7c26-224b-49c5-8e58-821f35d08f08","type":"LinearAxis"}],"right":[{"id":"390b7c26-224b-49c5-8e58-821f35d08f08","type":"LinearAxis"}],"title":"PubChem CID 6603928","tool_events":{"id":"c44af89f-1492-424b-a4bd-6a6779453796","type":"ToolEvents"},"toolbar_location":"below","tools":[{"id":"f635ad13-daed-4542-92b1-dd55c21d5064","type":"PreviewSaveTool"},{"id":"a4b59c7a-7988-485a-8c68-ed30a0ce1648","type":"TapTool"},{"id":"7b32d43f-cdea-4289-b893-09291e83e7ad","type":"HoverTool"},{"id":"99000ee0-7e8d-4484-b79d-38380d8a3f54","type":"HoverTool"}],"x_range":{"id":"a6862581-807f-47a8-b7b4-6896716f461d","type":"Range1d"},"y_range":{"id":"0acaded2-3f47-4295-99c9-e2eb27488c56","type":"Range1d"}},"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},{"attributes":{"data_source":{"id":"49a14595-c137-4c94-a76f-f18ae2354a41","type":"ColumnDataSource"},"glyph":{"id":"3fe34616-1e3f-492e-92e6-cb032254a597","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"857f732e-4049-4e1e-8592-1a341c42b34d","type":"Circle"},"selection_glyph":null},"id":"0563d767-40e8-46a2-9507-e8e9633ccc25","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"dfad4f63-ecdf-41f4-bbda-36d8c1f51f9d","type":"Circle"},{"attributes":{"data_source":{"id":"0328efa1-c285-4f88-9ee7-58cca70688c3","type":"ColumnDataSource"},"glyph":{"id":"10e357fe-7f91-4e99-8c0d-0ca725c422df","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"2db7202e-651d-41a9-bcdb-083091b57b96","type":"Text"},"selection_glyph":null},"id":"a7787ce8-5a7e-4b5e-9e5b-5acf2524d7e9","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"19b4a2a0-1fa4-44fb-abb8-ab7974f783bb","type":"Circle"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f6240f89-c6be-4dae-a4ea-99682544bf81","type":"Circle"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"708efe5b-19e6-4b34-9114-607c8a1f7dfe","type":"Text"},{"attributes":{"data_source":{"id":"22713929-044d-4bb5-ade3-4202653227f3","type":"ColumnDataSource"},"glyph":{"id":"fc120317-8ee1-4303-b8b0-f107a39dae64","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"daead269-be8b-4ed2-90b4-623de226836b","type":"Text"},"selection_glyph":null},"id":"05d9524c-903e-40f4-a811-a6020cf10b7d","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"daf0c743-03af-4e20-a06c-f18477bcdeed","type":"ColumnDataSource"},"glyph":{"id":"a12e995f-e744-4b86-9120-5f09b888496a","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"9d4e7457-36c8-4386-b380-fb59da940fa5","type":"Text"},"selection_glyph":null},"id":"982cea8b-e742-4e1b-b6ce-216261f010aa","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2db7202e-651d-41a9-bcdb-083091b57b96","type":"Text"},{"attributes":{"data_source":{"id":"3b635ada-16cb-4d3c-b235-943a42b1e997","type":"ColumnDataSource"},"glyph":{"id":"25b0cd6f-a2da-4492-a98f-e50654f24b8d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"d19c5a82-4848-46dd-ab74-a5cbd8328763","type":"Text"},"selection_glyph":null},"id":"441d246a-2314-4b8e-94c8-bd5ce4851981","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"ab58ae48-249c-4ec8-8abb-e00ed5126b7b","type":"ColumnDataSource"},"glyph":{"id":"f17272cc-dce4-40b5-b706-fa7e2a6f91b9","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"e1e611a0-4610-4baa-a5d4-eeae8cfb99b7","type":"Text"},"selection_glyph":null},"id":"0d672c2a-b148-4ee8-9f47-361f67fff1dc","type":"GlyphRenderer"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e0217762-dea7-4c0d-a20c-2e30860ae3c5","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"32a37477-e513-4e73-9af8-04bf247d4c6f","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2af11ffa-6ca6-4021-9e14-c073d558ff86","type":"Line"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"cc1733e2-7fce-42af-aa4c-06034b14d8ce","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"fc8557b4-6b19-475a-b179-f8fca4418f43","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"626b9c43-6dd9-418b-a956-4ea3b87bd723","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"426ed26f-2626-4f48-9704-939a70e2108a","type":"ColumnDataSource"},"glyph":{"id":"02749bad-2ace-41fa-8793-9febce98b7f7","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"36bb5007-5806-4a73-bf27-9b76d59c8093","type":"Line"},"selection_glyph":null},"id":"916cb35b-677b-4f1d-9d8d-b2f0cc09dad5","type":"GlyphRenderer"},{"attributes":{"callback":null,"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"renderers":[{"id":"ced942e4-7be5-4b02-99dc-da9067d1b2e9","type":"GlyphRenderer"},{"id":"cff1fe24-e5fd-4fe0-99f2-e0c6f34cb2f5","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"7b32d43f-cdea-4289-b893-09291e83e7ad","type":"HoverTool"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5374300f-124f-40df-bf6a-1c730ad38fed","type":"Wedge"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e9651682-7ff6-4b07-852c-b3067f33644c","type":"Text"},{"attributes":{"callback":null,"start":-1},"id":"7e6bf2f7-d105-4d2c-87d0-19dd9299578c","type":"Range1d"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c32fb5ed-7bf7-43f4-b992-d56f3a70934e","type":"Wedge"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"08d076d1-ef6c-4c93-a58c-40fa0ac1cf74","type":"ColumnDataSource"},{"attributes":{},"id":"aa44257c-fd2c-4bee-9267-660e89347364","type":"ToolEvents"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"be1b0284-8117-409f-8aae-6699500a6324","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"74a6a5a0-dc24-4acb-b43f-0af41006daa7","type":"Text"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Biological Nearest Neighbors"],"x":[0.5],"y":[1.025]}},"id":"f3d926c5-95ee-4c06-871f-e126a47fc90f","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b536176c-bb83-40db-909b-47e8a943ab65","type":"Text"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"d17c3a5d-94e7-413e-aa22-2bda411ac359","type":"FixedTicker"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bc75546c-1203-4c27-a1ca-2f7aa14e60de","type":"Text"},{"attributes":{"data_source":{"id":"65fae3f1-c802-4bbf-9a02-7bb48894b105","type":"ColumnDataSource"},"glyph":{"id":"bd1ae610-7769-436d-a58f-2a6e663d8586","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"b8be4c0f-9eb2-4535-8e58-7551bfb2df02","type":"Text"},"selection_glyph":null},"id":"baf98ef5-4fbd-48fb-8bb3-adc3a7245aa4","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"45179818-4c59-4351-8e8c-829fd21783d4","type":"ColumnDataSource"},{"attributes":{},"id":"b3f6dcff-0056-46ed-9edb-e0f6d8c6c6f1","type":"ToolEvents"},{"attributes":{"data_source":{"id":"18893c5a-2ea4-4879-84dc-69e70efb646b","type":"ColumnDataSource"},"glyph":{"id":"8cce8100-dee2-4ce3-b7ef-ed7f31954152","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"4b08c3cd-842e-46be-aaae-de8c1a3a541a","type":"Text"},"selection_glyph":null},"id":"b6691a69-4548-4fc3-b47c-db117176ed39","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"855b9ac5-d39d-40cc-bb23-d891055dc87e","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f58883cf-779d-4773-9048-ffb6fad0d645","type":"Text"},{"attributes":{"bottom":{"field":"bottom"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"left":{"field":"left"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"3d943e21-d9c5-4b47-8d0e-8156246cbb0a","type":"Quad"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[56638112.0,8570.0,15109.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.69,0.67,0.66],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#228B22"],"index":[6,7,8],"line_color":["#b30000","#b30000","#228B22"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.6896551724137931,0.6666666666666666,0.6551724137931034]}},"id":"98cf0b6a-95ad-4d36-8b41-88af12050a15","type":"ColumnDataSource"},{"attributes":{"callback":null,"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"renderers":[{"id":"293c0239-6489-4b71-b539-85b08893248b","type":"GlyphRenderer"},{"id":"7197c06d-6f43-4a9e-8b01-e84ed0bafd89","type":"GlyphRenderer"}],"tooltips":[["Nearest Neighbor","@NN"],["Similarity","@Similarity"],["Confidence","@Confidence"],["PubChem CID","@CID"]]},"id":"1b1f787f-8076-4008-8f4a-e56d9c9f0fe2","type":"HoverTool"},{"attributes":{"callback":{"id":"87a77245-ce30-49e9-aa47-9d90a046579e","type":"OpenURL"},"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"}},"id":"040320ee-5e16-4a1b-8af0-21dbd0bba412","type":"TapTool"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"daa014aa-b929-4190-8e07-3646690a8721","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"e8d60fee-a216-48e3-8c29-9a90174fc3f2","type":"BasicTickFormatter"},"plot":{"id":"76bdf9cd-973e-421a-87af-c3d62de12933","subtype":"Figure","type":"Plot"},"ticker":{"id":"5a56b690-9fad-46d9-b672-755cb49a1912","type":"FixedTicker"}},"id":"269c493b-6227-408a-badb-f2734409ec32","type":"LinearAxis"},{"attributes":{"data_source":{"id":"791f58e6-1b74-4c09-b50f-ec9970ba74e7","type":"ColumnDataSource"},"glyph":{"id":"4d6d853b-1b78-41fe-8e73-735a5c846d68","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"da59b435-65a3-47cf-a8d9-5b3618862c27","type":"Text"},"selection_glyph":null},"id":"b1c9201e-261e-4d2d-a87f-f351791bb043","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"e1a70edc-e91b-416f-9587-45a72cbb939f","type":"ColumnDataSource"},"glyph":{"id":"f54f6c62-6f31-496b-8967-b08d3eb9008c","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"ee01ba9c-e82a-4de6-a0f0-c7ee6479da14","type":"Line"},"selection_glyph":null},"id":"e3d5b38b-566c-475f-af2e-8a6aafceb385","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"f3102822-5e90-4667-bc7e-90cc663878ba","type":"ColumnDataSource"},"glyph":{"id":"fc0721f7-f1f8-4d28-8a1b-87691ff85bb4","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"68ca074d-a2cb-433f-b313-a96198f77f0d","type":"Quad"},"selection_glyph":null},"id":"a54ea75f-a143-4c98-9dff-4d8ca5e17954","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"b78bebe6-39e4-4ab2-937b-5536cbe6e11e","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9b35586d-0824-4ea3-a55a-afa282bb5c5f","type":"Text"},{"attributes":{"data_source":{"id":"d958147d-a9b5-4192-92b6-d00f401c6e09","type":"ColumnDataSource"},"glyph":{"id":"04d12ba0-83df-4bfa-be69-0ced3b33e742","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"c0e223fc-8d59-4b1f-a376-a61e932c5d98","type":"Circle"},"selection_glyph":null},"id":"3b6cc46b-3623-4c6e-a244-78a18f65e619","type":"GlyphRenderer"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4ce9e429-764f-42c2-8fe9-4a680ea353d7","type":"Text"},{"attributes":{},"id":"c72e1233-1e24-4de1-8d89-64f1dbe2bde9","type":"BasicTickFormatter"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"e25f92d0-282b-4de5-9237-052a70cf555b","type":"ColumnDataSource"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"e58e5987-c1b6-4cd0-907f-c3f4b54f2009","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"319ca9c6-c3bf-4e47-941c-9858519dd010","type":"GlyphRenderer"}]],["Active",[{"id":"20c6115d-edc7-46f8-8393-7fe64cdbaf50","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"}},"id":"9557a38e-d17d-4ca2-93d9-3dc2906959ea","type":"Legend"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"d911d5a0-e471-44c4-ae35-9f482ee62498","type":"ColumnDataSource"},{"attributes":{},"id":"4f3d1d70-e6bf-4964-af79-7b5541b32339","type":"BasicTicker"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"447a6e27-0db9-4056-96b3-b8deb9d8965b","type":"Line"},{"attributes":{"data_source":{"id":"106dace7-8ab2-45b2-a83d-13728d312c18","type":"ColumnDataSource"},"glyph":{"id":"30c00965-39ba-47f4-aff3-488a5650ff5f","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"c3da7013-97a4-4f9f-8cdd-3ba49f29e551","type":"Wedge"},"selection_glyph":null},"id":"22fcdf47-9b84-42a1-b79d-775fc368b805","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3028bf36-8c7f-4910-8014-f2fe13b8e567","type":"Line"},{"attributes":{"data_source":{"id":"af9c3bc6-5b8f-4e43-80d0-143e12d2d0ee","type":"ColumnDataSource"},"glyph":{"id":"932e1aeb-b771-49eb-b2c1-e1948c2bc33f","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"7f478e2d-cb62-4754-8f53-e3e5b46cc20a","type":"Text"},"selection_glyph":null},"id":"9849d424-9016-4662-9a6c-b3feea5ff7c2","type":"GlyphRenderer"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ea952f86-52aa-4e2b-93b1-909ce0dfb93b","type":"Text"},{"attributes":{"data_source":{"id":"6237731e-6c93-4c84-bc3c-7a3b5f7665e4","type":"ColumnDataSource"},"glyph":{"id":"3246b95c-a0c5-43c1-814d-608d4e87bf1a","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"17ab7374-e8ad-48d3-a552-d819d7b34da9","type":"Line"},"selection_glyph":null},"id":"68e981c0-5084-48d5-816c-6e4dd2502f6f","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"cb9724e7-2efb-43dd-a358-849179131339","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"ce43bea2-0729-4f53-8618-70b0df627877","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"077353e9-ffa0-4509-aaa6-d5e9b15944e0","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"617d3095-58ed-4fae-8754-a70afedc0e7e","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[0,0],"y":[0,1]}},"id":"426ed26f-2626-4f48-9704-939a70e2108a","type":"ColumnDataSource"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"6005ef5b-7eb9-466a-bdfa-da55af3853d0","type":"Range1d"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[-0.06],"y":[0]}},"id":"52860e3e-e15f-4b0d-bc12-36ab61fe0f9e","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"7ae9bb71-f5b0-4d0f-a5cb-acb1df553114","type":"Line"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0],"Confidence":[0.45,0.45,0.45],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.0642857142857143,0.0642857142857143,0.0642857142857143],"fill_color":["#228B22","#228B22","#228B22"],"index":[3,4,5],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.0032142857142857147,0.0032142857142857147,0.0032142857142857147],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"f6f228ec-39b8-45be-b227-4e1b9b31c2c4","type":"ColumnDataSource"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3cbc7cc3-729c-4e7c-85ea-efab44c62c9b","type":"Circle"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"dd6d8286-3e46-4eff-a83e-e30bfe9b5507","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1f613211-6c9f-4b82-87ba-9b866e8e1256","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"e81b5a01-7fb0-495e-a3b7-7f4b5b501bf4","type":"Text"},{"attributes":{"data_source":{"id":"015676df-988a-4710-ae0e-45f302196546","type":"ColumnDataSource"},"glyph":{"id":"417d6adb-3ecd-4a38-b100-6e4592311fde","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"7836ffdf-8591-4a28-bfc3-6e2dcbab67e4","type":"Line"},"selection_glyph":null},"id":"2acc4e09-187f-4c7a-959f-2503d4489378","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"015676df-988a-4710-ae0e-45f302196546","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d39f79ce-84c4-43f3-8c81-bf734d436934","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bae290b4-0b4f-4c87-8934-9faa076e9f91","type":"Text"},{"attributes":{"data_source":{"id":"7b142527-23cd-4bd5-b634-8ec825ce333e","type":"ColumnDataSource"},"glyph":{"id":"5053803d-b270-4446-abe6-bd1b0504d4fc","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"66e27df2-d7b7-4cab-a720-4b6630d8f204","type":"Line"},"selection_glyph":null},"id":"88c21c95-a5d6-4638-9989-e1171ac8d21d","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"9576c3d9-e65d-4415-859e-420776b4f711","type":"Line"},{"attributes":{"data_source":{"id":"159c1750-1d11-4764-bae9-0938ce6998ae","type":"ColumnDataSource"},"glyph":{"id":"c6c412a7-b1c5-4692-97e3-07661819eeef","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"1282bcaf-d8fd-4ad0-8008-6bf55b5087da","type":"Text"},"selection_glyph":null},"id":"0e7ef584-73dc-4f2e-8f49-202537f6bb10","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"20e9d9fe-7280-414a-b389-46ebaab1c39d","type":"Line"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"dfcfb902-d7a3-4c55-af61-0b8837a63122","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"050bc564-9aa2-4436-97ca-23212aa0cde6","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"932e1aeb-b771-49eb-b2c1-e1948c2bc33f","type":"Text"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"dfe80c05-c2a4-4364-bc58-ddccde640fa5","type":"Quad"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"54c290b6-5982-4739-aee0-2416065fe812","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"cdb79815-b733-4400-a34b-a439935e3201","type":"Text"},{"attributes":{"data_source":{"id":"7b5d385a-4721-4d43-a72c-eb52e1801f49","type":"ColumnDataSource"},"glyph":{"id":"7f5db10e-6ce8-42f6-847d-33ff257cc8e0","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"32bae0d1-e0ca-4f77-89cb-0bad8a815146","type":"Line"},"selection_glyph":null},"id":"f22fcf0b-17bb-4e7d-87cd-735038f16177","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"278f0ada-0e50-4185-b25d-de3db1ad6648","type":"Line"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9269f95d-e3e6-4c7b-9e7f-36836a9d8775","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9d12cad7-1ed5-42b2-b2a4-64cd610a055c","type":"Line"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a8efa064-f426-41f1-980b-14c9b64d7b63","type":"Circle"},{"attributes":{},"id":"3190fb7d-eb5d-427b-b86b-16f3798ebf5d","type":"BasicTicker"},{"attributes":{"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"}},"id":"c5e0b3bb-34e8-4ff6-a2d7-894e5a903d40","type":"PreviewSaveTool"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fa50f2e2-2aad-4558-b3c9-d2a1c7361359","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"9a514bbf-52b8-4f42-892d-a222c76a5311","type":"Text"},{"attributes":{"data_source":{"id":"907328ed-98c6-4c77-8269-5e7f0274afa3","type":"ColumnDataSource"},"glyph":{"id":"9b8dc605-d97d-4e9e-a473-9370c641a1ce","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"80169d3a-10c3-4022-a185-525f933c188c","type":"Circle"},"selection_glyph":null},"id":"52d5d45e-1fca-4390-91b5-bd9a519b562c","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"ad705037-7ef9-470c-bc9a-7a4ab82dec57","type":"ColumnDataSource"},{"attributes":{"callback":null,"start":-1},"id":"6c6b8449-de46-4c98-99a5-96b28bdc9312","type":"Range1d"},{"attributes":{},"id":"a2fce2d8-0e2a-4d33-a2aa-4d59a0fb096e","type":"BasicTicker"},{"attributes":{"callback":null,"start":-1},"id":"e87daea9-4f85-4651-a4bb-00b406495fbb","type":"Range1d"},{"attributes":{"data_source":{"id":"fdc3b0a7-975b-4136-8e6b-a4a61d41c238","type":"ColumnDataSource"},"glyph":{"id":"38918166-bd7c-4a6a-b9f9-ae1ef5cf9653","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"e5dd90cc-27de-464d-91ce-2a86bd966070","type":"Text"},"selection_glyph":null},"id":"dc0ad3b7-1fdc-4f18-bc88-22c89f62a27e","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"0822103c-c6eb-4552-bb93-a3008e13597d","type":"ColumnDataSource"},"glyph":{"id":"826d6c3f-d61e-4e06-bdc0-ecf9d4b960d9","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"3b92181b-2c60-4f74-a8e6-0be4ff6fea17","type":"Line"},"selection_glyph":null},"id":"ebf533bc-4207-41c5-b8a7-91b2923f898c","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"5f8a28fe-fff8-401a-bd26-9621e9a8413f","type":"ColumnDataSource"},"glyph":{"id":"9817ade6-e15c-4188-bba6-9ff7202e682d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"bae290b4-0b4f-4c87-8934-9faa076e9f91","type":"Text"},"selection_glyph":null},"id":"ebe5ce1f-3991-4e53-bb8c-fa9550067cb9","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7836ffdf-8591-4a28-bfc3-6e2dcbab67e4","type":"Line"},{"attributes":{"data_source":{"id":"daec6f3a-f661-4637-8d61-fe69871fd369","type":"ColumnDataSource"},"glyph":{"id":"5d2727aa-b21a-4455-9aa9-21d87a4c6350","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"799c1a03-16f2-4fcf-a63a-875d81c6d1d9","type":"Circle"},"selection_glyph":null},"id":"58cc1cf0-7d5f-4043-ab4c-535d4edbe46f","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"05d78898-e003-4523-bfc1-1fee74e45848","type":"ColumnDataSource"},"glyph":{"id":"5072c526-1778-4850-9035-9636cbb9dea9","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"63a53e86-0027-44ca-a901-c5561572f397","type":"Text"},"selection_glyph":null},"id":"ac24ba21-09f8-4243-8550-4f7e4dfbc17f","type":"GlyphRenderer"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a1e1667c-6c40-4faf-b90f-76067453bce0","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0],"Confidence":[0.27,0.27,0.27],"NN":[1,2,3],"Similarity":[1.0,1.0,1.0],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576],"fill_color":["#228B22","#228B22","#228B22"],"index":[3,4,5],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"faa15893-c1da-4960-a170-8d7f4c1b23b3","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d0d1a22c-fa09-4c0d-a17e-8c3b4ee41031","type":"Text"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"4d297a5a-6cbd-4d1b-92ca-80da696b3fbf","type":"Text"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fc120317-8ee1-4303-b8b0-f107a39dae64","type":"Text"},{"attributes":{},"id":"59623683-7844-476f-bd72-623ade51c6a9","type":"BasicTicker"},{"attributes":{"formatter":{"id":"92b236d5-9e12-4fc9-abdb-88f5922f8ece","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"},"ticker":{"id":"b2e8bdae-de82-4a02-8258-06a526f1d357","type":"BasicTicker"}},"id":"6eb98035-363c-493b-895e-6ce433127e8c","type":"LinearAxis"},{"attributes":{"formatter":{"id":"14f3c57b-e81e-42dc-b101-5a86a09b036a","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"ticker":{"id":"5ddec508-2ae2-4b8e-92f3-2dc5e5a55407","type":"BasicTicker"}},"id":"ccd29176-c24a-4038-ad03-46b01ffb8c09","type":"LinearAxis"},{"attributes":{"callback":null,"plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"},"renderers":[{"id":"662760c6-1f2c-4d92-9b16-bec25a6ffd70","type":"GlyphRenderer"}],"tooltips":[["Prediction","@Prediction"]]},"id":"d539c2a0-cd42-4ccd-b099-7a909c6944ad","type":"HoverTool"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[0.6666666666666666,1.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#b30000"],"index":[0,1],"line_color":["#b30000","#b30000"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[0.6666666666666666,1.0]}},"id":"fd275d41-844a-4cf7-9193-bb5b815168b2","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"1c7f1668-4366-404b-a1c5-a9ef666850bf","type":"ColumnDataSource"},"glyph":{"id":"ba8ad0fe-bb82-4d25-8f7b-de54f264f712","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"5877d2aa-fde0-4e34-9de1-89e52d99db3e","type":"Circle"},"selection_glyph":null},"id":"19b7e0f7-b556-480d-ad5d-ef8509834714","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"db5e79c9-3c84-440d-a31f-2c9f3f1a2cc1","type":"ColumnDataSource"},"glyph":{"id":"90c20c91-aa17-40b0-a506-92ca14f77c26","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"3640f87d-b1f8-485d-81b4-3c8eb05f93aa","type":"Text"},"selection_glyph":null},"id":"44641c9b-8219-4eb6-976e-bea2dc4fe74d","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"06fbe35e-e691-4228-bd65-238ae24c2a37","type":"ColumnDataSource"},"glyph":{"id":"e1f4ec85-5f2c-4ae3-8c93-76cf97e5ebca","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"9d12cad7-1ed5-42b2-b2a4-64cd610a055c","type":"Line"},"selection_glyph":null},"id":"6120b74b-fc7b-44a9-a7b5-25b064ab37d8","type":"GlyphRenderer"},{"attributes":{"fill_color":{"value":"#228B22"},"line_color":{"value":"#228B22"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1a3710fc-bb09-4ea0-b103-7612a709341e","type":"Circle"},{"attributes":{"data_source":{"id":"f6b35e06-5b03-416d-bbd0-7383eda28985","type":"ColumnDataSource"},"glyph":{"id":"7f05898c-08df-42d1-83b9-00b3127d9cf4","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"d660c2fb-f324-4980-9b11-cda287461049","type":"Circle"},"selection_glyph":null},"id":"252e3f99-327e-428c-9d62-39b54e09261d","type":"GlyphRenderer"},{"attributes":{},"id":"58522dbe-4e4b-4a47-b95c-5ea5c6e6e102","type":"ToolEvents"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"0923ce87-f112-47a9-9daa-a44c0dceee0c","type":"Line"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"119282da-2059-4118-a6ba-b353ff64db6f","type":"Line"},{"attributes":{},"id":"92b236d5-9e12-4fc9-abdb-88f5922f8ece","type":"BasicTickFormatter"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"aa3db0b8-51ff-4fa7-b555-4dca68e50320","type":"Text"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"060327c2-ca8a-47e3-9601-36dca3d5d9b6","type":"Circle"},{"attributes":{"callback":{"id":"aeea3608-2af7-4456-9a85-976b250bd41b","type":"OpenURL"},"plot":{"id":"baf55ecb-f20f-4ddb-89f1-48a177433549","subtype":"Figure","type":"Plot"}},"id":"a4b59c7a-7988-485a-8c68-ed30a0ce1648","type":"TapTool"},{"attributes":{},"id":"14f3c57b-e81e-42dc-b101-5a86a09b036a","type":"BasicTickFormatter"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fb0a1e0e-16d1-4048-9c10-679840a5d036","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"4e544471-fb09-4319-81fc-ceeb81764f6e","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"4070f420-8af8-4007-8a6b-0af5831635a3","type":"ColumnDataSource"},"glyph":{"id":"b327041a-3613-4f79-90b0-ec212821e260","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"497ea889-fff5-4b0a-9f32-2259639c353a","type":"Circle"},"selection_glyph":null},"id":"96568603-0248-421c-bd09-42c8a6933e20","type":"GlyphRenderer"},{"attributes":{"callback":null,"end":1.1,"start":-0.15},"id":"4a0a47a9-4287-4482-975f-2f7cdd0b360c","type":"Range1d"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"2fe87224-2618-4382-903c-5320288beb7c","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"44f42cf7-b0d6-4f3c-9648-b889bd5d9eab","type":"Line"},{"attributes":{"data_source":{"id":"00f2eb34-f169-4d49-9cb4-26fb37dbcc53","type":"ColumnDataSource"},"glyph":{"id":"fba5e9e6-d96b-4475-984b-507b85a9600d","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"a4f1198e-3cb0-4468-88a0-8fc1b3dfb5c3","type":"Text"},"selection_glyph":null},"id":"93ea5ea0-3e6e-4fc1-9be3-526f468ba636","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"cf5f41b7-97e2-476e-bb57-ff3a9919d296","type":"ColumnDataSource"},"glyph":{"id":"148eb8b2-119d-49fb-b472-47691d87a287","type":"Quad"},"hover_glyph":null,"nonselection_glyph":{"id":"0bca1867-a8b4-4f88-8ec5-a247ea2fc6a7","type":"Quad"},"selection_glyph":null},"id":"a6accade-88f3-43e8-bb1c-4d063609e921","type":"GlyphRenderer"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"30731d34-81d9-4cc8-afa8-158926b9b434","type":"Text"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"799aae23-3355-4892-a4e0-220d39b18737","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"804c3109-46a1-4ba4-b1ce-b7d29f9503d3","type":"ColumnDataSource"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"3988cb34-9e28-42bd-ae9f-32421a950e04","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"0c472726-c370-4a4e-94f4-73e22b07ef3b","type":"GlyphRenderer"}]],["Active",[{"id":"3b6cc46b-3623-4c6e-a244-78a18f65e619","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"22f6c49e-b671-42f8-88c0-24cffd7bc981","subtype":"Figure","type":"Plot"}},"id":"e9acedbc-6672-4de5-80f0-39fcb0e5297f","type":"Legend"},{"attributes":{},"id":"6ed3dc5a-3617-4701-ae9b-676d26d7f1be","type":"BasicTickFormatter"},{"attributes":{"callback":{"id":"a9afb7a9-c356-4684-9046-d55c44937a6f","type":"OpenURL"},"plot":{"id":"74f70251-f233-4599-80fb-aeaefc4b73a6","subtype":"Figure","type":"Plot"}},"id":"5dbbb6d8-40f9-40f9-8d3b-7bffed8e2ff8","type":"TapTool"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8ea12d3f-76ca-4de4-ab83-29d300decc7f","type":"Line"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.25,0.25]}},"id":"c4e7a4ad-8cb5-4273-85a3-19b94c220e7b","type":"ColumnDataSource"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"e7132043-2074-454b-8e0e-1db1933c927b","type":"Quad"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0,3033538.0,10127622.0,2040.0],"Confidence":["0.45","0.45","0.45","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.53,0.41,0.4],"alpha":[0.0642857142857143,0.0642857142857143,0.0642857142857143,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"radius":[0.0032142857142857147,0.0032142857142857147,0.0032142857142857147,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.46941176470588236,0.3484507042253521,0.34]}},"id":"6faad113-a25a-46f7-8c69-3a4f25fca2ca","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"61282e9e-c17a-4644-962c-75679c4448e5","type":"ColumnDataSource"},{"attributes":{},"id":"0610ff32-5aa9-442f-865f-449864f799dd","type":"BasicTicker"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"82cd1763-f618-4184-98f1-f62be969e2ae","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b13343e4-a3de-45c1-8342-c3eab93943b0","type":"Text"},{"attributes":{"data_source":{"id":"ee37717a-9925-4bef-8f93-d4c1fe0c1ee5","type":"ColumnDataSource"},"glyph":{"id":"bc59961b-3dd8-4589-abe4-2944a8cd5ee0","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"a395d39e-6a09-4a75-b02b-417d22e165c3","type":"Text"},"selection_glyph":null},"id":"f456e206-c618-4801-aedf-d58b3de71dd4","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[56638112.0,8570.0,15109.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.69,0.67,0.66],"alpha":[0.5,0.5,0.5],"fill_color":["#b30000","#b30000","#228B22"],"index":[6,7,8],"line_color":["#b30000","#b30000","#228B22"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.6896551724137931,0.6666666666666666,0.6551724137931034]}},"id":"7c0c7512-a78f-4961-86d9-a8d12d1a28c6","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"78e93c2a-f482-4ff4-98ff-48ea504e2a03","type":"ColumnDataSource"},"glyph":{"id":"5c506c51-5b4a-4213-87c2-932404db56de","type":"Circle"},"hover_glyph":null,"nonselection_glyph":{"id":"0d0e8298-f2da-41f7-a60c-9dec6d9c6961","type":"Circle"},"selection_glyph":null},"id":"d50b2b4c-afd9-44bd-9189-314b54088a41","type":"GlyphRenderer"},{"attributes":{"formatter":{"id":"ac6ed80f-b600-4c15-bab0-109326623c1f","type":"BasicTickFormatter"},"major_label_text_color":{"field":"None"},"major_tick_in":0,"major_tick_out":0,"minor_tick_out":0,"plot":{"id":"a0def348-24cf-4fb4-a0f9-72c46e73c7e3","subtype":"Figure","type":"Plot"},"ticker":{"id":"a334b9fb-970f-4492-91c7-6590484c6ccc","type":"BasicTicker"}},"id":"835ced68-b808-4204-bbcf-e5afaf5e29e3","type":"LinearAxis"},{"attributes":{"callback":null,"column_names":["alpha","start_angle","end_angle","index","line_color","y","x","Prediction","radius","fill_color"],"data":{"Prediction":[0.6666666666666666,1.0],"alpha":[0.5,0.5],"end_angle":[270,90],"fill_color":["#b30000","#b30000"],"index":[0,1],"line_color":["#b30000","#b30000"],"radius":[0.05,0.05],"start_angle":[90,270],"x":[0,0],"y":[0.6666666666666666,1.0]}},"id":"4c3b698f-bdf2-451f-97ae-9f73253b78aa","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8deb7732-400b-40a2-940a-3ec5d04ef293","type":"Line"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"db5e79c9-3c84-440d-a31f-2c9f3f1a2cc1","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"8b5fadad-713c-4d80-bbfa-3a4c8fbe7149","type":"Text"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[-0.06],"y":[0.5]}},"id":"9b17b4b1-b6fa-4b81-b348-e011f1fd99a3","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inconclusive"],"x":[0.06],"y":[0.5]}},"id":"ab58ae48-249c-4ec8-8abb-e00ed5126b7b","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_baseline":"top","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"46b31113-de04-40bc-9d77-8d37203bcfd2","type":"Text"},{"attributes":{"background_fill_alpha":{"value":0.8},"background_fill_color":{"value":"#cdcdcd"},"legends":[["Inactive",[{"id":"89ca11c9-e348-4575-a936-a748fdc9a58d","type":"GlyphRenderer"}]],["Inconclusive",[{"id":"96568603-0248-421c-bd09-42c8a6933e20","type":"GlyphRenderer"}]],["Active",[{"id":"dcdaee22-b44d-40bd-8e41-1de0d88d26fd","type":"GlyphRenderer"}]]],"location":"bottom_right","plot":{"id":"b3ecf466-9a47-4fce-b8bf-3e6644af5b47","subtype":"Figure","type":"Plot"}},"id":"c3e2211d-8e5e-4f29-a1f8-0b9b5fde43cc","type":"Legend"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.025,0.025],"y":[0.75,0.75]}},"id":"04bc41ea-792d-4df9-9354-21dfcf4d42f3","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0.5,0.5]}},"id":"88e63dac-83de-44d9-9621-e7b9410de9d2","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Inactive"],"x":[0.06],"y":[0]}},"id":"42272ad1-d6b5-4cd1-bea6-856b50e2c2bd","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d97f18dc-aa33-4e0d-86aa-1469d84b5d6b","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"7f5db10e-6ce8-42f6-847d-33ff257cc8e0","type":"Line"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d660c2fb-f324-4980-9b11-cda287461049","type":"Circle"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d414134a-11c2-4969-b64c-e0ff591a013d","type":"Text"},{"attributes":{"data_source":{"id":"25fd62e5-79cb-4045-83ac-eb5c397d1232","type":"ColumnDataSource"},"glyph":{"id":"521cf91b-cd61-411c-a6b2-b5fb0b7a417c","type":"Wedge"},"hover_glyph":null,"nonselection_glyph":{"id":"113dce63-81af-4410-93f0-fef2d535f36d","type":"Wedge"},"selection_glyph":null},"id":"662760c6-1f2c-4d92-9b16-bec25a6ffd70","type":"GlyphRenderer"},{"attributes":{"data_source":{"id":"d0a4f03e-6323-435d-8903-ae41880f4bbe","type":"ColumnDataSource"},"glyph":{"id":"7174a60e-20dd-4ce0-8e1f-f87372c6b8a6","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"877a44cd-fe77-4154-9425-e47f26bee2c7","type":"Text"},"selection_glyph":null},"id":"82164310-ce9c-4b4b-8643-d14aa41ce1aa","type":"GlyphRenderer"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[460.0,931.0,1183.0,9909677.0,4921.0,213031.0],"Confidence":["0.27","0.27","0.27","N/A","N/A","N/A"],"NN":["NN 1","NN 2","NN 3","NN 1","NN 2","NN 3"],"Similarity":[1.0,1.0,1.0,0.61,0.58,0.56],"alpha":[0.038571428571428576,0.038571428571428576,0.038571428571428576,0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"index":[3,4,5,6,7,8],"line_color":["#228B22","#228B22","#228B22","#b30000","#b30000","#b30000"],"radius":[0.0019285714285714288,0.0019285714285714288,0.0019285714285714288,0.05,0.05,0.05],"x":[0.25,0.5,0.75,-0.25,-0.5,-0.75],"y":[0.94,0.94,0.94,0.5519402985074626,0.5244155844155844,0.49932203389830504]}},"id":"900d06d5-82ad-4059-ac48-078c9bc16dc9","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"c6546bf2-619a-4c88-a24a-b3d6e905326c","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"32bae0d1-e0ca-4f77-89cb-0bad8a815146","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"704fcaf3-e187-4a0e-a5ba-ead9d5241b6f","type":"Text"},{"attributes":{"bottom":{"field":"bottom"},"fill_color":{"value":null},"left":{"field":"left"},"line_alpha":{"value":0.2},"line_dash":[6,4],"right":{"field":"right"},"top":{"field":"top"}},"id":"fc0721f7-f1f8-4d28-8a1b-87691ff85bb4","type":"Quad"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"a4f1198e-3cb0-4468-88a0-8fc1b3dfb5c3","type":"Text"},{"attributes":{"end_angle":{"field":"end_angle","units":"deg"},"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"start_angle":{"field":"start_angle","units":"deg"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fdeb3acb-64cb-4190-af15-6c05a842b5ea","type":"Wedge"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"53d8ba23-ab62-4168-9380-a2c6e20eca53","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"907328ed-98c6-4c77-8269-5e7f0274afa3","type":"ColumnDataSource"},{"attributes":{"text_align":"center","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"51fc417a-4769-400a-b488-fe602ff46d1a","type":"Text"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[-0.05,0.05],"y":[0,0]}},"id":"8464cb63-3817-4a4d-b134-1a651f589791","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["x","y","text"],"data":{"text":["Active"],"x":[-0.06],"y":[1]}},"id":"8c71415e-5383-4dc6-bb49-6e3efbc0ebd1","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"a72e70d2-e0e1-461b-bca8-fbac7db623f7","type":"ColumnDataSource"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"e9226244-2ad6-4873-9414-831146f05b2e","type":"Line"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"d75f4ad7-e6a9-499c-bb41-80eb72fb6890","type":"Text"},{"attributes":{"text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7211ec32-30cf-4ac0-b969-86401c96476d","type":"Text"},{"attributes":{"data_source":{"id":"df972afa-89c2-4d1c-a316-d2950ab2fe3d","type":"ColumnDataSource"},"glyph":{"id":"270541aa-4bed-4dbe-a424-684f7f927f34","type":"Line"},"hover_glyph":null,"nonselection_glyph":{"id":"2b61ad6c-6b2e-4a69-9c4f-4cdbbf239159","type":"Line"},"selection_glyph":null},"id":"214d2228-8fb3-450a-8de0-842f6e2f97a7","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"d37485fa-138c-4ee5-912a-5c826130f7c8","type":"Line"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Predicted Activity"],"x":[0],"y":[-0.03]}},"id":"fdc3b0a7-975b-4136-8e6b-a4a61d41c238","type":"ColumnDataSource"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":[72.0,370.0,1491.0],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.83,0.77,0.69],"alpha":[0.5,0.5,0.5],"fill_color":["#228B22","#228B22","#228B22"],"index":[6,7,8],"line_color":["#228B22","#228B22","#228B22"],"radius":[0.05,0.05,0.05],"x":[-0.25,-0.5,-0.75],"y":[0.8333333333333334,0.7692307692307693,0.6923076923076923]}},"id":"219dbc84-cfb1-4a16-a760-fc3fb5dd9480","type":"ColumnDataSource"},{"attributes":{"data_source":{"id":"e64c468c-d3a9-4078-aa10-b9eba0c462b9","type":"ColumnDataSource"},"glyph":{"id":"acf33afd-2266-4634-b820-60728684b84e","type":"Text"},"hover_glyph":null,"nonselection_glyph":{"id":"fcd1f9aa-83b7-4801-ac34-147ac66512f5","type":"Text"},"selection_glyph":null},"id":"c1bfe955-3d69-4a25-8036-3f0c83c56ac7","type":"GlyphRenderer"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"2f826e81-c45c-484e-97fc-c9dd727d08cd","type":"Line"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"5053803d-b270-4446-abe6-bd1b0504d4fc","type":"Line"},{"attributes":{"grid_line_color":{"value":null},"plot":{"id":"020bcade-caeb-427d-adfc-63f6344effc0","subtype":"Figure","type":"Plot"},"ticker":{"id":"eb411e86-4f11-4257-ac79-cf51f4e15b19","type":"BasicTicker"}},"id":"71202d7d-a1ac-499a-97ec-29eb98d62513","type":"Grid"},{"attributes":{"text_align":"right","text_alpha":{"value":0.1},"text_baseline":"middle","text_color":{"value":"black"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"84a0240e-2415-4414-b92d-ac18b17d8862","type":"Text"},{"attributes":{"callback":null,"column_names":["alpha","NN","Similarity","index","line_color","y","CID","x","Confidence","radius","fill_color"],"data":{"CID":["N/A","N/A","N/A"],"Confidence":["N/A","N/A","N/A"],"NN":[1,2,3],"Similarity":[0.0,0.0,0.0],"alpha":[1.0,1.0,1.0],"fill_color":[null,null,null],"index":[0,1,2],"line_color":["black","black","black"],"radius":[0.05,0.05,0.05],"x":[0.25,0.5,0.75],"y":[1.0,1.0,1.0]}},"id":"4b769f47-8c40-443d-bca9-6ae0d7223bd8","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fa06be48-95af-403a-b315-638414f44be3","type":"Circle"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"d958147d-a9b5-4192-92b6-d00f401c6e09","type":"ColumnDataSource"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"f17272cc-dce4-40b5-b706-fa7e2a6f91b9","type":"Text"},{"attributes":{"text_align":"center","text_alpha":{"value":0.1},"text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"135eb392-0644-4ead-84c0-f94febe935ac","type":"Text"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"86e735fe-b149-4578-821c-7943bf3b7930","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#9a9a9a"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"36606a36-062b-41c0-ba3b-b25569e85792","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"7f3bbb0d-5a76-4352-baec-82d49a96658a","type":"Line"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"0ffb55b2-339e-4331-a991-a8250250416d","type":"Line"},{"attributes":{"text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#228B22"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"bc59961b-3dd8-4589-abe4-2944a8cd5ee0","type":"Text"},{"attributes":{"callback":null,"column_names":["y","text","x"],"data":{"text":["Chemical Nearest Neighbors"],"x":[-0.5],"y":[1.025]}},"id":"22713929-044d-4bb5-ade3-4202653227f3","type":"ColumnDataSource"},{"attributes":{"text_align":"right","text_alpha":{"value":0.5},"text_baseline":"middle","text_color":{"value":"#b30000"},"text_font_size":{"value":"8pt"},"x":{"field":"x"},"y":{"field":"y"}},"id":"fba5e9e6-d96b-4475-984b-507b85a9600d","type":"Text"},{"attributes":{"fill_alpha":{"field":"alpha"},"fill_color":{"field":"fill_color"},"line_alpha":{"field":"alpha"},"line_color":{"field":"line_color"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"3e83067a-f701-40bb-a2a6-01a0f0be20c1","type":"Circle"},{"attributes":{"text":{"field":"NN"},"text_align":"center","text_baseline":"middle","text_color":{"value":"black"},"x":{"field":"x"},"y":{"field":"y"}},"id":"1db7a92c-abaf-4424-aeb9-40afe30d397e","type":"Text"},{"attributes":{"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"c24aee7b-219f-4c7b-86d0-72884addae8c","type":"Line"},{"attributes":{"fill_color":{"value":"#b30000"},"line_color":{"value":"#b30000"},"x":{"field":"x"},"y":{"field":"y"}},"id":"5d2727aa-b21a-4455-9aa9-21d87a4c6350","type":"Circle"},{"attributes":{"callback":null,"column_names":["bottom","right","left","top"],"data":{"bottom":[-0.03],"left":[-0.05],"right":[0.05],"top":[1.03]}},"id":"6b5a3bca-e13a-4e6e-b8d9-fbd901e5fc83","type":"ColumnDataSource"},{"attributes":{"ticks":[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1]},"id":"1bbc8a57-2bb7-413d-899b-7bad02f123a9","type":"FixedTicker"},{"attributes":{"callback":null,"column_names":["y","x"],"data":{"x":[2],"y":[2]}},"id":"aee4bc84-4a91-42e4-8ba6-dc8f0c6e162d","type":"ColumnDataSource"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"field":"radius","units":"data"},"x":{"field":"x"},"y":{"field":"y"}},"id":"b6560264-75b6-4602-a324-79bb05660f20","type":"Circle"},{"attributes":{"line_alpha":{"value":0.2},"x":{"field":"x"},"y":{"field":"y"}},"id":"a6c0fc9e-92f3-4172-ad65-fec1ea1c4158","type":"Line"},{"attributes":{"url":"https://pubchem.ncbi.nlm.nih.gov/compound/@CID/"},"id":"933677c7-166f-446a-81c0-849f2c19a172","type":"OpenURL"},{"attributes":{"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"x":{"field":"x"},"y":{"field":"y"}},"id":"799c1a03-16f2-4fcf-a63a-875d81c6d1d9","type":"Circle"}],"root_ids":["020bcade-caeb-427d-adfc-63f6344effc0","a0def348-24cf-4fb4-a0f9-72c46e73c7e3","69f683bf-8b7c-4adb-b6b8-8f141703c344","22f6c49e-b671-42f8-88c0-24cffd7bc981","b3ecf466-9a47-4fce-b8bf-3e6644af5b47","ae73f079-93a7-47e5-9014-e189818f588f","74f70251-f233-4599-80fb-aeaefc4b73a6","baf55ecb-f20f-4ddb-89f1-48a177433549","450aa568-a859-4858-99d1-3e38c634f3a3","76bdf9cd-973e-421a-87af-c3d62de12933"]},"title":"Bokeh Application","version":"0.11.1"}};
          var render_items = [{"docid":"ea2ef7ec-23e1-49f3-9e20-2873371b6cf4","elementid":"3ebf6bac-6e4d-4eaf-996a-097814bdb80f","modelid":"76bdf9cd-973e-421a-87af-c3d62de12933"}];
          
          Bokeh.embed.embed_items(docs_json, render_items);
      });
    },
    function(Bokeh) {
      console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-0.11.1.min.css");
      Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-0.11.1.min.css");
      console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.11.1.min.css");
      Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.11.1.min.css");
    }
  ];

  function run_inline_js() {
    for (var i = 0; i < inline_js.length; i++) {
      inline_js[i](window.Bokeh);
    }
  }

  if (window._bokeh_is_loading === 0) {
    console.log("Bokeh: BokehJS loaded, going straight to plotting");
    run_inline_js();
  } else {
    load_libs(js_urls, function() {
      console.log("Bokeh: BokehJS plotting callback run at", now());
      run_inline_js();
    });
  }
}(this));